/* application-client.c generated by valac 0.56.17, the Vala compiler
 * generated from application-client.vala, do not modify */

/*
 * Copyright © 2016 Software Freedom Conservancy Inc.
 * Copyright © 2019-2021 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */
/* Defined by CMake build script.*/

#include "geary-client-46.0.h"
#include "geary-engine.h"
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <webkit2/webkit2.h>
#include <glib/gstdio.h>
#include <stdio.h>
#include <handy.h>
#include <gdk/gdk.h>

#define APPLICATION_CLIENT_OPTION_VERSION "version"
#define APPLICATION_CLIENT_OPTION_DEBUG "debug"
#define APPLICATION_CLIENT_OPTION_INSPECTOR "inspector"
#define APPLICATION_CLIENT_OPTION_LOG_CONVERSATIONS "log-conversations"
#define APPLICATION_CLIENT_OPTION_LOG_DESERIALIZER "log-deserializer"
#define APPLICATION_CLIENT_OPTION_LOG_FOLDER_NORM "log-folder-normalization"
#define APPLICATION_CLIENT_OPTION_LOG_IMAP "log-imap"
#define APPLICATION_CLIENT_OPTION_LOG_REPLAY_QUEUE "log-replay-queue"
#define APPLICATION_CLIENT_OPTION_LOG_SMTP "log-smtp"
#define APPLICATION_CLIENT_OPTION_LOG_SQL "log-sql"
#define APPLICATION_CLIENT_OPTION_NEW_WINDOW "new-window"
#define APPLICATION_CLIENT_OPTION_QUIT "quit"
#define APPLICATION_CLIENT_OPTION_REVOKE_CERTS "revoke-certs"
#define APPLICATION_CLIENT_MAILTO_URI_SCHEME_PREFIX "mailto:"
#define APPLICATION_CLIENT_USEC_PER_SEC ((gint64) 1000000)
#define APPLICATION_CLIENT_FORCE_SHUTDOWN_USEC (5 * APPLICATION_CLIENT_USEC_PER_SEC)
#define APPLICATION_CLIENT_ERROR_NOTIFICATION_ID "error"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define APPLICATION_TYPE_CONTROLLER (application_controller_get_type ())
#define APPLICATION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationController))
#define APPLICATION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))
#define APPLICATION_IS_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_IS_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_CONTROLLER))
#define APPLICATION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_CONTROLLER, ApplicationControllerClass))

typedef struct _ApplicationController ApplicationController;
typedef struct _ApplicationControllerClass ApplicationControllerClass;
enum  {
	APPLICATION_CLIENT_0_PROPERTY,
	APPLICATION_CLIENT_ENGINE_PROPERTY,
	APPLICATION_CLIENT_CONFIG_PROPERTY,
	APPLICATION_CLIENT_LAST_ACTIVE_MAIN_WINDOW_PROPERTY,
	APPLICATION_CLIENT_AUTOSTART_PROPERTY,
	APPLICATION_CLIENT_IS_BACKGROUND_SERVICE_PROPERTY,
	APPLICATION_CLIENT_IS_FLATPAK_SANDBOXED_PROPERTY,
	APPLICATION_CLIENT_CONTROLLER_PROPERTY,
	APPLICATION_CLIENT_IS_INSTALLED_PROPERTY,
	APPLICATION_CLIENT_INSTALL_PREFIX_PROPERTY,
	APPLICATION_CLIENT_NUM_PROPERTIES
};
static GParamSpec* application_client_properties[APPLICATION_CLIENT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block5Data Block5Data;
typedef struct _ApplicationClientShowAboutData ApplicationClientShowAboutData;
typedef struct _ApplicationClientShowAccountsData ApplicationClientShowAccountsData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define APPLICATION_TYPE_EMAIL_STORE_FACTORY (application_email_store_factory_get_type ())
#define APPLICATION_EMAIL_STORE_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_EMAIL_STORE_FACTORY, ApplicationEmailStoreFactory))
#define APPLICATION_EMAIL_STORE_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_EMAIL_STORE_FACTORY, ApplicationEmailStoreFactoryClass))
#define APPLICATION_IS_EMAIL_STORE_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_EMAIL_STORE_FACTORY))
#define APPLICATION_IS_EMAIL_STORE_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_EMAIL_STORE_FACTORY))
#define APPLICATION_EMAIL_STORE_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_EMAIL_STORE_FACTORY, ApplicationEmailStoreFactoryClass))

typedef struct _ApplicationEmailStoreFactory ApplicationEmailStoreFactory;
typedef struct _ApplicationEmailStoreFactoryClass ApplicationEmailStoreFactoryClass;

#define APPLICATION_PLUGIN_MANAGER_TYPE_PLUGIN_GLOBALS (application_plugin_manager_plugin_globals_get_type ())
#define APPLICATION_PLUGIN_MANAGER_PLUGIN_GLOBALS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_PLUGIN_MANAGER_TYPE_PLUGIN_GLOBALS, ApplicationPluginManagerPluginGlobals))
#define APPLICATION_PLUGIN_MANAGER_PLUGIN_GLOBALS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_PLUGIN_MANAGER_TYPE_PLUGIN_GLOBALS, ApplicationPluginManagerPluginGlobalsClass))
#define APPLICATION_PLUGIN_MANAGER_IS_PLUGIN_GLOBALS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_PLUGIN_MANAGER_TYPE_PLUGIN_GLOBALS))
#define APPLICATION_PLUGIN_MANAGER_IS_PLUGIN_GLOBALS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_PLUGIN_MANAGER_TYPE_PLUGIN_GLOBALS))
#define APPLICATION_PLUGIN_MANAGER_PLUGIN_GLOBALS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_PLUGIN_MANAGER_TYPE_PLUGIN_GLOBALS, ApplicationPluginManagerPluginGlobalsClass))

typedef struct _ApplicationPluginManagerPluginGlobals ApplicationPluginManagerPluginGlobals;
typedef struct _ApplicationPluginManagerPluginGlobalsClass ApplicationPluginManagerPluginGlobalsClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ApplicationClientShowEmailData ApplicationClientShowEmailData;

#define APPLICATION_TYPE_FOLDER_STORE_FACTORY (application_folder_store_factory_get_type ())
#define APPLICATION_FOLDER_STORE_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_FOLDER_STORE_FACTORY, ApplicationFolderStoreFactory))
#define APPLICATION_FOLDER_STORE_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), APPLICATION_TYPE_FOLDER_STORE_FACTORY, ApplicationFolderStoreFactoryClass))
#define APPLICATION_IS_FOLDER_STORE_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_FOLDER_STORE_FACTORY))
#define APPLICATION_IS_FOLDER_STORE_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), APPLICATION_TYPE_FOLDER_STORE_FACTORY))
#define APPLICATION_FOLDER_STORE_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), APPLICATION_TYPE_FOLDER_STORE_FACTORY, ApplicationFolderStoreFactoryClass))

typedef struct _ApplicationFolderStoreFactory ApplicationFolderStoreFactory;
typedef struct _ApplicationFolderStoreFactoryClass ApplicationFolderStoreFactoryClass;
typedef struct _ApplicationClientShowFolderData ApplicationClientShowFolderData;
typedef struct _ApplicationClientShowInspectorData ApplicationClientShowInspectorData;
typedef struct _ApplicationClientShowPreferencesData ApplicationClientShowPreferencesData;

#define APPLICATION_TYPE_ACCOUNT_INTERFACE (application_account_interface_get_type ())
#define APPLICATION_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface))
#define APPLICATION_IS_ACCOUNT_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE))
#define APPLICATION_ACCOUNT_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterfaceIface))

typedef struct _ApplicationAccountInterface ApplicationAccountInterface;
typedef struct _ApplicationAccountInterfaceIface ApplicationAccountInterfaceIface;
typedef struct _ApplicationClientNewComposerData ApplicationClientNewComposerData;
typedef struct _ApplicationClientNewComposerMailtoData ApplicationClientNewComposerMailtoData;
typedef struct _ApplicationClientNewWindowData ApplicationClientNewWindowData;

#define COMPOSER_TYPE_APPLICATION_INTERFACE (composer_application_interface_get_type ())
#define COMPOSER_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface))
#define COMPOSER_IS_APPLICATION_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE))
#define COMPOSER_APPLICATION_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterfaceIface))

typedef struct _ComposerApplicationInterface ComposerApplicationInterface;
typedef struct _ComposerApplicationInterfaceIface ComposerApplicationInterfaceIface;
typedef struct _ApplicationClientShowUriData ApplicationClientShowUriData;
typedef struct _ApplicationClientPresentData ApplicationClientPresentData;
typedef struct _ApplicationClientCreateControllerData ApplicationClientCreateControllerData;
typedef struct _ApplicationClientDestroyControllerData ApplicationClientDestroyControllerData;
#define _g_variant_dict_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_dict_unref (var), NULL)))
typedef struct _Block6Data Block6Data;

struct _ApplicationClientPrivate {
	GearyEngine* _engine;
	ApplicationConfiguration* _config;
	ApplicationMainWindow* _last_active_main_window;
	ApplicationStartupManager* _autostart;
	gboolean _is_flatpak_sandboxed;
	ApplicationController* _controller;
	GFile* _install_prefix;
	GFile* exec_dir;
	gchar* binary;
	GtkCssProvider* single_key_shortcuts;
	GCancellable* controller_cancellable;
	ComponentsInspector* inspector;
	GearyNonblockingMutex* controller_mutex;
	GNotification* error_notification;
};

struct _Block5Data {
	int _ref_count_;
	ApplicationClient* self;
	gboolean controller_closed;
};

struct _ApplicationClientShowAboutData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkWindow* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
};

struct _ApplicationClientShowAccountsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	AccountsEditor* editor;
	ApplicationMainWindow* _tmp2_;
	ApplicationMainWindow* _tmp3_;
	AccountsEditor* _tmp4_;
	AccountsEditor* _tmp5_;
	ApplicationController* _tmp6_;
};

struct _ApplicationClientShowEmailData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	GVariant* id;
	ApplicationMainWindow* main;
	ApplicationMainWindow* _tmp0_;
	ApplicationEmailStoreFactory* email;
	ApplicationController* _tmp1_;
	ApplicationPluginManager* _tmp2_;
	ApplicationPluginManager* _tmp3_;
	ApplicationPluginManagerPluginGlobals* _tmp4_;
	ApplicationPluginManagerPluginGlobals* _tmp5_;
	ApplicationEmailStoreFactory* _tmp6_;
	ApplicationEmailStoreFactory* _tmp7_;
	ApplicationEmailStoreFactory* _tmp8_;
	ApplicationAccountContext* context;
	ApplicationEmailStoreFactory* _tmp9_;
	ApplicationAccountContext* _tmp10_;
	GearyEmailIdentifier* email_id;
	ApplicationEmailStoreFactory* _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	gboolean _tmp13_;
	ApplicationAccountContext* _tmp14_;
	GearyEmailIdentifier* _tmp15_;
	GeeMultiMap* folders;
	GeeMultiMap* _tmp16_;
	ApplicationAccountContext* _tmp17_;
	GearyAccount* _tmp18_;
	GearyAccount* _tmp19_;
	GearyEmailIdentifier* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
	ApplicationAccountContext* _tmp23_;
	GCancellable* _tmp24_;
	GCancellable* _tmp25_;
	GeeMultiMap* _tmp26_;
	GeeMultiMap* _tmp27_;
	GeeMultiMap* _tmp28_;
	GError* err;
	GError* _tmp29_;
	const gchar* _tmp30_;
	GeeMultiMap* _tmp31_;
	GeeCollection* paths;
	GeeMultiMap* _tmp32_;
	GearyEmailIdentifier* _tmp33_;
	GeeCollection* _tmp34_;
	GearyFolder* selected;
	ApplicationMainWindow* _tmp35_;
	GearyFolder* _tmp36_;
	GearyFolder* _tmp37_;
	GearyFolder* _tmp38_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	GearyFolder* _tmp41_;
	GearyFolder* _tmp42_;
	GearyAccount* _tmp43_;
	GearyAccount* _tmp44_;
	ApplicationAccountContext* _tmp45_;
	GearyAccount* _tmp46_;
	GearyAccount* _tmp47_;
	GeeCollection* _tmp48_;
	GearyFolder* _tmp49_;
	GearyFolderPath* _tmp50_;
	GearyFolderPath* _tmp51_;
	GeeIterator* _path_it;
	GeeCollection* _tmp52_;
	GeeIterator* _tmp53_;
	GeeIterator* _tmp54_;
	GearyFolderPath* path;
	GeeIterator* _tmp55_;
	gpointer _tmp56_;
	GearyFolder* folder;
	ApplicationAccountContext* _tmp57_;
	GearyAccount* _tmp58_;
	GearyAccount* _tmp59_;
	GearyFolderPath* _tmp60_;
	GearyFolder* _tmp61_;
	GearyFolder* _tmp62_;
	GearyFolderSpecialUse _tmp63_;
	GearyFolderSpecialUse _tmp64_;
	GearyFolder* _tmp65_;
	GearyFolder* _tmp66_;
	GError* _vala1_err;
	GError* _tmp67_;
	const gchar* _tmp68_;
	gboolean _tmp69_;
	GearyFolder* _tmp70_;
	GeeCollection* _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	GearyFolder* _tmp74_;
	ApplicationAccountContext* _tmp75_;
	GearyAccount* _tmp76_;
	GearyAccount* _tmp77_;
	GeeCollection* _tmp78_;
	gpointer _tmp79_;
	GearyFolderPath* _tmp80_;
	GearyFolder* _tmp81_;
	GearyFolder* _tmp82_;
	GearyFolder* _tmp83_;
	GError* _vala2_err;
	GError* _tmp84_;
	const gchar* _tmp85_;
	GearyFolder* _tmp86_;
	ApplicationMainWindow* _tmp87_;
	GearyFolder* _tmp88_;
	GearyEmailIdentifier* _tmp89_;
	GeeCollection* _tmp90_;
	GeeCollection* _tmp91_;
	GError* _inner_error0_;
};

struct _ApplicationClientShowFolderData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	GVariant* id;
	ApplicationMainWindow* main;
	ApplicationMainWindow* _tmp0_;
	GearyFolder* folder;
	ApplicationController* _tmp1_;
	ApplicationPluginManager* _tmp2_;
	ApplicationPluginManager* _tmp3_;
	ApplicationPluginManagerPluginGlobals* _tmp4_;
	ApplicationPluginManagerPluginGlobals* _tmp5_;
	ApplicationFolderStoreFactory* _tmp6_;
	ApplicationFolderStoreFactory* _tmp7_;
	GearyFolder* _tmp8_;
	GearyFolder* _tmp9_;
	ApplicationMainWindow* _tmp10_;
	GearyFolder* _tmp11_;
};

struct _ApplicationClientShowInspectorData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ComponentsInspector* _tmp2_;
	ComponentsInspector* _tmp3_;
	ComponentsInspector* _tmp4_;
	GtkWindowGroup* group;
	GtkWindowGroup* _tmp5_;
	GtkWindowGroup* _tmp6_;
	ComponentsInspector* _tmp7_;
	ComponentsInspector* _tmp8_;
	ComponentsInspector* _tmp9_;
};

struct _ApplicationClientShowPreferencesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ComponentsPreferencesWindow* prefs;
	ApplicationMainWindow* _tmp2_;
	ApplicationMainWindow* _tmp3_;
	ApplicationController* _tmp4_;
	ApplicationPluginManager* _tmp5_;
	ApplicationPluginManager* _tmp6_;
	ComponentsPreferencesWindow* _tmp7_;
	ComponentsPreferencesWindow* _tmp8_;
};

struct _ApplicationAccountInterfaceIface {
	GTypeInterface parent_iface;
	ApplicationAccountContext* (*get_context_for_account) (ApplicationAccountInterface* self, GearyAccountInformation* account);
	GeeCollection* (*get_account_contexts) (ApplicationAccountInterface* self);
};

struct _ApplicationClientNewComposerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	GearyRFC822MailboxAddress* to;
	ApplicationMainWindow* main;
	ApplicationMainWindow* _tmp0_;
	ApplicationAccountContext* account;
	ApplicationMainWindow* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccount* _tmp3_;
	ApplicationController* _tmp4_;
	ApplicationMainWindow* _tmp5_;
	GearyAccount* _tmp6_;
	GearyAccount* _tmp7_;
	GearyAccountInformation* _tmp8_;
	GearyAccountInformation* _tmp9_;
	ApplicationAccountContext* _tmp10_;
	ApplicationAccountContext* _tmp11_;
	ApplicationController* _tmp12_;
	GeeCollection* _tmp13_;
	GeeCollection* _tmp14_;
	gpointer _tmp15_;
	ApplicationAccountContext* _tmp16_;
	ComposerWidget* composer;
	ApplicationController* _tmp17_;
	ApplicationAccountContext* _tmp18_;
	ComposerWidget* _tmp19_;
	ApplicationController* _tmp20_;
	ComposerWidget* _tmp21_;
};

struct _ApplicationClientNewComposerMailtoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	gchar* mailto;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationController* _tmp2_;
};

struct _ApplicationClientNewWindowData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	GearyFolder* select_folder;
	GeeCollection* select_conversations;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean do_select;
	ApplicationMainWindow* main;
	ApplicationMainWindow* _tmp4_;
	ApplicationMainWindow* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	ApplicationMainWindow* _tmp9_;
	ApplicationMainWindow* _tmp10_;
};

struct _ComposerApplicationInterfaceIface {
	GTypeInterface parent_iface;
	void (*report_problem) (ComposerApplicationInterface* self, GearyProblemReport* report);
	void (*send_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*send_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*save_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*save_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
	void (*discard_composed_email) (ComposerApplicationInterface* self, ComposerWidget* composer, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*discard_composed_email_finish) (ComposerApplicationInterface* self, GAsyncResult* _res_);
};

struct _ApplicationClientShowUriData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	gchar* uri;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gchar* uri_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkWindow* _tmp5_;
	const gchar* _tmp6_;
	GError* err;
	ApplicationController* _tmp7_;
	GError* _tmp8_;
	GearyProblemReport* _tmp9_;
	GearyProblemReport* _tmp10_;
	GError* _inner_error0_;
};

struct _ApplicationClientPresentData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	ApplicationMainWindow* result;
	ApplicationMainWindow* main;
	ApplicationMainWindow* _tmp0_;
};

struct _ApplicationClientCreateControllerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	gboolean first_run;
	gboolean open_failed;
	gint mutex_token;
	gint _tmp0_;
	GearyNonblockingMutex* _tmp1_;
	ApplicationController* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GFile* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	ApplicationController* _tmp13_;
	GCancellable* _tmp14_;
	ApplicationController* _tmp15_;
	GearyEngine* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GError* err;
	GError* _tmp19_;
	const gchar* _tmp20_;
	DialogsProblemDetailsDialog* dialog;
	GError* _tmp21_;
	GearyProblemReport* _tmp22_;
	GearyProblemReport* _tmp23_;
	DialogsProblemDetailsDialog* _tmp24_;
	DialogsProblemDetailsDialog* _tmp25_;
	DialogsProblemDetailsDialog* _tmp26_;
	GearyNonblockingMutex* _tmp27_;
	GError* _error_;
	GError* _tmp28_;
	const gchar* _tmp29_;
	GearyEngine* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	GError* _inner_error0_;
};

struct _ApplicationClientDestroyControllerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ApplicationClient* self;
	gint mutex_token;
	GearyNonblockingMutex* _tmp0_;
	ApplicationController* _tmp1_;
	ApplicationController* _tmp2_;
	GearyNonblockingMutex* _tmp3_;
	GError* err;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GearyEngine* _tmp6_;
	GError* _error_;
	GError* _tmp7_;
	const gchar* _tmp8_;
	GError* _inner_error0_;
};

struct _Block6Data {
	int _ref_count_;
	ApplicationClient* self;
	GtkDialog* dialog;
};

static gint ApplicationClient_private_offset;
static gpointer application_client_parent_class = NULL;

VALA_EXTERN GType application_controller_get_type (void) G_GNUC_CONST ;
static void application_client_on_activate_about (ApplicationClient* self);
static void _application_client_on_activate_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void application_client_on_activate_accounts (ApplicationClient* self);
static void _application_client_on_activate_accounts_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void application_client_on_activate_compose (ApplicationClient* self);
static void _application_client_on_activate_compose_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void application_client_on_activate_help (ApplicationClient* self);
static void _application_client_on_activate_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void application_client_on_activate_inspect (ApplicationClient* self);
static void _application_client_on_activate_inspect_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
static void application_client_on_activate_mailto (ApplicationClient* self,
                                            GSimpleAction* action,
                                            GVariant* param);
static void _application_client_on_activate_mailto_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void application_client_on_activate_new_window (ApplicationClient* self);
static void _application_client_on_activate_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_client_on_activate_preferences (ApplicationClient* self);
static void _application_client_on_activate_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void application_client_on_activate_quit (ApplicationClient* self);
static void _application_client_on_activate_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void application_client_on_activate_show_email (ApplicationClient* self,
                                                GSimpleAction* action,
                                                GVariant* target);
static void _application_client_on_activate_show_email_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void application_client_on_activate_show_folder (ApplicationClient* self,
                                                 GSimpleAction* action,
                                                 GVariant* target);
static void _application_client_on_activate_show_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void application_client_set_engine (ApplicationClient* self,
                                    GearyEngine* value);
static void application_client_set_config (ApplicationClient* self,
                                    ApplicationConfiguration* value);
static void application_client_set_last_active_main_window (ApplicationClient* self,
                                                     ApplicationMainWindow* value);
static void application_client_set_autostart (ApplicationClient* self,
                                       ApplicationStartupManager* value);
static void application_client_set_is_flatpak_sandboxed (ApplicationClient* self,
                                                  gboolean value);
VALA_EXTERN ApplicationController* application_client_get_controller (ApplicationClient* self);
static void application_client_set_controller (ApplicationClient* self,
                                        ApplicationController* value);
VALA_EXTERN gboolean application_client_get_is_installed (ApplicationClient* self);
VALA_EXTERN GFile* application_client_get_install_prefix (ApplicationClient* self);
static void application_client_set_install_prefix (ApplicationClient* self,
                                            GFile* value);
static void application_client_on_window_removed (ApplicationClient* self,
                                           GtkWindow* window);
static void _application_client_on_window_removed_gtk_application_window_removed (GtkApplication* _sender,
                                                                           GtkWindow* window,
                                                                           gpointer self);
static gboolean application_client_real_local_command_line (GApplication* base,
                                                     gchar*** args,
                                                     gint* exit_status);
static gint application_client_real_handle_local_options (GApplication* base,
                                                   GVariantDict* options);
static void application_client_real_startup (GApplication* base);
VALA_EXTERN void util_i18n_init (const gchar* package_name,
                     const gchar* program_path,
                     const gchar* locale);
static void application_client_add_app_accelerators (ApplicationClient* self,
                                              const gchar* action,
                                              gchar** accelerators,
                                              gint accelerators_length1,
                                              GVariant* param);
static void application_client_load_css (ApplicationClient* self,
                                  GtkCssProvider* provider,
                                  const gchar* resource_uri);
static void application_client_update_single_key_shortcuts (ApplicationClient* self);
static void application_client_on_single_key_shortcuts_toggled (ApplicationClient* self);
static void _application_client_on_single_key_shortcuts_toggled_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self);
static void application_client_create_controller (ApplicationClient* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void application_client_create_controller_finish (ApplicationClient* self,
                                                  GAsyncResult* _res_);
static gint application_client_real_command_line (GApplication* base,
                                           GApplicationCommandLine* command_line);
static gint application_client_handle_general_options (ApplicationClient* self,
                                                GApplicationCommandLine* command_line);
static void application_client_real_shutdown (GApplication* base);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void application_client_destroy_controller (ApplicationClient* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void application_client_destroy_controller_finish (ApplicationClient* self,
                                                   GAsyncResult* _res_);
static void __lambda165_ (Block5Data* _data5_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda165__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void util_date_terminate (void);
static void application_client_real_activate (GApplication* base);
static void application_client_present (ApplicationClient* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static ApplicationMainWindow* application_client_present_finish (ApplicationClient* self,
                                                          GAsyncResult* _res_);
static void application_client_real_open (GApplication* base,
                                   GFile** targets,
                                   gint targets_length1,
                                   const gchar* hint);
static ApplicationMainWindow* application_client_new_main_window (ApplicationClient* self,
                                                           gboolean select_first_inbox);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void application_client_show_about_data_free (gpointer _data);
static gboolean application_client_show_about_co (ApplicationClientShowAboutData* _data_);
static void application_client_show_about_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void application_client_show_accounts_data_free (gpointer _data);
static gboolean application_client_show_accounts_co (ApplicationClientShowAccountsData* _data_);
static void application_client_show_accounts_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
VALA_EXTERN void application_controller_expunge_accounts (ApplicationController* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
VALA_EXTERN void application_controller_expunge_accounts_finish (ApplicationController* self,
                                                     GAsyncResult* _res_);
static void application_client_show_email_data_free (gpointer _data);
static gboolean application_client_show_email_co (ApplicationClientShowEmailData* _data_);
static void application_client_show_email_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
VALA_EXTERN GType application_email_store_factory_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ApplicationPluginManager* application_controller_get_plugins (ApplicationController* self);
VALA_EXTERN gpointer application_plugin_manager_plugin_globals_ref (gpointer instance);
VALA_EXTERN void application_plugin_manager_plugin_globals_unref (gpointer instance);
VALA_EXTERN GParamSpec* application_plugin_manager_param_spec_plugin_globals (const gchar* name,
                                                                  const gchar* nick,
                                                                  const gchar* blurb,
                                                                  GType object_type,
                                                                  GParamFlags flags);
VALA_EXTERN void application_plugin_manager_value_set_plugin_globals (GValue* value,
                                                          gpointer v_object);
VALA_EXTERN void application_plugin_manager_value_take_plugin_globals (GValue* value,
                                                           gpointer v_object);
VALA_EXTERN gpointer application_plugin_manager_value_get_plugin_globals (const GValue* value);
VALA_EXTERN GType application_plugin_manager_plugin_globals_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ApplicationPluginManagerPluginGlobals* application_plugin_manager_get_globals (ApplicationPluginManager* self);
VALA_EXTERN ApplicationEmailStoreFactory* application_plugin_manager_plugin_globals_get_email (ApplicationPluginManagerPluginGlobals* self);
VALA_EXTERN ApplicationAccountContext* application_email_store_factory_get_account_for_variant (ApplicationEmailStoreFactory* self,
                                                                                    GVariant* target);
VALA_EXTERN GearyEmailIdentifier* application_email_store_factory_get_email_identifier_for_variant (ApplicationEmailStoreFactory* self,
                                                                                        GVariant* target);
static void application_client_show_folder_data_free (gpointer _data);
static gboolean application_client_show_folder_co (ApplicationClientShowFolderData* _data_);
static void application_client_show_folder_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN GType application_folder_store_factory_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ApplicationFolderStoreFactory* application_plugin_manager_plugin_globals_get_folders (ApplicationPluginManagerPluginGlobals* self);
VALA_EXTERN GearyFolder* application_folder_store_factory_get_folder_for_variant (ApplicationFolderStoreFactory* self,
                                                                      GVariant* target);
static void application_client_show_inspector_data_free (gpointer _data);
static gboolean application_client_show_inspector_co (ApplicationClientShowInspectorData* _data_);
static void application_client_show_inspector_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void ___lambda160_ (ApplicationClient* self);
static void ____lambda160__gtk_widget_destroy (GtkWidget* _sender,
                                        gpointer self);
static void application_client_show_preferences_data_free (gpointer _data);
static gboolean application_client_show_preferences_co (ApplicationClientShowPreferencesData* _data_);
static void application_client_show_preferences_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void application_client_new_composer_data_free (gpointer _data);
static gboolean application_client_new_composer_co (ApplicationClientNewComposerData* _data_);
static void application_client_new_composer_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
VALA_EXTERN GType application_account_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ApplicationAccountContext* application_account_interface_get_context_for_account (ApplicationAccountInterface* self,
                                                                                  GearyAccountInformation* account);
VALA_EXTERN GeeCollection* application_account_interface_get_account_contexts (ApplicationAccountInterface* self);
VALA_EXTERN void application_controller_compose_blank (ApplicationController* self,
                                           ApplicationAccountContext* send_context,
                                           GearyRFC822MailboxAddress* to,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN ComposerWidget* application_controller_compose_blank_finish (ApplicationController* self,
                                                             GAsyncResult* _res_);
VALA_EXTERN void application_controller_present_composer (ApplicationController* self,
                                              ComposerWidget* composer);
static void application_client_new_composer_mailto_data_free (gpointer _data);
static gboolean application_client_new_composer_mailto_co (ApplicationClientNewComposerMailtoData* _data_);
static void application_client_new_composer_mailto_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_);
VALA_EXTERN void application_controller_compose_mailto (ApplicationController* self,
                                            const gchar* mailto,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void application_controller_compose_mailto_finish (ApplicationController* self,
                                                   GAsyncResult* _res_);
static void application_client_new_window_data_free (gpointer _data);
static gboolean application_client_new_window_co (ApplicationClientNewWindowData* _data_);
static void application_client_new_window_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static gchar* application_client_get_geary_home_dir_name (ApplicationClient* self);
static void application_client_show_uri_data_free (gpointer _data);
static gboolean application_client_show_uri_co (ApplicationClientShowUriData* _data_);
static void application_client_show_uri_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
VALA_EXTERN GType composer_application_interface_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void composer_application_interface_report_problem (ComposerApplicationInterface* self,
                                                    GearyProblemReport* report);
VALA_EXTERN gboolean application_controller_check_open_composers (ApplicationController* self);
VALA_EXTERN GFile** application_client_get_config_search_path (ApplicationClient* self,
                                                   gint* result_length1);
static void _vala_array_add3 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
static void _vala_array_add4 (GFile** * array,
                       gint* length,
                       gint* size,
                       GFile* value);
VALA_EXTERN void application_client_send_error_notification (ApplicationClient* self,
                                                 const gchar* summary,
                                                 const gchar* body);
VALA_EXTERN void application_client_clear_error_notification (ApplicationClient* self);
static void application_client_present_data_free (gpointer _data);
static gboolean application_client_present_co (ApplicationClientPresentData* _data_);
static void application_client_present_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_);
VALA_EXTERN ApplicationMainWindow* application_main_window_new (ApplicationClient* application);
VALA_EXTERN ApplicationMainWindow* application_main_window_construct (GType object_type,
                                                          ApplicationClient* application);
VALA_EXTERN void application_controller_register_window (ApplicationController* self,
                                             ApplicationMainWindow* window);
static gboolean application_client_on_main_window_focus_in (ApplicationClient* self,
                                                     GtkWidget* widget,
                                                     GdkEventFocus* event);
static gboolean _application_client_on_main_window_focus_in_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                                GdkEventFocus* event,
                                                                                gpointer self);
VALA_EXTERN gboolean application_main_window_select_first_inbox (ApplicationMainWindow* self,
                                                     gboolean is_interactive);
static void application_client_on_folders_first_available (ApplicationClient* self,
                                                    GearyAccount* account,
                                                    GeeBidirSortedSet* available,
                                                    GeeBidirSortedSet* unavailable);
static void _application_client_on_folders_first_available_geary_account_folders_available_unavailable (GearyAccount* _sender,
                                                                                                 GeeBidirSortedSet* available,
                                                                                                 GeeBidirSortedSet* unavailable,
                                                                                                 gpointer self);
static void application_client_create_controller_data_free (gpointer _data);
static gboolean application_client_create_controller_co (ApplicationClientCreateControllerData* _data_);
static void application_client_create_controller_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
VALA_EXTERN void application_controller_new (ApplicationClient* application,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
VALA_EXTERN ApplicationController* application_controller_new_finish (GAsyncResult* _res_,
                                                          GError** error);
VALA_EXTERN void application_controller_construct (GType object_type,
                                       ApplicationClient* application,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
VALA_EXTERN ApplicationController* application_controller_construct_finish (GAsyncResult* _res_,
                                                                GError** error);
static void application_client_destroy_controller_data_free (gpointer _data);
static gboolean application_client_destroy_controller_co (ApplicationClientDestroyControllerData* _data_);
static void application_client_destroy_controller_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN void application_controller_close (ApplicationController* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void application_controller_close_finish (ApplicationController* self,
                                          GAsyncResult* _res_);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static void application_client_on_css_parse_error (ApplicationClient* self,
                                            GtkCssSection* section,
                                            GError* _error_);
static void _application_client_on_css_parse_error_gtk_css_provider_parsing_error (GtkCssProvider* _sender,
                                                                            GtkCssSection* section,
                                                                            GError* _error_,
                                                                            gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void ___lambda159_ (Block6Data* _data6_);
static void ____lambda159__gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self);
VALA_EXTERN void application_controller_unregister_window (ApplicationController* self,
                                               ApplicationMainWindow* window);
static void application_client_finalize (GObject * obj);
static GType application_client_get_type_once (void);
static void _vala_application_client_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_application_client_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

const gchar* APPLICATION_CLIENT_AUTHORS[8] = {"Jim Nelson <jim@yorba.org>", "Eric Gregory <eric@yorba.org>", "Nate Lillich <nate@yorba.org>", "Matthew Pirocchi <matthew@yorba.org>", "Charles Lindsay <chaz@yorba.org>", "Robert Schroll <rschroll@gmail.com>", "Michael Gratton <mike@vee.net>", NULL};
static const GActionEntry APPLICATION_CLIENT_ACTION_ENTRIES[11] = {{ACTION_APPLICATION_ABOUT, _application_client_on_activate_about_gsimple_action_activate_callback}, {ACTION_APPLICATION_ACCOUNTS, _application_client_on_activate_accounts_gsimple_action_activate_callback}, {ACTION_APPLICATION_COMPOSE, _application_client_on_activate_compose_gsimple_action_activate_callback}, {ACTION_APPLICATION_HELP, _application_client_on_activate_help_gsimple_action_activate_callback}, {ACTION_APPLICATION_INSPECT, _application_client_on_activate_inspect_gsimple_action_activate_callback}, {ACTION_APPLICATION_MAILTO, _application_client_on_activate_mailto_gsimple_action_activate_callback, "s"}, {ACTION_APPLICATION_NEW_WINDOW, _application_client_on_activate_new_window_gsimple_action_activate_callback}, {ACTION_APPLICATION_PREFERENCES, _application_client_on_activate_preferences_gsimple_action_activate_callback}, {ACTION_APPLICATION_QUIT, _application_client_on_activate_quit_gsimple_action_activate_callback}, {ACTION_APPLICATION_SHOW_EMAIL, _application_client_on_activate_show_email_gsimple_action_activate_callback, "(sv)"}, {ACTION_APPLICATION_SHOW_FOLDER, _application_client_on_activate_show_folder_gsimple_action_activate_callback, "(sv)"}};
static const GOptionEntry APPLICATION_CLIENT_OPTION_ENTRIES[15] = {{APPLICATION_CLIENT_OPTION_DEBUG, 'd', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Print debug logging"), NULL}, {APPLICATION_CLIENT_OPTION_INSPECTOR, 'i', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Enable WebKitGTK Inspector in web views"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_CONVERSATIONS, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log conversation monitoring"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_DESERIALIZER, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log IMAP network deserialization"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_FOLDER_NORM, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log folder normalization"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_IMAP, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log IMAP network activity"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_REPLAY_QUEUE, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log IMAP replay queue"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_SMTP, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log SMTP network activity"), NULL}, {APPLICATION_CLIENT_OPTION_LOG_SQL, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Log database queries (generates lots of messages)"), NULL}, {APPLICATION_CLIENT_OPTION_QUIT, 'q', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Perform a graceful quit"), NULL}, {APPLICATION_CLIENT_OPTION_NEW_WINDOW, 'n', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Open a new window"), NULL}, {APPLICATION_CLIENT_OPTION_REVOKE_CERTS, (gchar) 0, (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Revoke all pinned TLS server certificates"), NULL}, {APPLICATION_CLIENT_OPTION_VERSION, 'v', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Display program version"), NULL}, {G_OPTION_REMAINING, (gchar) 0, (gint) 0, G_OPTION_ARG_STRING_ARRAY, NULL, NULL, "[mailto:[...]]"}, {NULL}};

static inline gpointer
application_client_get_instance_private (ApplicationClient* self)
{
	return G_STRUCT_MEMBER_P (self, ApplicationClient_private_offset);
}

static void
_application_client_on_activate_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_about ((ApplicationClient*) self);
#line 942 "application-client.c"
}

static void
_application_client_on_activate_accounts_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_accounts ((ApplicationClient*) self);
#line 952 "application-client.c"
}

static void
_application_client_on_activate_compose_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_compose ((ApplicationClient*) self);
#line 962 "application-client.c"
}

static void
_application_client_on_activate_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_help ((ApplicationClient*) self);
#line 972 "application-client.c"
}

static void
_application_client_on_activate_inspect_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_inspect ((ApplicationClient*) self);
#line 982 "application-client.c"
}

static void
_application_client_on_activate_mailto_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_mailto ((ApplicationClient*) self, action, parameter);
#line 992 "application-client.c"
}

static void
_application_client_on_activate_new_window_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_new_window ((ApplicationClient*) self);
#line 1002 "application-client.c"
}

static void
_application_client_on_activate_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_preferences ((ApplicationClient*) self);
#line 1012 "application-client.c"
}

static void
_application_client_on_activate_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_quit ((ApplicationClient*) self);
#line 1022 "application-client.c"
}

static void
_application_client_on_activate_show_email_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_show_email ((ApplicationClient*) self, action, parameter);
#line 1032 "application-client.c"
}

static void
_application_client_on_activate_show_folder_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 82 "../src/client/application/application-client.vala"
	application_client_on_activate_show_folder ((ApplicationClient*) self, action, parameter);
#line 1042 "application-client.c"
}

GearyEngine*
application_client_get_engine (ApplicationClient* self)
{
	GearyEngine* result;
	GearyEngine* _tmp0_;
#line 166 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 166 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_engine;
#line 166 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 166 "../src/client/application/application-client.vala"
	return result;
#line 1058 "application-client.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 166 "../src/client/application/application-client.vala"
	return self ? g_object_ref (self) : NULL;
#line 1066 "application-client.c"
}

static void
application_client_set_engine (ApplicationClient* self,
                               GearyEngine* value)
{
	GearyEngine* old_value;
#line 166 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 166 "../src/client/application/application-client.vala"
	old_value = application_client_get_engine (self);
#line 166 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 1080 "application-client.c"
		GearyEngine* _tmp0_;
#line 166 "../src/client/application/application-client.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 166 "../src/client/application/application-client.vala"
		_g_object_unref0 (self->priv->_engine);
#line 166 "../src/client/application/application-client.vala"
		self->priv->_engine = _tmp0_;
#line 166 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_ENGINE_PROPERTY]);
#line 1090 "application-client.c"
	}
}

ApplicationConfiguration*
application_client_get_config (ApplicationClient* self)
{
	ApplicationConfiguration* result;
	ApplicationConfiguration* _tmp0_;
#line 176 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 176 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_config;
#line 176 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 176 "../src/client/application/application-client.vala"
	return result;
#line 1107 "application-client.c"
}

static void
application_client_set_config (ApplicationClient* self,
                               ApplicationConfiguration* value)
{
	ApplicationConfiguration* old_value;
#line 176 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 176 "../src/client/application/application-client.vala"
	old_value = application_client_get_config (self);
#line 176 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 1121 "application-client.c"
		ApplicationConfiguration* _tmp0_;
#line 176 "../src/client/application/application-client.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 176 "../src/client/application/application-client.vala"
		_g_object_unref0 (self->priv->_config);
#line 176 "../src/client/application/application-client.vala"
		self->priv->_config = _tmp0_;
#line 176 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_CONFIG_PROPERTY]);
#line 1131 "application-client.c"
	}
}

ApplicationMainWindow*
application_client_get_last_active_main_window (ApplicationClient* self)
{
	ApplicationMainWindow* result;
	ApplicationMainWindow* _tmp0_;
#line 187 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 187 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_last_active_main_window;
#line 187 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 187 "../src/client/application/application-client.vala"
	return result;
#line 1148 "application-client.c"
}

static void
application_client_set_last_active_main_window (ApplicationClient* self,
                                                ApplicationMainWindow* value)
{
	ApplicationMainWindow* old_value;
#line 187 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 187 "../src/client/application/application-client.vala"
	old_value = application_client_get_last_active_main_window (self);
#line 187 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 1162 "application-client.c"
		ApplicationMainWindow* _tmp0_;
#line 187 "../src/client/application/application-client.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 187 "../src/client/application/application-client.vala"
		_g_object_unref0 (self->priv->_last_active_main_window);
#line 187 "../src/client/application/application-client.vala"
		self->priv->_last_active_main_window = _tmp0_;
#line 187 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_LAST_ACTIVE_MAIN_WINDOW_PROPERTY]);
#line 1172 "application-client.c"
	}
}

ApplicationStartupManager*
application_client_get_autostart (ApplicationClient* self)
{
	ApplicationStartupManager* result;
	ApplicationStartupManager* _tmp0_;
#line 197 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 197 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_autostart;
#line 197 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 197 "../src/client/application/application-client.vala"
	return result;
#line 1189 "application-client.c"
}

static void
application_client_set_autostart (ApplicationClient* self,
                                  ApplicationStartupManager* value)
{
	ApplicationStartupManager* old_value;
#line 197 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 197 "../src/client/application/application-client.vala"
	old_value = application_client_get_autostart (self);
#line 197 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 1203 "application-client.c"
		ApplicationStartupManager* _tmp0_;
#line 197 "../src/client/application/application-client.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 197 "../src/client/application/application-client.vala"
		_g_object_unref0 (self->priv->_autostart);
#line 197 "../src/client/application/application-client.vala"
		self->priv->_autostart = _tmp0_;
#line 197 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_AUTOSTART_PROPERTY]);
#line 1213 "application-client.c"
	}
}

gboolean
application_client_get_is_background_service (ApplicationClient* self)
{
	gboolean result;
	ApplicationConfiguration* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 208 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), FALSE);
#line 209 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_config;
#line 209 "../src/client/application/application-client.vala"
	_tmp1_ = application_configuration_get_run_in_background (_tmp0_);
#line 209 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 209 "../src/client/application/application-client.vala"
	result = _tmp2_;
#line 209 "../src/client/application/application-client.vala"
	return result;
#line 1236 "application-client.c"
}

gboolean
application_client_get_is_flatpak_sandboxed (ApplicationClient* self)
{
	gboolean result;
#line 219 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), FALSE);
#line 219 "../src/client/application/application-client.vala"
	result = self->priv->_is_flatpak_sandboxed;
#line 219 "../src/client/application/application-client.vala"
	return result;
#line 1249 "application-client.c"
}

static void
application_client_set_is_flatpak_sandboxed (ApplicationClient* self,
                                             gboolean value)
{
	gboolean old_value;
#line 219 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 219 "../src/client/application/application-client.vala"
	old_value = application_client_get_is_flatpak_sandboxed (self);
#line 219 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 219 "../src/client/application/application-client.vala"
		self->priv->_is_flatpak_sandboxed = value;
#line 219 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_IS_FLATPAK_SANDBOXED_PROPERTY]);
#line 1267 "application-client.c"
	}
}

ApplicationController*
application_client_get_controller (ApplicationClient* self)
{
	ApplicationController* result;
	ApplicationController* _tmp0_;
#line 229 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 229 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_controller;
#line 229 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 229 "../src/client/application/application-client.vala"
	return result;
#line 1284 "application-client.c"
}

static void
application_client_set_controller (ApplicationClient* self,
                                   ApplicationController* value)
{
	ApplicationController* old_value;
#line 229 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 229 "../src/client/application/application-client.vala"
	old_value = application_client_get_controller (self);
#line 229 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 1298 "application-client.c"
		ApplicationController* _tmp0_;
#line 229 "../src/client/application/application-client.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 229 "../src/client/application/application-client.vala"
		_g_object_unref0 (self->priv->_controller);
#line 229 "../src/client/application/application-client.vala"
		self->priv->_controller = _tmp0_;
#line 229 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_CONTROLLER_PROPERTY]);
#line 1308 "application-client.c"
	}
}

gboolean
application_client_get_is_installed (ApplicationClient* self)
{
	gboolean result;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 236 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), FALSE);
#line 237 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->exec_dir;
#line 237 "../src/client/application/application-client.vala"
	_tmp1_ = self->priv->_install_prefix;
#line 237 "../src/client/application/application-client.vala"
	result = g_file_has_prefix (_tmp0_, _tmp1_);
#line 237 "../src/client/application/application-client.vala"
	return result;
#line 1328 "application-client.c"
}

GFile*
application_client_get_install_prefix (ApplicationClient* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 243 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 243 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_install_prefix;
#line 243 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 243 "../src/client/application/application-client.vala"
	return result;
#line 1344 "application-client.c"
}

static void
application_client_set_install_prefix (ApplicationClient* self,
                                       GFile* value)
{
	GFile* old_value;
#line 243 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 243 "../src/client/application/application-client.vala"
	old_value = application_client_get_install_prefix (self);
#line 243 "../src/client/application/application-client.vala"
	if (old_value != value) {
#line 1358 "application-client.c"
		GFile* _tmp0_;
#line 243 "../src/client/application/application-client.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 243 "../src/client/application/application-client.vala"
		_g_object_unref0 (self->priv->_install_prefix);
#line 243 "../src/client/application/application-client.vala"
		self->priv->_install_prefix = _tmp0_;
#line 243 "../src/client/application/application-client.vala"
		g_object_notify_by_pspec ((GObject *) self, application_client_properties[APPLICATION_CLIENT_INSTALL_PREFIX_PROPERTY]);
#line 1368 "application-client.c"
	}
}

/**
     * Returns name/value pairs of application information.
     *
     * This includes Geary library version information, the current
     * desktop, and so on.
     */
GeeCollection*
application_client_get_runtime_information (ApplicationClient* self)
{
	GeeLinkedList* info = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	ApplicationClientRuntimeDetail _tmp2_ = {0};
	GeeLinkedList* _tmp3_;
	ApplicationClientRuntimeDetail _tmp4_ = {0};
	GeeLinkedList* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	ApplicationClientRuntimeDetail _tmp8_ = {0};
	GeeLinkedList* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	ApplicationClientRuntimeDetail _tmp12_ = {0};
	GeeLinkedList* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	ApplicationClientRuntimeDetail _tmp16_ = {0};
	const gchar* _tmp17_ = NULL;
	const gchar* _tmp18_;
	GeeLinkedList* _tmp19_;
	ApplicationClientRuntimeDetail _tmp20_ = {0};
	gchar* _tmp21_ = NULL;
	gchar* _tmp22_;
	GeeLinkedList* _tmp24_;
	ApplicationClientRuntimeDetail _tmp25_ = {0};
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_;
	GeeLinkedList* _tmp29_;
	ApplicationClientRuntimeDetail _tmp30_ = {0};
	GeeLinkedList* _tmp31_;
	ApplicationClientRuntimeDetail _tmp32_ = {0};
	GeeCollection* result;
#line 262 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 263 "../src/client/application/application-client.vala"
	_tmp0_ = gee_linked_list_new (APPLICATION_CLIENT_TYPE_RUNTIME_DETAIL, (GBoxedCopyFunc) application_client_runtime_detail_dup, (GDestroyNotify) application_client_runtime_detail_free, NULL, NULL, NULL);
#line 263 "../src/client/application/application-client.vala"
	info = _tmp0_;
#line 267 "../src/client/application/application-client.vala"
	_tmp1_ = info;
#line 267 "../src/client/application/application-client.vala"
	_g_free0 (_tmp2_.name);
#line 267 "../src/client/application/application-client.vala"
	_tmp2_.name = _ ("Geary version");
#line 267 "../src/client/application/application-client.vala"
	_g_free0 (_tmp2_.value);
#line 267 "../src/client/application/application-client.vala"
	_tmp2_.value = APPLICATION_CLIENT_VERSION;
#line 267 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp2_);
#line 269 "../src/client/application/application-client.vala"
	_tmp3_ = info;
#line 269 "../src/client/application/application-client.vala"
	_g_free0 (_tmp4_.name);
#line 269 "../src/client/application/application-client.vala"
	_tmp4_.name = _ ("Geary revision");
#line 269 "../src/client/application/application-client.vala"
	_g_free0 (_tmp4_.value);
#line 269 "../src/client/application/application-client.vala"
	_tmp4_.value = _REVNO;
#line 269 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp4_);
#line 271 "../src/client/application/application-client.vala"
	_tmp5_ = info;
#line 271 "../src/client/application/application-client.vala"
	_tmp6_ = g_strdup_printf ("%u.%u.%u", gtk_get_major_version (), gtk_get_minor_version (), gtk_get_micro_version ());
#line 271 "../src/client/application/application-client.vala"
	_tmp7_ = _tmp6_;
#line 271 "../src/client/application/application-client.vala"
	_g_free0 (_tmp8_.name);
#line 271 "../src/client/application/application-client.vala"
	_tmp8_.name = _ ("GTK version");
#line 271 "../src/client/application/application-client.vala"
	_g_free0 (_tmp8_.value);
#line 271 "../src/client/application/application-client.vala"
	_tmp8_.value = _tmp7_;
#line 271 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp8_);
#line 271 "../src/client/application/application-client.vala"
	_g_free0 (_tmp7_);
#line 278 "../src/client/application/application-client.vala"
	_tmp9_ = info;
#line 278 "../src/client/application/application-client.vala"
	_tmp10_ = g_strdup_printf ("%u.%u.%u", glib_major_version, glib_minor_version, glib_micro_version);
#line 278 "../src/client/application/application-client.vala"
	_tmp11_ = _tmp10_;
#line 278 "../src/client/application/application-client.vala"
	_g_free0 (_tmp12_.name);
#line 278 "../src/client/application/application-client.vala"
	_tmp12_.name = _ ("GLib version");
#line 278 "../src/client/application/application-client.vala"
	_g_free0 (_tmp12_.value);
#line 278 "../src/client/application/application-client.vala"
	_tmp12_.value = _tmp11_;
#line 278 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp12_);
#line 278 "../src/client/application/application-client.vala"
	_g_free0 (_tmp11_);
#line 285 "../src/client/application/application-client.vala"
	_tmp13_ = info;
#line 285 "../src/client/application/application-client.vala"
	_tmp14_ = g_strdup_printf ("%u.%u.%u", webkit_get_major_version (), webkit_get_minor_version (), webkit_get_micro_version ());
#line 285 "../src/client/application/application-client.vala"
	_tmp15_ = _tmp14_;
#line 285 "../src/client/application/application-client.vala"
	_g_free0 (_tmp16_.name);
#line 285 "../src/client/application/application-client.vala"
	_tmp16_.name = _ ("WebKitGTK version");
#line 285 "../src/client/application/application-client.vala"
	_g_free0 (_tmp16_.value);
#line 285 "../src/client/application/application-client.vala"
	_tmp16_.value = _tmp15_;
#line 285 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp16_);
#line 285 "../src/client/application/application-client.vala"
	_g_free0 (_tmp15_);
#line 293 "../src/client/application/application-client.vala"
	_tmp18_ = g_getenv ("XDG_CURRENT_DESKTOP");
#line 293 "../src/client/application/application-client.vala"
	_tmp17_ = _tmp18_;
#line 293 "../src/client/application/application-client.vala"
	if (_tmp17_ == NULL) {
#line 294 "../src/client/application/application-client.vala"
		_tmp17_ = _ ("Unknown");
#line 1506 "application-client.c"
	}
#line 292 "../src/client/application/application-client.vala"
	_tmp19_ = info;
#line 292 "../src/client/application/application-client.vala"
	_g_free0 (_tmp20_.name);
#line 292 "../src/client/application/application-client.vala"
	_tmp20_.name = _ ("Desktop environment");
#line 292 "../src/client/application/application-client.vala"
	_g_free0 (_tmp20_.value);
#line 292 "../src/client/application/application-client.vala"
	_tmp20_.value = _tmp17_;
#line 292 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp20_);
#line 299 "../src/client/application/application-client.vala"
	_tmp22_ = g_get_os_info (G_OS_INFO_KEY_NAME);
#line 299 "../src/client/application/application-client.vala"
	_tmp21_ = _tmp22_;
#line 299 "../src/client/application/application-client.vala"
	if (_tmp21_ == NULL) {
#line 1526 "application-client.c"
		gchar* _tmp23_;
#line 300 "../src/client/application/application-client.vala"
		_tmp23_ = g_strdup (_ ("Unknown"));
#line 300 "../src/client/application/application-client.vala"
		_g_free0 (_tmp21_);
#line 300 "../src/client/application/application-client.vala"
		_tmp21_ = _tmp23_;
#line 1534 "application-client.c"
	}
#line 298 "../src/client/application/application-client.vala"
	_tmp24_ = info;
#line 298 "../src/client/application/application-client.vala"
	_g_free0 (_tmp25_.name);
#line 298 "../src/client/application/application-client.vala"
	_tmp25_.name = _ ("Distribution name");
#line 298 "../src/client/application/application-client.vala"
	_g_free0 (_tmp25_.value);
#line 298 "../src/client/application/application-client.vala"
	_tmp25_.value = _tmp21_;
#line 298 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp25_);
#line 305 "../src/client/application/application-client.vala"
	_tmp27_ = g_get_os_info (G_OS_INFO_KEY_VERSION);
#line 305 "../src/client/application/application-client.vala"
	_tmp26_ = _tmp27_;
#line 305 "../src/client/application/application-client.vala"
	if (_tmp26_ == NULL) {
#line 1554 "application-client.c"
		gchar* _tmp28_;
#line 306 "../src/client/application/application-client.vala"
		_tmp28_ = g_strdup (_ ("Unknown"));
#line 306 "../src/client/application/application-client.vala"
		_g_free0 (_tmp26_);
#line 306 "../src/client/application/application-client.vala"
		_tmp26_ = _tmp28_;
#line 1562 "application-client.c"
	}
#line 304 "../src/client/application/application-client.vala"
	_tmp29_ = info;
#line 304 "../src/client/application/application-client.vala"
	_g_free0 (_tmp30_.name);
#line 304 "../src/client/application/application-client.vala"
	_tmp30_.name = _ ("Distribution release");
#line 304 "../src/client/application/application-client.vala"
	_g_free0 (_tmp30_.value);
#line 304 "../src/client/application/application-client.vala"
	_tmp30_.value = _tmp26_;
#line 304 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp30_);
#line 310 "../src/client/application/application-client.vala"
	_tmp31_ = info;
#line 310 "../src/client/application/application-client.vala"
	_g_free0 (_tmp32_.name);
#line 310 "../src/client/application/application-client.vala"
	_tmp32_.name = _ ("Installation prefix");
#line 310 "../src/client/application/application-client.vala"
	_g_free0 (_tmp32_.value);
#line 310 "../src/client/application/application-client.vala"
	_tmp32_.value = APPLICATION_CLIENT_INSTALL_PREFIX;
#line 310 "../src/client/application/application-client.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), &_tmp32_);
#line 312 "../src/client/application/application-client.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (info, GEE_TYPE_COLLECTION, GeeCollection);
#line 312 "../src/client/application/application-client.vala"
	_g_free0 (_tmp26_);
#line 312 "../src/client/application/application-client.vala"
	_g_free0 (_tmp21_);
#line 312 "../src/client/application/application-client.vala"
	return result;
#line 1596 "application-client.c"
}

static void
_application_client_on_window_removed_gtk_application_window_removed (GtkApplication* _sender,
                                                                      GtkWindow* window,
                                                                      gpointer self)
{
#line 326 "../src/client/application/application-client.vala"
	application_client_on_window_removed ((ApplicationClient*) self, window);
#line 1606 "application-client.c"
}

ApplicationClient*
application_client_construct (GType object_type)
{
	ApplicationClient * self = NULL;
#line 317 "../src/client/application/application-client.vala"
	self = (ApplicationClient*) g_object_new (object_type, "application-id", APPLICATION_CLIENT_APP_ID, "resource-base-path", APPLICATION_CLIENT_RESOURCE_BASE_PATH, "flags", G_APPLICATION_HANDLES_OPEN | G_APPLICATION_HANDLES_COMMAND_LINE, NULL);
#line 325 "../src/client/application/application-client.vala"
	g_application_add_main_option_entries (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication), APPLICATION_CLIENT_OPTION_ENTRIES);
#line 326 "../src/client/application/application-client.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), "window-removed", (GCallback) _application_client_on_window_removed_gtk_application_window_removed, self, G_CONNECT_AFTER);
#line 327 "../src/client/application/application-client.vala"
	application_client_set_is_flatpak_sandboxed (self, g_file_test ("/.flatpak-info", G_FILE_TEST_EXISTS));
#line 316 "../src/client/application/application-client.vala"
	return self;
#line 1623 "application-client.c"
}

ApplicationClient*
application_client_new (void)
{
#line 316 "../src/client/application/application-client.vala"
	return application_client_construct (APPLICATION_TYPE_CLIENT);
#line 1631 "application-client.c"
}

static gboolean
application_client_real_local_command_line (GApplication* base,
                                            gchar*** args,
                                            gint* exit_status)
{
	ApplicationClient * self;
	gint _vala_exit_status = 0;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* current_path = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gint _tmp14_ = 0;
	gboolean _tmp15_;
	gboolean result;
#line 330 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 332 "../src/client/application/application-client.vala"
	_tmp0_ = (*args)[0];
#line 332 "../src/client/application/application-client.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 332 "../src/client/application/application-client.vala"
	_g_free0 (self->priv->binary);
#line 332 "../src/client/application/application-client.vala"
	self->priv->binary = _tmp1_;
#line 333 "../src/client/application/application-client.vala"
	_tmp2_ = self->priv->binary;
#line 333 "../src/client/application/application-client.vala"
	_tmp3_ = g_find_program_in_path (_tmp2_);
#line 333 "../src/client/application/application-client.vala"
	_tmp4_ = _tmp3_;
#line 333 "../src/client/application/application-client.vala"
	_tmp5_ = realpath (_tmp4_, NULL);
#line 333 "../src/client/application/application-client.vala"
	_tmp6_ = _tmp5_;
#line 333 "../src/client/application/application-client.vala"
	_g_free0 (_tmp4_);
#line 333 "../src/client/application/application-client.vala"
	current_path = _tmp6_;
#line 336 "../src/client/application/application-client.vala"
	_tmp7_ = current_path;
#line 336 "../src/client/application/application-client.vala"
	if (_tmp7_ == NULL) {
#line 1685 "application-client.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 339 "../src/client/application/application-client.vala"
		_tmp8_ = self->priv->binary;
#line 339 "../src/client/application/application-client.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 339 "../src/client/application/application-client.vala"
		_g_free0 (current_path);
#line 339 "../src/client/application/application-client.vala"
		current_path = _tmp9_;
#line 1696 "application-client.c"
	}
#line 341 "../src/client/application/application-client.vala"
	_tmp10_ = current_path;
#line 341 "../src/client/application/application-client.vala"
	_tmp11_ = g_file_new_for_path (_tmp10_);
#line 341 "../src/client/application/application-client.vala"
	_tmp12_ = _tmp11_;
#line 341 "../src/client/application/application-client.vala"
	_tmp13_ = g_file_get_parent (_tmp12_);
#line 341 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->exec_dir);
#line 341 "../src/client/application/application-client.vala"
	self->priv->exec_dir = _tmp13_;
#line 341 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp12_);
#line 343 "../src/client/application/application-client.vala"
	_tmp15_ = G_APPLICATION_CLASS (application_client_parent_class)->local_command_line (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), g_application_get_type (), GApplication), args, &_tmp14_);
#line 343 "../src/client/application/application-client.vala"
	_vala_exit_status = _tmp14_;
#line 343 "../src/client/application/application-client.vala"
	result = _tmp15_;
#line 343 "../src/client/application/application-client.vala"
	_g_free0 (current_path);
#line 343 "../src/client/application/application-client.vala"
	if (exit_status) {
#line 343 "../src/client/application/application-client.vala"
		*exit_status = _vala_exit_status;
#line 1724 "application-client.c"
	}
#line 343 "../src/client/application/application-client.vala"
	return result;
#line 1728 "application-client.c"
}

static gint
application_client_real_handle_local_options (GApplication* base,
                                              GVariantDict* options)
{
	ApplicationClient * self;
	gint ret = 0;
	gint result;
#line 346 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 346 "../src/client/application/application-client.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 347 "../src/client/application/application-client.vala"
	ret = -1;
#line 348 "../src/client/application/application-client.vala"
	if (g_variant_dict_contains (options, APPLICATION_CLIENT_OPTION_DEBUG)) {
#line 1746 "application-client.c"
		FILE* _tmp0_;
#line 349 "../src/client/application/application-client.vala"
		_tmp0_ = stdout;
#line 349 "../src/client/application/application-client.vala"
		geary_logging_log_to (_tmp0_);
#line 1752 "application-client.c"
	}
#line 351 "../src/client/application/application-client.vala"
	if (g_variant_dict_contains (options, APPLICATION_CLIENT_OPTION_VERSION)) {
#line 1756 "application-client.c"
		FILE* _tmp1_;
		const gchar* _tmp2_;
#line 352 "../src/client/application/application-client.vala"
		_tmp1_ = stdout;
#line 352 "../src/client/application/application-client.vala"
		_tmp2_ = self->priv->binary;
#line 352 "../src/client/application/application-client.vala"
		fprintf (_tmp1_, "%s: %s\n", _tmp2_, APPLICATION_CLIENT_VERSION);
#line 355 "../src/client/application/application-client.vala"
		ret = 0;
#line 1767 "application-client.c"
	}
#line 357 "../src/client/application/application-client.vala"
	result = ret;
#line 357 "../src/client/application/application-client.vala"
	return result;
#line 1773 "application-client.c"
}

static void
_application_client_on_single_key_shortcuts_toggled_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self)
{
#line 415 "../src/client/application/application-client.vala"
	application_client_on_single_key_shortcuts_toggled ((ApplicationClient*) self);
#line 1783 "application-client.c"
}

static void
application_client_real_startup (GApplication* base)
{
	ApplicationClient * self;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GearyEngine* _tmp5_;
	GearyEngine* _tmp6_;
	ApplicationConfiguration* _tmp7_;
	ApplicationConfiguration* _tmp8_;
	ApplicationStartupManager* _tmp9_;
	ApplicationStartupManager* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar* _tmp14_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar* _tmp23_;
	gchar** _tmp24_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gchar* _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	gchar* _tmp33_;
	gchar** _tmp34_;
	gchar** _tmp35_;
	gint _tmp35__length1;
	gchar* _tmp36_;
	gchar** _tmp37_;
	gchar** _tmp38_;
	gint _tmp38__length1;
	gchar* _tmp39_;
	gchar** _tmp40_;
	gchar** _tmp41_;
	gint _tmp41__length1;
	gchar* _tmp42_;
	gchar** _tmp43_;
	gchar** _tmp44_;
	gint _tmp44__length1;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp45_;
	GdkDisplay* _tmp46_;
	GdkScreen* _tmp47_;
	GtkCssProvider* _tmp48_;
	ApplicationConfiguration* _tmp49_;
	gchar* _tmp50_;
#line 360 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 361 "../src/client/application/application-client.vala"
	g_set_application_name (APPLICATION_CLIENT_NAME);
#line 362 "../src/client/application/application-client.vala"
	g_set_prgname (APPLICATION_CLIENT_APP_ID);
#line 363 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->binary;
#line 363 "../src/client/application/application-client.vala"
	util_i18n_init (GETTEXT_PACKAGE, _tmp0_, UTIL_I18N_SYSTEM_LOCALE);
#line 364 "../src/client/application/application-client.vala"
	util_date_init ();
#line 366 "../src/client/application/application-client.vala"
	_tmp1_ = application_client_get_is_installed (self);
#line 366 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 366 "../src/client/application/application-client.vala"
	application_configuration_init (_tmp2_, APPLICATION_CLIENT_GSETTINGS_DIR);
#line 371 "../src/client/application/application-client.vala"
	g_action_map_add_action_entries (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_map_get_type (), GActionMap), APPLICATION_CLIENT_ACTION_ENTRIES, (gint) G_N_ELEMENTS (APPLICATION_CLIENT_ACTION_ENTRIES), self);
#line 374 "../src/client/application/application-client.vala"
	G_APPLICATION_CLASS (application_client_parent_class)->startup (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), g_application_get_type (), GApplication));
#line 375 "../src/client/application/application-client.vala"
	hdy_init ();
#line 377 "../src/client/application/application-client.vala"
	_tmp3_ = application_client_get_resource_directory (self);
#line 377 "../src/client/application/application-client.vala"
	_tmp4_ = _tmp3_;
#line 377 "../src/client/application/application-client.vala"
	_tmp5_ = geary_engine_new (_tmp4_);
#line 377 "../src/client/application/application-client.vala"
	_tmp6_ = _tmp5_;
#line 377 "../src/client/application/application-client.vala"
	application_client_set_engine (self, _tmp6_);
#line 377 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp6_);
#line 377 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp4_);
#line 378 "../src/client/application/application-client.vala"
	_tmp7_ = application_configuration_new (APPLICATION_CLIENT_SCHEMA_ID);
#line 378 "../src/client/application/application-client.vala"
	_tmp8_ = _tmp7_;
#line 378 "../src/client/application/application-client.vala"
	application_client_set_config (self, _tmp8_);
#line 378 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp8_);
#line 379 "../src/client/application/application-client.vala"
	_tmp9_ = application_startup_manager_new (self);
#line 379 "../src/client/application/application-client.vala"
	_tmp10_ = _tmp9_;
#line 379 "../src/client/application/application-client.vala"
	application_client_set_autostart (self, _tmp10_);
#line 379 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp10_);
#line 382 "../src/client/application/application-client.vala"
	gtk_window_set_default_icon_name (APPLICATION_CLIENT_APP_ID);
#line 385 "../src/client/application/application-client.vala"
	_tmp11_ = g_strdup ("<Ctrl>N");
#line 385 "../src/client/application/application-client.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 385 "../src/client/application/application-client.vala"
	_tmp12_[0] = _tmp11_;
#line 385 "../src/client/application/application-client.vala"
	_tmp13_ = _tmp12_;
#line 385 "../src/client/application/application-client.vala"
	_tmp13__length1 = 1;
#line 385 "../src/client/application/application-client.vala"
	application_client_add_app_accelerators (self, ACTION_APPLICATION_COMPOSE, _tmp13_, (gint) 1, NULL);
#line 385 "../src/client/application/application-client.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 386 "../src/client/application/application-client.vala"
	_tmp14_ = g_strdup ("F1");
#line 386 "../src/client/application/application-client.vala"
	_tmp15_ = g_new0 (gchar*, 1 + 1);
#line 386 "../src/client/application/application-client.vala"
	_tmp15_[0] = _tmp14_;
#line 386 "../src/client/application/application-client.vala"
	_tmp16_ = _tmp15_;
#line 386 "../src/client/application/application-client.vala"
	_tmp16__length1 = 1;
#line 386 "../src/client/application/application-client.vala"
	application_client_add_app_accelerators (self, ACTION_APPLICATION_HELP, _tmp16_, (gint) 1, NULL);
#line 386 "../src/client/application/application-client.vala"
	_tmp16_ = (_vala_array_free (_tmp16_, _tmp16__length1, (GDestroyNotify) g_free), NULL);
#line 387 "../src/client/application/application-client.vala"
	_tmp17_ = g_strdup ("<Alt><Shift>I");
#line 387 "../src/client/application/application-client.vala"
	_tmp18_ = g_new0 (gchar*, 1 + 1);
#line 387 "../src/client/application/application-client.vala"
	_tmp18_[0] = _tmp17_;
#line 387 "../src/client/application/application-client.vala"
	_tmp19_ = _tmp18_;
#line 387 "../src/client/application/application-client.vala"
	_tmp19__length1 = 1;
#line 387 "../src/client/application/application-client.vala"
	application_client_add_app_accelerators (self, ACTION_APPLICATION_INSPECT, _tmp19_, (gint) 1, NULL);
#line 387 "../src/client/application/application-client.vala"
	_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 388 "../src/client/application/application-client.vala"
	_tmp20_ = g_strdup ("<Ctrl><Shift>N");
#line 388 "../src/client/application/application-client.vala"
	_tmp21_ = g_new0 (gchar*, 1 + 1);
#line 388 "../src/client/application/application-client.vala"
	_tmp21_[0] = _tmp20_;
#line 388 "../src/client/application/application-client.vala"
	_tmp22_ = _tmp21_;
#line 388 "../src/client/application/application-client.vala"
	_tmp22__length1 = 1;
#line 388 "../src/client/application/application-client.vala"
	application_client_add_app_accelerators (self, ACTION_APPLICATION_NEW_WINDOW, _tmp22_, (gint) 1, NULL);
#line 388 "../src/client/application/application-client.vala"
	_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_free), NULL);
#line 389 "../src/client/application/application-client.vala"
	_tmp23_ = g_strdup ("<Ctrl>Q");
#line 389 "../src/client/application/application-client.vala"
	_tmp24_ = g_new0 (gchar*, 1 + 1);
#line 389 "../src/client/application/application-client.vala"
	_tmp24_[0] = _tmp23_;
#line 389 "../src/client/application/application-client.vala"
	_tmp25_ = _tmp24_;
#line 389 "../src/client/application/application-client.vala"
	_tmp25__length1 = 1;
#line 389 "../src/client/application/application-client.vala"
	application_client_add_app_accelerators (self, ACTION_APPLICATION_QUIT, _tmp25_, (gint) 1, NULL);
#line 389 "../src/client/application/application-client.vala"
	_tmp25_ = (_vala_array_free (_tmp25_, _tmp25__length1, (GDestroyNotify) g_free), NULL);
#line 392 "../src/client/application/application-client.vala"
	_tmp26_ = g_strdup ("<Ctrl>W");
#line 392 "../src/client/application/application-client.vala"
	_tmp27_ = g_new0 (gchar*, 1 + 1);
#line 392 "../src/client/application/application-client.vala"
	_tmp27_[0] = _tmp26_;
#line 392 "../src/client/application/application-client.vala"
	_tmp28_ = _tmp27_;
#line 392 "../src/client/application/application-client.vala"
	_tmp28__length1 = 1;
#line 392 "../src/client/application/application-client.vala"
	application_client_add_window_accelerators (self, ACTION_WINDOW_CLOSE, _tmp28_, (gint) 1, NULL);
#line 392 "../src/client/application/application-client.vala"
	_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 393 "../src/client/application/application-client.vala"
	_tmp29_ = g_strdup ("<Ctrl>F1");
#line 393 "../src/client/application/application-client.vala"
	_tmp30_ = g_strdup ("<Ctrl>question");
#line 393 "../src/client/application/application-client.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 393 "../src/client/application/application-client.vala"
	_tmp31_[0] = _tmp29_;
#line 393 "../src/client/application/application-client.vala"
	_tmp31_[1] = _tmp30_;
#line 393 "../src/client/application/application-client.vala"
	_tmp32_ = _tmp31_;
#line 393 "../src/client/application/application-client.vala"
	_tmp32__length1 = 2;
#line 393 "../src/client/application/application-client.vala"
	application_client_add_window_accelerators (self, ACTION_WINDOW_SHORTCUT_HELP, _tmp32_, (gint) 2, NULL);
#line 393 "../src/client/application/application-client.vala"
	_tmp32_ = (_vala_array_free (_tmp32_, _tmp32__length1, (GDestroyNotify) g_free), NULL);
#line 396 "../src/client/application/application-client.vala"
	_tmp33_ = g_strdup ("F10");
#line 396 "../src/client/application/application-client.vala"
	_tmp34_ = g_new0 (gchar*, 1 + 1);
#line 396 "../src/client/application/application-client.vala"
	_tmp34_[0] = _tmp33_;
#line 396 "../src/client/application/application-client.vala"
	_tmp35_ = _tmp34_;
#line 396 "../src/client/application/application-client.vala"
	_tmp35__length1 = 1;
#line 396 "../src/client/application/application-client.vala"
	application_client_add_window_accelerators (self, ACTION_WINDOW_SHOW_MENU, _tmp35_, (gint) 1, NULL);
#line 396 "../src/client/application/application-client.vala"
	_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
#line 399 "../src/client/application/application-client.vala"
	_tmp36_ = g_strdup ("<Ctrl>C");
#line 399 "../src/client/application/application-client.vala"
	_tmp37_ = g_new0 (gchar*, 1 + 1);
#line 399 "../src/client/application/application-client.vala"
	_tmp37_[0] = _tmp36_;
#line 399 "../src/client/application/application-client.vala"
	_tmp38_ = _tmp37_;
#line 399 "../src/client/application/application-client.vala"
	_tmp38__length1 = 1;
#line 399 "../src/client/application/application-client.vala"
	application_client_add_edit_accelerators (self, ACTION_EDIT_COPY, _tmp38_, (gint) 1, NULL);
#line 399 "../src/client/application/application-client.vala"
	_tmp38_ = (_vala_array_free (_tmp38_, _tmp38__length1, (GDestroyNotify) g_free), NULL);
#line 400 "../src/client/application/application-client.vala"
	_tmp39_ = g_strdup ("<Ctrl><Shift>Z");
#line 400 "../src/client/application/application-client.vala"
	_tmp40_ = g_new0 (gchar*, 1 + 1);
#line 400 "../src/client/application/application-client.vala"
	_tmp40_[0] = _tmp39_;
#line 400 "../src/client/application/application-client.vala"
	_tmp41_ = _tmp40_;
#line 400 "../src/client/application/application-client.vala"
	_tmp41__length1 = 1;
#line 400 "../src/client/application/application-client.vala"
	application_client_add_edit_accelerators (self, ACTION_EDIT_REDO, _tmp41_, (gint) 1, NULL);
#line 400 "../src/client/application/application-client.vala"
	_tmp41_ = (_vala_array_free (_tmp41_, _tmp41__length1, (GDestroyNotify) g_free), NULL);
#line 401 "../src/client/application/application-client.vala"
	_tmp42_ = g_strdup ("<Ctrl>Z");
#line 401 "../src/client/application/application-client.vala"
	_tmp43_ = g_new0 (gchar*, 1 + 1);
#line 401 "../src/client/application/application-client.vala"
	_tmp43_[0] = _tmp42_;
#line 401 "../src/client/application/application-client.vala"
	_tmp44_ = _tmp43_;
#line 401 "../src/client/application/application-client.vala"
	_tmp44__length1 = 1;
#line 401 "../src/client/application/application-client.vala"
	application_client_add_edit_accelerators (self, ACTION_EDIT_UNDO, _tmp44_, (gint) 1, NULL);
#line 401 "../src/client/application/application-client.vala"
	_tmp44_ = (_vala_array_free (_tmp44_, _tmp44__length1, (GDestroyNotify) g_free), NULL);
#line 404 "../src/client/application/application-client.vala"
	_tmp45_ = gtk_css_provider_new ();
#line 404 "../src/client/application/application-client.vala"
	provider = _tmp45_;
#line 405 "../src/client/application/application-client.vala"
	_tmp46_ = gdk_display_get_default ();
#line 405 "../src/client/application/application-client.vala"
	_tmp47_ = gdk_display_get_default_screen (_tmp46_);
#line 405 "../src/client/application/application-client.vala"
	gtk_style_context_add_provider_for_screen (_tmp47_, G_TYPE_CHECK_INSTANCE_CAST (provider, gtk_style_provider_get_type (), GtkStyleProvider), (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 410 "../src/client/application/application-client.vala"
	application_client_load_css (self, provider, "resource:///org/gnome/Geary/geary.css");
#line 412 "../src/client/application/application-client.vala"
	_tmp48_ = self->priv->single_key_shortcuts;
#line 412 "../src/client/application/application-client.vala"
	application_client_load_css (self, _tmp48_, "resource:///org/gnome/Geary/single-key-shortcuts.css");
#line 414 "../src/client/application/application-client.vala"
	application_client_update_single_key_shortcuts (self);
#line 415 "../src/client/application/application-client.vala"
	_tmp49_ = self->priv->_config;
#line 415 "../src/client/application/application-client.vala"
	_tmp50_ = g_strconcat ("notify::", APPLICATION_CONFIGURATION_SINGLE_KEY_SHORTCUTS, NULL);
#line 415 "../src/client/application/application-client.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, G_TYPE_OBJECT, GObject), _tmp50_, (GCallback) _application_client_on_single_key_shortcuts_toggled_g_object_notify, self, 0);
#line 415 "../src/client/application/application-client.vala"
	_g_free0 (_tmp50_);
#line 419 "../src/client/application/application-client.vala"
	application_main_window_add_accelerators (self);
#line 420 "../src/client/application/application-client.vala"
	composer_editor_add_accelerators (self);
#line 421 "../src/client/application/application-client.vala"
	composer_widget_add_accelerators (self);
#line 422 "../src/client/application/application-client.vala"
	components_inspector_add_accelerators (self);
#line 423 "../src/client/application/application-client.vala"
	components_preferences_window_add_accelerators (self);
#line 424 "../src/client/application/application-client.vala"
	dialogs_problem_details_dialog_add_accelerators (self);
#line 430 "../src/client/application/application-client.vala"
	g_application_hold (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication));
#line 433 "../src/client/application/application-client.vala"
	application_client_create_controller (self, NULL, NULL);
#line 360 "../src/client/application/application-client.vala"
	_g_object_unref0 (provider);
#line 2111 "application-client.c"
}

static gint
application_client_real_command_line (GApplication* base,
                                      GApplicationCommandLine* command_line)
{
	ApplicationClient * self;
	gint exit_value = 0;
	gint result;
#line 436 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 436 "../src/client/application/application-client.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (command_line, g_application_command_line_get_type ()), 0);
#line 437 "../src/client/application/application-client.vala"
	exit_value = application_client_handle_general_options (self, command_line);
#line 438 "../src/client/application/application-client.vala"
	if (exit_value != -1) {
#line 439 "../src/client/application/application-client.vala"
		result = exit_value;
#line 439 "../src/client/application/application-client.vala"
		return result;
#line 2133 "application-client.c"
	}
#line 441 "../src/client/application/application-client.vala"
	result = -1;
#line 441 "../src/client/application/application-client.vala"
	return result;
#line 2139 "application-client.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 444 "../src/client/application/application-client.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 444 "../src/client/application/application-client.vala"
	return _data5_;
#line 2149 "application-client.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 444 "../src/client/application/application-client.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2159 "application-client.c"
		ApplicationClient* self;
#line 444 "../src/client/application/application-client.vala"
		self = _data5_->self;
#line 444 "../src/client/application/application-client.vala"
		_g_object_unref0 (self);
#line 444 "../src/client/application/application-client.vala"
		g_slice_free (Block5Data, _data5_);
#line 2167 "application-client.c"
	}
}

static void
__lambda165_ (Block5Data* _data5_,
              GObject* obj,
              GAsyncResult* res)
{
	ApplicationClient* self;
#line 446 "../src/client/application/application-client.vala"
	self = _data5_->self;
#line 446 "../src/client/application/application-client.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 446 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 447 "../src/client/application/application-client.vala"
	application_client_destroy_controller_finish (self, res);
#line 448 "../src/client/application/application-client.vala"
	_data5_->controller_closed = TRUE;
#line 2187 "application-client.c"
}

static void
___lambda165__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 446 "../src/client/application/application-client.vala"
	__lambda165_ (self, source_object, res);
#line 446 "../src/client/application/application-client.vala"
	block5_data_unref (self);
#line 2199 "application-client.c"
}

static void
application_client_real_shutdown (GApplication* base)
{
	ApplicationClient * self;
	Block5Data* _data5_;
	gint64 start_usec = 0LL;
#line 444 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 444 "../src/client/application/application-client.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 444 "../src/client/application/application-client.vala"
	_data5_->_ref_count_ = 1;
#line 444 "../src/client/application/application-client.vala"
	_data5_->self = g_object_ref (self);
#line 445 "../src/client/application/application-client.vala"
	_data5_->controller_closed = FALSE;
#line 446 "../src/client/application/application-client.vala"
	application_client_destroy_controller (self, ___lambda165__gasync_ready_callback, block5_data_ref (_data5_));
#line 455 "../src/client/application/application-client.vala"
	start_usec = g_get_monotonic_time ();
#line 456 "../src/client/application/application-client.vala"
	while (TRUE) {
#line 2224 "application-client.c"
		gint64 delta_usec = 0LL;
#line 456 "../src/client/application/application-client.vala"
		if (!(!_data5_->controller_closed)) {
#line 456 "../src/client/application/application-client.vala"
			break;
#line 2230 "application-client.c"
		}
#line 457 "../src/client/application/application-client.vala"
		gtk_main_iteration ();
#line 459 "../src/client/application/application-client.vala"
		delta_usec = g_get_monotonic_time () - start_usec;
#line 460 "../src/client/application/application-client.vala"
		if (delta_usec >= APPLICATION_CLIENT_FORCE_SHUTDOWN_USEC) {
#line 2238 "application-client.c"
			gchar* _tmp0_;
			gchar* _tmp1_;
#line 465 "../src/client/application/application-client.vala"
			_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, delta_usec / APPLICATION_CLIENT_USEC_PER_SEC);
#line 465 "../src/client/application/application-client.vala"
			_tmp1_ = _tmp0_;
#line 465 "../src/client/application/application-client.vala"
			g_warning ("application-client.vala:465: Forcing shutdown of Geary, %ss passed...", _tmp1_);
#line 465 "../src/client/application/application-client.vala"
			_g_free0 (_tmp1_);
#line 467 "../src/client/application/application-client.vala"
			exit (2);
#line 2251 "application-client.c"
		}
	}
#line 471 "../src/client/application/application-client.vala"
	application_client_set_engine (self, NULL);
#line 472 "../src/client/application/application-client.vala"
	application_client_set_config (self, NULL);
#line 473 "../src/client/application/application-client.vala"
	application_client_set_autostart (self, NULL);
#line 475 "../src/client/application/application-client.vala"
	util_date_terminate ();
#line 476 "../src/client/application/application-client.vala"
	geary_logging_clear ();
#line 478 "../src/client/application/application-client.vala"
	G_APPLICATION_CLASS (application_client_parent_class)->shutdown (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), g_application_get_type (), GApplication));
#line 444 "../src/client/application/application-client.vala"
	block5_data_unref (_data5_);
#line 444 "../src/client/application/application-client.vala"
	_data5_ = NULL;
#line 2270 "application-client.c"
}

static void
application_client_real_activate (GApplication* base)
{
	ApplicationClient * self;
#line 481 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 482 "../src/client/application/application-client.vala"
	G_APPLICATION_CLASS (application_client_parent_class)->activate (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), g_application_get_type (), GApplication));
#line 483 "../src/client/application/application-client.vala"
	application_client_present (self, NULL, NULL);
#line 2283 "application-client.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 2306 "application-client.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 2315 "application-client.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 2334 "application-client.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 2338 "application-client.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 2344 "application-client.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 2354 "application-client.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 2362 "application-client.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 2366 "application-client.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 2372 "application-client.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 2382 "application-client.c"
}

static void
application_client_real_open (GApplication* base,
                              GFile** targets,
                              gint targets_length1,
                              const gchar* hint)
{
	ApplicationClient * self;
#line 486 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 486 "../src/client/application/application-client.vala"
	g_return_if_fail (hint != NULL);
#line 2396 "application-client.c"
	{
		GFile** target_collection = NULL;
		gint target_collection_length1 = 0;
		gint _target_collection_size_ = 0;
		gint target_it = 0;
#line 487 "../src/client/application/application-client.vala"
		target_collection = targets;
#line 487 "../src/client/application/application-client.vala"
		target_collection_length1 = targets_length1;
#line 487 "../src/client/application/application-client.vala"
		for (target_it = 0; target_it < target_collection_length1; target_it = target_it + 1) {
#line 2408 "application-client.c"
			GFile* _tmp0_;
			GFile* target = NULL;
#line 487 "../src/client/application/application-client.vala"
			_tmp0_ = _g_object_ref0 (target_collection[target_it]);
#line 487 "../src/client/application/application-client.vala"
			target = _tmp0_;
#line 2415 "application-client.c"
			{
				GFile* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				gboolean _tmp4_;
#line 488 "../src/client/application/application-client.vala"
				_tmp1_ = target;
#line 488 "../src/client/application/application-client.vala"
				_tmp2_ = g_file_get_uri_scheme (_tmp1_);
#line 488 "../src/client/application/application-client.vala"
				_tmp3_ = _tmp2_;
#line 488 "../src/client/application/application-client.vala"
				_tmp4_ = g_strcmp0 (_tmp3_, "mailto") == 0;
#line 488 "../src/client/application/application-client.vala"
				_g_free0 (_tmp3_);
#line 488 "../src/client/application/application-client.vala"
				if (_tmp4_) {
#line 2433 "application-client.c"
					gchar* mailto = NULL;
					GFile* _tmp5_;
					gchar* _tmp6_;
#line 492 "../src/client/application/application-client.vala"
					static const char B0RKED_GLIB_MAILTO_PREFIX[] = "mailto:///";
#line 2439 "application-client.c"
					const gchar* _tmp7_;
					const gchar* _tmp14_;
#line 489 "../src/client/application/application-client.vala"
					_tmp5_ = target;
#line 489 "../src/client/application/application-client.vala"
					_tmp6_ = g_file_get_uri (_tmp5_);
#line 489 "../src/client/application/application-client.vala"
					mailto = _tmp6_;
#line 493 "../src/client/application/application-client.vala"
					_tmp7_ = mailto;
#line 493 "../src/client/application/application-client.vala"
					if (g_str_has_prefix (_tmp7_, B0RKED_GLIB_MAILTO_PREFIX)) {
#line 2452 "application-client.c"
						const gchar* _tmp8_;
						gint _tmp9_;
						gint _tmp10_;
						gchar* _tmp11_;
						gchar* _tmp12_;
						gchar* _tmp13_;
#line 494 "../src/client/application/application-client.vala"
						_tmp8_ = mailto;
#line 494 "../src/client/application/application-client.vala"
						_tmp9_ = strlen (B0RKED_GLIB_MAILTO_PREFIX);
#line 494 "../src/client/application/application-client.vala"
						_tmp10_ = _tmp9_;
#line 494 "../src/client/application/application-client.vala"
						_tmp11_ = string_substring (_tmp8_, (glong) _tmp10_, (glong) -1);
#line 494 "../src/client/application/application-client.vala"
						_tmp12_ = _tmp11_;
#line 494 "../src/client/application/application-client.vala"
						_tmp13_ = g_strconcat (APPLICATION_CLIENT_MAILTO_URI_SCHEME_PREFIX, _tmp12_, NULL);
#line 494 "../src/client/application/application-client.vala"
						_g_free0 (mailto);
#line 494 "../src/client/application/application-client.vala"
						mailto = _tmp13_;
#line 494 "../src/client/application/application-client.vala"
						_g_free0 (_tmp12_);
#line 2477 "application-client.c"
					}
#line 499 "../src/client/application/application-client.vala"
					_tmp14_ = mailto;
#line 499 "../src/client/application/application-client.vala"
					application_client_new_composer_mailto (self, _tmp14_, NULL, NULL);
#line 488 "../src/client/application/application-client.vala"
					_g_free0 (mailto);
#line 2485 "application-client.c"
				}
#line 487 "../src/client/application/application-client.vala"
				_g_object_unref0 (target);
#line 2489 "application-client.c"
			}
		}
	}
}

/**
     * Returns a collection of open main windows.
     */
GeeCollection*
application_client_get_main_windows (ApplicationClient* self)
{
	GeeLinkedList* windows = NULL;
	GeeLinkedList* _tmp0_;
	GList* _tmp1_;
	GeeCollection* result;
#line 507 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 508 "../src/client/application/application-client.vala"
	_tmp0_ = gee_linked_list_new (APPLICATION_TYPE_MAIN_WINDOW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 508 "../src/client/application/application-client.vala"
	windows = _tmp0_;
#line 509 "../src/client/application/application-client.vala"
	_tmp1_ = gtk_application_get_windows (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 2513 "application-client.c"
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
#line 509 "../src/client/application/application-client.vala"
		window_collection = _tmp1_;
#line 509 "../src/client/application/application-client.vala"
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
#line 2521 "application-client.c"
			GtkWindow* _tmp2_;
			GtkWindow* window = NULL;
#line 509 "../src/client/application/application-client.vala"
			_tmp2_ = _g_object_ref0 ((GtkWindow*) window_it->data);
#line 509 "../src/client/application/application-client.vala"
			window = _tmp2_;
#line 2528 "application-client.c"
			{
				ApplicationMainWindow* main = NULL;
				GtkWindow* _tmp3_;
				ApplicationMainWindow* _tmp4_;
				ApplicationMainWindow* _tmp5_;
#line 510 "../src/client/application/application-client.vala"
				_tmp3_ = window;
#line 510 "../src/client/application/application-client.vala"
				_tmp4_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp3_) ? ((ApplicationMainWindow*) _tmp3_) : NULL);
#line 510 "../src/client/application/application-client.vala"
				main = _tmp4_;
#line 511 "../src/client/application/application-client.vala"
				_tmp5_ = main;
#line 511 "../src/client/application/application-client.vala"
				if (_tmp5_ != NULL) {
#line 2544 "application-client.c"
					GeeLinkedList* _tmp6_;
					ApplicationMainWindow* _tmp7_;
#line 512 "../src/client/application/application-client.vala"
					_tmp6_ = windows;
#line 512 "../src/client/application/application-client.vala"
					_tmp7_ = main;
#line 512 "../src/client/application/application-client.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp7_);
#line 2553 "application-client.c"
				}
#line 509 "../src/client/application/application-client.vala"
				_g_object_unref0 (main);
#line 509 "../src/client/application/application-client.vala"
				_g_object_unref0 (window);
#line 2559 "application-client.c"
			}
		}
	}
#line 515 "../src/client/application/application-client.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (windows, GEE_TYPE_COLLECTION, GeeCollection);
#line 515 "../src/client/application/application-client.vala"
	return result;
#line 2567 "application-client.c"
}

/**
     * Returns the mostly recently active main window or a new instance.
     *
     * This returns the value of {@link last_active_main_window} if
     * not null, else it constructs a new MainWindow instance and
     * shows it.
     */
ApplicationMainWindow*
application_client_get_active_main_window (ApplicationClient* self)
{
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp3_;
	ApplicationMainWindow* _tmp4_;
	ApplicationMainWindow* result;
#line 525 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 526 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_last_active_main_window;
#line 526 "../src/client/application/application-client.vala"
	if (_tmp0_ == NULL) {
#line 2590 "application-client.c"
		ApplicationMainWindow* _tmp1_;
		ApplicationMainWindow* _tmp2_;
#line 527 "../src/client/application/application-client.vala"
		_tmp1_ = application_client_new_main_window (self, TRUE);
#line 527 "../src/client/application/application-client.vala"
		_tmp2_ = _tmp1_;
#line 527 "../src/client/application/application-client.vala"
		application_client_set_last_active_main_window (self, _tmp2_);
#line 527 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp2_);
#line 2601 "application-client.c"
	}
#line 529 "../src/client/application/application-client.vala"
	_tmp3_ = self->priv->_last_active_main_window;
#line 529 "../src/client/application/application-client.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 529 "../src/client/application/application-client.vala"
	result = _tmp4_;
#line 529 "../src/client/application/application-client.vala"
	return result;
#line 2611 "application-client.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 538 "../src/client/application/application-client.vala"
	if ((*length) == (*size)) {
#line 538 "../src/client/application/application-client.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 538 "../src/client/application/application-client.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2626 "application-client.c"
	}
#line 538 "../src/client/application/application-client.vala"
	(*array)[(*length)++] = value;
#line 538 "../src/client/application/application-client.vala"
	(*array)[*length] = NULL;
#line 2632 "application-client.c"
}

void
application_client_add_window_accelerators (ApplicationClient* self,
                                            const gchar* action,
                                            gchar** accelerators,
                                            gint accelerators_length1,
                                            GVariant* param)
{
	gchar* name = NULL;
	gchar* _tmp0_;
	gchar** all_accel = NULL;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint all_accel_length1;
	gint _all_accel_size_;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 532 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 532 "../src/client/application/application-client.vala"
	g_return_if_fail (action != NULL);
#line 535 "../src/client/application/application-client.vala"
	_tmp0_ = action_window_prefix (action);
#line 535 "../src/client/application/application-client.vala"
	name = _tmp0_;
#line 536 "../src/client/application/application-client.vala"
	_tmp1_ = name;
#line 536 "../src/client/application/application-client.vala"
	_tmp3_ = _tmp2_ = gtk_application_get_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), _tmp1_);
#line 536 "../src/client/application/application-client.vala"
	all_accel = _tmp3_;
#line 536 "../src/client/application/application-client.vala"
	all_accel_length1 = _vala_array_length (_tmp2_);
#line 536 "../src/client/application/application-client.vala"
	_all_accel_size_ = all_accel_length1;
#line 2671 "application-client.c"
	{
		gchar** accel_collection = NULL;
		gint accel_collection_length1 = 0;
		gint _accel_collection_size_ = 0;
		gint accel_it = 0;
#line 537 "../src/client/application/application-client.vala"
		accel_collection = accelerators;
#line 537 "../src/client/application/application-client.vala"
		accel_collection_length1 = accelerators_length1;
#line 537 "../src/client/application/application-client.vala"
		for (accel_it = 0; accel_it < accel_collection_length1; accel_it = accel_it + 1) {
#line 2683 "application-client.c"
			gchar* _tmp4_;
			gchar* accel = NULL;
#line 537 "../src/client/application/application-client.vala"
			_tmp4_ = g_strdup (accel_collection[accel_it]);
#line 537 "../src/client/application/application-client.vala"
			accel = _tmp4_;
#line 2690 "application-client.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 538 "../src/client/application/application-client.vala"
				_tmp5_ = accel;
#line 538 "../src/client/application/application-client.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 538 "../src/client/application/application-client.vala"
				_vala_array_add1 (&all_accel, &all_accel_length1, &_all_accel_size_, _tmp6_);
#line 537 "../src/client/application/application-client.vala"
				_g_free0 (accel);
#line 2702 "application-client.c"
			}
		}
	}
#line 540 "../src/client/application/application-client.vala"
	_tmp7_ = name;
#line 540 "../src/client/application/application-client.vala"
	_tmp8_ = all_accel;
#line 540 "../src/client/application/application-client.vala"
	_tmp8__length1 = all_accel_length1;
#line 540 "../src/client/application/application-client.vala"
	gtk_application_set_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), _tmp7_, _tmp8_);
#line 532 "../src/client/application/application-client.vala"
	all_accel = (_vala_array_free (all_accel, all_accel_length1, (GDestroyNotify) g_free), NULL);
#line 532 "../src/client/application/application-client.vala"
	_g_free0 (name);
#line 2718 "application-client.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 549 "../src/client/application/application-client.vala"
	if ((*length) == (*size)) {
#line 549 "../src/client/application/application-client.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 549 "../src/client/application/application-client.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 2733 "application-client.c"
	}
#line 549 "../src/client/application/application-client.vala"
	(*array)[(*length)++] = value;
#line 549 "../src/client/application/application-client.vala"
	(*array)[*length] = NULL;
#line 2739 "application-client.c"
}

void
application_client_add_edit_accelerators (ApplicationClient* self,
                                          const gchar* action,
                                          gchar** accelerators,
                                          gint accelerators_length1,
                                          GVariant* param)
{
	gchar* name = NULL;
	gchar* _tmp0_;
	gchar** all_accel = NULL;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint all_accel_length1;
	gint _all_accel_size_;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
#line 543 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 543 "../src/client/application/application-client.vala"
	g_return_if_fail (action != NULL);
#line 546 "../src/client/application/application-client.vala"
	_tmp0_ = action_edit_prefix (action);
#line 546 "../src/client/application/application-client.vala"
	name = _tmp0_;
#line 547 "../src/client/application/application-client.vala"
	_tmp1_ = name;
#line 547 "../src/client/application/application-client.vala"
	_tmp3_ = _tmp2_ = gtk_application_get_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), _tmp1_);
#line 547 "../src/client/application/application-client.vala"
	all_accel = _tmp3_;
#line 547 "../src/client/application/application-client.vala"
	all_accel_length1 = _vala_array_length (_tmp2_);
#line 547 "../src/client/application/application-client.vala"
	_all_accel_size_ = all_accel_length1;
#line 2778 "application-client.c"
	{
		gchar** accel_collection = NULL;
		gint accel_collection_length1 = 0;
		gint _accel_collection_size_ = 0;
		gint accel_it = 0;
#line 548 "../src/client/application/application-client.vala"
		accel_collection = accelerators;
#line 548 "../src/client/application/application-client.vala"
		accel_collection_length1 = accelerators_length1;
#line 548 "../src/client/application/application-client.vala"
		for (accel_it = 0; accel_it < accel_collection_length1; accel_it = accel_it + 1) {
#line 2790 "application-client.c"
			gchar* _tmp4_;
			gchar* accel = NULL;
#line 548 "../src/client/application/application-client.vala"
			_tmp4_ = g_strdup (accel_collection[accel_it]);
#line 548 "../src/client/application/application-client.vala"
			accel = _tmp4_;
#line 2797 "application-client.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 549 "../src/client/application/application-client.vala"
				_tmp5_ = accel;
#line 549 "../src/client/application/application-client.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 549 "../src/client/application/application-client.vala"
				_vala_array_add2 (&all_accel, &all_accel_length1, &_all_accel_size_, _tmp6_);
#line 548 "../src/client/application/application-client.vala"
				_g_free0 (accel);
#line 2809 "application-client.c"
			}
		}
	}
#line 551 "../src/client/application/application-client.vala"
	_tmp7_ = name;
#line 551 "../src/client/application/application-client.vala"
	_tmp8_ = all_accel;
#line 551 "../src/client/application/application-client.vala"
	_tmp8__length1 = all_accel_length1;
#line 551 "../src/client/application/application-client.vala"
	gtk_application_set_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), _tmp7_, _tmp8_);
#line 543 "../src/client/application/application-client.vala"
	all_accel = (_vala_array_free (all_accel, all_accel_length1, (GDestroyNotify) g_free), NULL);
#line 543 "../src/client/application/application-client.vala"
	_g_free0 (name);
#line 2825 "application-client.c"
}

static void
application_client_show_about_data_free (gpointer _data)
{
	ApplicationClientShowAboutData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowAboutData, _data_);
#line 2837 "application-client.c"
}

void
application_client_show_about (ApplicationClient* self,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ApplicationClientShowAboutData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowAboutData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_about_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_about_co (_data_);
#line 2861 "application-client.c"
}

void
application_client_show_about_finish (ApplicationClient* self,
                                      GAsyncResult* _res_)
{
	ApplicationClientShowAboutData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2871 "application-client.c"
}

static void
application_client_show_about_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ApplicationClientShowAboutData* _data_;
#line 555 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 555 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 555 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 555 "../src/client/application/application-client.vala"
	application_client_show_about_co (_data_);
#line 2888 "application-client.c"
}

static gboolean
application_client_show_about_co (ApplicationClientShowAboutData* _data_)
{
#line 554 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 554 "../src/client/application/application-client.vala"
		case 0:
#line 2898 "application-client.c"
		goto _state_0;
#line 554 "../src/client/application/application-client.vala"
		case 1:
#line 2902 "application-client.c"
		goto _state_1;
		default:
#line 554 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 2907 "application-client.c"
	}
	_state_0:
#line 555 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 555 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_show_about_ready, _data_);
#line 555 "../src/client/application/application-client.vala"
	return FALSE;
#line 2916 "application-client.c"
	_state_1:
#line 555 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 555 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 555 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 564 "../src/client/application/application-client.vala"
	if (g_strcmp0 (_REVNO, "") == 0) {
#line 564 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = g_strdup (APPLICATION_CLIENT_VERSION);
#line 564 "../src/client/application/application-client.vala"
		_g_free0 (_data_->_tmp2_);
#line 564 "../src/client/application/application-client.vala"
		_data_->_tmp2_ = _data_->_tmp3_;
#line 2932 "application-client.c"
	} else {
#line 564 "../src/client/application/application-client.vala"
		_data_->_tmp4_ = g_strdup_printf ("%s (%s)", APPLICATION_CLIENT_VERSION, _REVNO);
#line 564 "../src/client/application/application-client.vala"
		_g_free0 (_data_->_tmp2_);
#line 564 "../src/client/application/application-client.vala"
		_data_->_tmp2_ = _data_->_tmp4_;
#line 2940 "application-client.c"
	}
#line 557 "../src/client/application/application-client.vala"
	_data_->_tmp5_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, gtk_application_get_type (), GtkApplication));
#line 557 "../src/client/application/application-client.vala"
	_data_->_tmp6_ = g_strjoin ("\n", APPLICATION_CLIENT_COPYRIGHT_1, APPLICATION_CLIENT_COPYRIGHT_2, NULL);
#line 557 "../src/client/application/application-client.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 557 "../src/client/application/application-client.vala"
	_data_->_tmp8_ = g_strdup_printf (_ ("About %s"), APPLICATION_CLIENT_NAME);
#line 557 "../src/client/application/application-client.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 557 "../src/client/application/application-client.vala"
	gtk_show_about_dialog (_data_->_tmp5_, "program-name", APPLICATION_CLIENT_NAME, "comments", APPLICATION_CLIENT_DESCRIPTION, "authors", APPLICATION_CLIENT_AUTHORS, "copyright", _data_->_tmp7_, "license-type", GTK_LICENSE_LGPL_2_1, "logo-icon-name", APPLICATION_CLIENT_APP_ID, "version", _data_->_tmp2_, "website", APPLICATION_CLIENT_WEBSITE, "website-label", APPLICATION_CLIENT_WEBSITE_LABEL, "title", _data_->_tmp9_, "translator-credits", _ ("translator-credits"), NULL);
#line 557 "../src/client/application/application-client.vala"
	_g_free0 (_data_->_tmp9_);
#line 557 "../src/client/application/application-client.vala"
	_g_free0 (_data_->_tmp7_);
#line 554 "../src/client/application/application-client.vala"
	_g_free0 (_data_->_tmp2_);
#line 554 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 554 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 554 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 554 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2968 "application-client.c"
		}
	}
#line 554 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 554 "../src/client/application/application-client.vala"
	return FALSE;
#line 2975 "application-client.c"
}

static void
application_client_show_accounts_data_free (gpointer _data)
{
	ApplicationClientShowAccountsData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowAccountsData, _data_);
#line 2987 "application-client.c"
}

void
application_client_show_accounts (ApplicationClient* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	ApplicationClientShowAccountsData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowAccountsData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_accounts_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_accounts_co (_data_);
#line 3011 "application-client.c"
}

void
application_client_show_accounts_finish (ApplicationClient* self,
                                         GAsyncResult* _res_)
{
	ApplicationClientShowAccountsData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3021 "application-client.c"
}

static void
application_client_show_accounts_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	ApplicationClientShowAccountsData* _data_;
#line 576 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 576 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 576 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 576 "../src/client/application/application-client.vala"
	application_client_show_accounts_co (_data_);
#line 3038 "application-client.c"
}

static gboolean
application_client_show_accounts_co (ApplicationClientShowAccountsData* _data_)
{
#line 575 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 575 "../src/client/application/application-client.vala"
		case 0:
#line 3048 "application-client.c"
		goto _state_0;
#line 575 "../src/client/application/application-client.vala"
		case 1:
#line 3052 "application-client.c"
		goto _state_1;
		default:
#line 575 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 3057 "application-client.c"
	}
	_state_0:
#line 576 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 576 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_show_accounts_ready, _data_);
#line 576 "../src/client/application/application-client.vala"
	return FALSE;
#line 3066 "application-client.c"
	_state_1:
#line 576 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 576 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 576 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 578 "../src/client/application/application-client.vala"
	_data_->_tmp2_ = application_client_get_active_main_window (_data_->self);
#line 578 "../src/client/application/application-client.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 578 "../src/client/application/application-client.vala"
	_data_->_tmp4_ = accounts_editor_new (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, gtk_window_get_type (), GtkWindow));
#line 578 "../src/client/application/application-client.vala"
	g_object_ref_sink (_data_->_tmp4_);
#line 578 "../src/client/application/application-client.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 578 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 578 "../src/client/application/application-client.vala"
	_data_->editor = _data_->_tmp5_;
#line 581 "../src/client/application/application-client.vala"
	gtk_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_data_->editor, gtk_dialog_get_type (), GtkDialog));
#line 582 "../src/client/application/application-client.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_data_->editor, gtk_widget_get_type (), GtkWidget));
#line 583 "../src/client/application/application-client.vala"
	_data_->_tmp6_ = _data_->self->priv->_controller;
#line 583 "../src/client/application/application-client.vala"
	application_controller_expunge_accounts (_data_->_tmp6_, NULL, NULL);
#line 575 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->editor);
#line 575 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 575 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 575 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 575 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3106 "application-client.c"
		}
	}
#line 575 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 575 "../src/client/application/application-client.vala"
	return FALSE;
#line 3113 "application-client.c"
}

static void
application_client_show_email_data_free (gpointer _data)
{
	ApplicationClientShowEmailData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_variant_unref0 (_data_->id);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowEmailData, _data_);
#line 3127 "application-client.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 27 "../src/client/application/application-client.vala"
	return self ? g_variant_ref (self) : NULL;
#line 3135 "application-client.c"
}

void
application_client_show_email (ApplicationClient* self,
                               GVariant* id,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ApplicationClientShowEmailData* _data_;
	ApplicationClient* _tmp0_;
	GVariant* _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowEmailData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_email_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	_tmp1_ = _g_variant_ref0 (id);
#line 27 "../src/client/application/application-client.vala"
	_g_variant_unref0 (_data_->id);
#line 27 "../src/client/application/application-client.vala"
	_data_->id = _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_email_co (_data_);
#line 3167 "application-client.c"
}

void
application_client_show_email_finish (ApplicationClient* self,
                                      GAsyncResult* _res_)
{
	ApplicationClientShowEmailData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3177 "application-client.c"
}

/**
     * Displays a specific email in a main window.
     *
     * This method is invoked by the application `show-email`
     * action. A folder containing the email will be selected if the
     * current folder does not select it.
     *
     * The email is identified by the given variant, which can be
     * obtained by calling {@link Plugin.EmailIdentifier.to_variant}.
     */
static void
application_client_show_email_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ApplicationClientShowEmailData* _data_;
#line 597 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 597 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 597 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 597 "../src/client/application/application-client.vala"
	application_client_show_email_co (_data_);
#line 3204 "application-client.c"
}

static gboolean
application_client_show_email_co (ApplicationClientShowEmailData* _data_)
{
#line 596 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 596 "../src/client/application/application-client.vala"
		case 0:
#line 3214 "application-client.c"
		goto _state_0;
#line 596 "../src/client/application/application-client.vala"
		case 1:
#line 3218 "application-client.c"
		goto _state_1;
#line 596 "../src/client/application/application-client.vala"
		case 2:
#line 3222 "application-client.c"
		goto _state_2;
#line 596 "../src/client/application/application-client.vala"
		case 3:
#line 3226 "application-client.c"
		goto _state_3;
		default:
#line 596 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 3231 "application-client.c"
	}
	_state_0:
#line 597 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 597 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_show_email_ready, _data_);
#line 597 "../src/client/application/application-client.vala"
	return FALSE;
#line 3240 "application-client.c"
	_state_1:
#line 597 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 597 "../src/client/application/application-client.vala"
	_data_->main = _data_->_tmp0_;
#line 598 "../src/client/application/application-client.vala"
	if (_data_->id != NULL) {
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp1_ = _data_->self->priv->_controller;
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp2_ = application_controller_get_plugins (_data_->_tmp1_);
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp4_ = application_plugin_manager_get_globals (_data_->_tmp3_);
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp6_ = application_plugin_manager_plugin_globals_get_email (_data_->_tmp5_);
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 599 "../src/client/application/application-client.vala"
		_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 599 "../src/client/application/application-client.vala"
		_data_->email = _data_->_tmp8_;
#line 600 "../src/client/application/application-client.vala"
		_data_->_tmp9_ = _data_->email;
#line 600 "../src/client/application/application-client.vala"
		_data_->_tmp10_ = application_email_store_factory_get_account_for_variant (_data_->_tmp9_, _data_->id);
#line 600 "../src/client/application/application-client.vala"
		_data_->context = _data_->_tmp10_;
#line 601 "../src/client/application/application-client.vala"
		_data_->_tmp11_ = _data_->email;
#line 601 "../src/client/application/application-client.vala"
		_data_->_tmp12_ = application_email_store_factory_get_email_identifier_for_variant (_data_->_tmp11_, _data_->id);
#line 601 "../src/client/application/application-client.vala"
		_data_->email_id = _data_->_tmp12_;
#line 603 "../src/client/application/application-client.vala"
		_data_->_tmp14_ = _data_->context;
#line 603 "../src/client/application/application-client.vala"
		if (_data_->_tmp14_ != NULL) {
#line 603 "../src/client/application/application-client.vala"
			_data_->_tmp15_ = _data_->email_id;
#line 603 "../src/client/application/application-client.vala"
			_data_->_tmp13_ = _data_->_tmp15_ != NULL;
#line 3286 "application-client.c"
		} else {
#line 603 "../src/client/application/application-client.vala"
			_data_->_tmp13_ = FALSE;
#line 3290 "application-client.c"
		}
#line 603 "../src/client/application/application-client.vala"
		if (_data_->_tmp13_) {
#line 605 "../src/client/application/application-client.vala"
			_data_->folders = NULL;
#line 3296 "application-client.c"
			{
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp17_ = _data_->context;
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp18_ = application_account_context_get_account (_data_->_tmp17_);
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp19_ = _data_->_tmp18_;
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp20_ = _data_->email_id;
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp21_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp20_);
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp22_ = _data_->_tmp21_;
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp23_ = _data_->context;
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp24_ = application_account_context_get_cancellable (_data_->_tmp23_);
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 607 "../src/client/application/application-client.vala"
				_data_->_state_ = 2;
#line 607 "../src/client/application/application-client.vala"
				geary_account_get_containing_folders_async (_data_->_tmp19_, _data_->_tmp22_, _data_->_tmp25_, application_client_show_email_ready, _data_);
#line 607 "../src/client/application/application-client.vala"
				return FALSE;
#line 3322 "application-client.c"
				_state_2:
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp26_ = geary_account_get_containing_folders_finish (_data_->_tmp19_, _data_->_res_, &_data_->_inner_error0_);
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp27_ = _data_->_tmp26_;
#line 607 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->_tmp22_);
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp16_ = _data_->_tmp27_;
#line 607 "../src/client/application/application-client.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3334 "application-client.c"
					goto __catch0_g_error;
				}
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp28_ = _data_->_tmp16_;
#line 607 "../src/client/application/application-client.vala"
				_data_->_tmp16_ = NULL;
#line 607 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->folders);
#line 607 "../src/client/application/application-client.vala"
				_data_->folders = _data_->_tmp28_;
#line 606 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->_tmp16_);
#line 3347 "application-client.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 606 "../src/client/application/application-client.vala"
				_data_->err = _data_->_inner_error0_;
#line 606 "../src/client/application/application-client.vala"
				_data_->_inner_error0_ = NULL;
#line 612 "../src/client/application/application-client.vala"
				_data_->_tmp29_ = _data_->err;
#line 612 "../src/client/application/application-client.vala"
				_data_->_tmp30_ = _data_->_tmp29_->message;
#line 612 "../src/client/application/application-client.vala"
				g_warning ("application-client.vala:612: Error listing folders for email: %s", _data_->_tmp30_);
#line 606 "../src/client/application/application-client.vala"
				_g_error_free0 (_data_->err);
#line 3364 "application-client.c"
			}
			__finally0:
#line 606 "../src/client/application/application-client.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 606 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->folders);
#line 606 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->email_id);
#line 606 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->context);
#line 606 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->email);
#line 606 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->main);
#line 606 "../src/client/application/application-client.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 606 "../src/client/application/application-client.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 606 "../src/client/application/application-client.vala"
				g_object_unref (_data_->_async_result);
#line 606 "../src/client/application/application-client.vala"
				return FALSE;
#line 3387 "application-client.c"
			}
#line 614 "../src/client/application/application-client.vala"
			_data_->_tmp31_ = _data_->folders;
#line 614 "../src/client/application/application-client.vala"
			if (_data_->_tmp31_ != NULL) {
#line 620 "../src/client/application/application-client.vala"
				_data_->_tmp32_ = _data_->folders;
#line 620 "../src/client/application/application-client.vala"
				_data_->_tmp33_ = _data_->email_id;
#line 620 "../src/client/application/application-client.vala"
				_data_->_tmp34_ = gee_multi_map_get (_data_->_tmp32_, _data_->_tmp33_);
#line 620 "../src/client/application/application-client.vala"
				_data_->paths = _data_->_tmp34_;
#line 621 "../src/client/application/application-client.vala"
				_data_->_tmp35_ = _data_->main;
#line 621 "../src/client/application/application-client.vala"
				_data_->_tmp36_ = application_main_window_get_selected_folder (_data_->_tmp35_);
#line 621 "../src/client/application/application-client.vala"
				_data_->_tmp37_ = _data_->_tmp36_;
#line 621 "../src/client/application/application-client.vala"
				_data_->_tmp38_ = _g_object_ref0 (_data_->_tmp37_);
#line 621 "../src/client/application/application-client.vala"
				_data_->selected = _data_->_tmp38_;
#line 622 "../src/client/application/application-client.vala"
				_data_->_tmp41_ = _data_->selected;
#line 622 "../src/client/application/application-client.vala"
				if (_data_->_tmp41_ == NULL) {
#line 622 "../src/client/application/application-client.vala"
					_data_->_tmp40_ = TRUE;
#line 3417 "application-client.c"
				} else {
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp42_ = _data_->selected;
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp43_ = geary_folder_get_account (_data_->_tmp42_);
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp44_ = _data_->_tmp43_;
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp45_ = _data_->context;
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp46_ = application_account_context_get_account (_data_->_tmp45_);
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp47_ = _data_->_tmp46_;
#line 623 "../src/client/application/application-client.vala"
					_data_->_tmp40_ = _data_->_tmp44_ != _data_->_tmp47_;
#line 3433 "application-client.c"
				}
#line 622 "../src/client/application/application-client.vala"
				if (_data_->_tmp40_) {
#line 622 "../src/client/application/application-client.vala"
					_data_->_tmp39_ = TRUE;
#line 3439 "application-client.c"
				} else {
#line 624 "../src/client/application/application-client.vala"
					_data_->_tmp48_ = _data_->paths;
#line 624 "../src/client/application/application-client.vala"
					_data_->_tmp49_ = _data_->selected;
#line 624 "../src/client/application/application-client.vala"
					_data_->_tmp50_ = geary_folder_get_path (_data_->_tmp49_);
#line 624 "../src/client/application/application-client.vala"
					_data_->_tmp51_ = _data_->_tmp50_;
#line 624 "../src/client/application/application-client.vala"
					_data_->_tmp39_ = !gee_collection_contains (_data_->_tmp48_, _data_->_tmp51_);
#line 3451 "application-client.c"
				}
#line 622 "../src/client/application/application-client.vala"
				if (_data_->_tmp39_) {
#line 625 "../src/client/application/application-client.vala"
					_g_object_unref0 (_data_->selected);
#line 625 "../src/client/application/application-client.vala"
					_data_->selected = NULL;
#line 3459 "application-client.c"
					{
#line 626 "../src/client/application/application-client.vala"
						_data_->_tmp52_ = _data_->paths;
#line 626 "../src/client/application/application-client.vala"
						_data_->_tmp53_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp52_, GEE_TYPE_ITERABLE, GeeIterable));
#line 626 "../src/client/application/application-client.vala"
						_data_->_path_it = _data_->_tmp53_;
#line 626 "../src/client/application/application-client.vala"
						while (TRUE) {
#line 626 "../src/client/application/application-client.vala"
							_data_->_tmp54_ = _data_->_path_it;
#line 626 "../src/client/application/application-client.vala"
							if (!gee_iterator_next (_data_->_tmp54_)) {
#line 626 "../src/client/application/application-client.vala"
								break;
#line 3475 "application-client.c"
							}
#line 626 "../src/client/application/application-client.vala"
							_data_->_tmp55_ = _data_->_path_it;
#line 626 "../src/client/application/application-client.vala"
							_data_->_tmp56_ = gee_iterator_get (_data_->_tmp55_);
#line 626 "../src/client/application/application-client.vala"
							_data_->path = (GearyFolderPath*) _data_->_tmp56_;
#line 3483 "application-client.c"
							{
#line 628 "../src/client/application/application-client.vala"
								_data_->_tmp57_ = _data_->context;
#line 628 "../src/client/application/application-client.vala"
								_data_->_tmp58_ = application_account_context_get_account (_data_->_tmp57_);
#line 628 "../src/client/application/application-client.vala"
								_data_->_tmp59_ = _data_->_tmp58_;
#line 628 "../src/client/application/application-client.vala"
								_data_->_tmp60_ = _data_->path;
#line 628 "../src/client/application/application-client.vala"
								_data_->_tmp61_ = geary_account_get_folder (_data_->_tmp59_, _data_->_tmp60_, &_data_->_inner_error0_);
#line 628 "../src/client/application/application-client.vala"
								_data_->folder = _data_->_tmp61_;
#line 628 "../src/client/application/application-client.vala"
								if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3499 "application-client.c"
									goto __catch1_g_error;
								}
#line 630 "../src/client/application/application-client.vala"
								_data_->_tmp62_ = _data_->folder;
#line 630 "../src/client/application/application-client.vala"
								_data_->_tmp63_ = geary_folder_get_used_as (_data_->_tmp62_);
#line 630 "../src/client/application/application-client.vala"
								_data_->_tmp64_ = _data_->_tmp63_;
#line 630 "../src/client/application/application-client.vala"
								if (_data_->_tmp64_ == GEARY_FOLDER_SPECIAL_USE_INBOX) {
#line 631 "../src/client/application/application-client.vala"
									_data_->_tmp65_ = _data_->folder;
#line 631 "../src/client/application/application-client.vala"
									_data_->_tmp66_ = _g_object_ref0 (_data_->_tmp65_);
#line 631 "../src/client/application/application-client.vala"
									_g_object_unref0 (_data_->selected);
#line 631 "../src/client/application/application-client.vala"
									_data_->selected = _data_->_tmp66_;
#line 632 "../src/client/application/application-client.vala"
									_g_object_unref0 (_data_->folder);
#line 632 "../src/client/application/application-client.vala"
									_g_object_unref0 (_data_->path);
#line 632 "../src/client/application/application-client.vala"
									break;
#line 3524 "application-client.c"
								}
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->folder);
#line 3528 "application-client.c"
							}
							goto __finally1;
							__catch1_g_error:
							{
#line 627 "../src/client/application/application-client.vala"
								_data_->_vala1_err = _data_->_inner_error0_;
#line 627 "../src/client/application/application-client.vala"
								_data_->_inner_error0_ = NULL;
#line 635 "../src/client/application/application-client.vala"
								_data_->_tmp67_ = _data_->_vala1_err;
#line 635 "../src/client/application/application-client.vala"
								_data_->_tmp68_ = _data_->_tmp67_->message;
#line 635 "../src/client/application/application-client.vala"
								g_warning ("application-client.vala:635: Error getting folder for email: %s", _data_->_tmp68_);
#line 627 "../src/client/application/application-client.vala"
								_g_error_free0 (_data_->_vala1_err);
#line 3545 "application-client.c"
							}
							__finally1:
#line 627 "../src/client/application/application-client.vala"
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->path);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->_path_it);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->selected);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->paths);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->folders);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->email_id);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->context);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->email);
#line 627 "../src/client/application/application-client.vala"
								_g_object_unref0 (_data_->main);
#line 627 "../src/client/application/application-client.vala"
								g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 627 "../src/client/application/application-client.vala"
								g_clear_error (&_data_->_inner_error0_);
#line 627 "../src/client/application/application-client.vala"
								g_object_unref (_data_->_async_result);
#line 627 "../src/client/application/application-client.vala"
								return FALSE;
#line 3576 "application-client.c"
							}
#line 626 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->path);
#line 3580 "application-client.c"
						}
#line 626 "../src/client/application/application-client.vala"
						_g_object_unref0 (_data_->_path_it);
#line 3584 "application-client.c"
					}
#line 642 "../src/client/application/application-client.vala"
					_data_->_tmp70_ = _data_->selected;
#line 642 "../src/client/application/application-client.vala"
					if (_data_->_tmp70_ == NULL) {
#line 642 "../src/client/application/application-client.vala"
						_data_->_tmp71_ = _data_->paths;
#line 642 "../src/client/application/application-client.vala"
						_data_->_tmp72_ = gee_collection_get_is_empty (_data_->_tmp71_);
#line 642 "../src/client/application/application-client.vala"
						_data_->_tmp73_ = _data_->_tmp72_;
#line 642 "../src/client/application/application-client.vala"
						_data_->_tmp69_ = !_data_->_tmp73_;
#line 3598 "application-client.c"
					} else {
#line 642 "../src/client/application/application-client.vala"
						_data_->_tmp69_ = FALSE;
#line 3602 "application-client.c"
					}
#line 642 "../src/client/application/application-client.vala"
					if (_data_->_tmp69_) {
#line 3606 "application-client.c"
						{
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp75_ = _data_->context;
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp76_ = application_account_context_get_account (_data_->_tmp75_);
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp77_ = _data_->_tmp76_;
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp78_ = _data_->paths;
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp79_ = geary_collection_first (GEARY_TYPE_FOLDER_PATH, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp78_);
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp80_ = (GearyFolderPath*) _data_->_tmp79_;
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp81_ = geary_account_get_folder (_data_->_tmp77_, _data_->_tmp80_, &_data_->_inner_error0_);
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp82_ = _data_->_tmp81_;
#line 644 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->_tmp80_);
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp74_ = _data_->_tmp82_;
#line 644 "../src/client/application/application-client.vala"
							if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3630 "application-client.c"
								goto __catch2_g_error;
							}
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp83_ = _data_->_tmp74_;
#line 644 "../src/client/application/application-client.vala"
							_data_->_tmp74_ = NULL;
#line 644 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->selected);
#line 644 "../src/client/application/application-client.vala"
							_data_->selected = _data_->_tmp83_;
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->_tmp74_);
#line 3643 "application-client.c"
						}
						goto __finally2;
						__catch2_g_error:
						{
#line 643 "../src/client/application/application-client.vala"
							_data_->_vala2_err = _data_->_inner_error0_;
#line 643 "../src/client/application/application-client.vala"
							_data_->_inner_error0_ = NULL;
#line 648 "../src/client/application/application-client.vala"
							_data_->_tmp84_ = _data_->_vala2_err;
#line 648 "../src/client/application/application-client.vala"
							_data_->_tmp85_ = _data_->_tmp84_->message;
#line 648 "../src/client/application/application-client.vala"
							g_warning ("application-client.vala:648: Error getting folder for email: %s", _data_->_tmp85_);
#line 643 "../src/client/application/application-client.vala"
							_g_error_free0 (_data_->_vala2_err);
#line 3660 "application-client.c"
						}
						__finally2:
#line 643 "../src/client/application/application-client.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->selected);
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->paths);
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->folders);
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->email_id);
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->context);
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->email);
#line 643 "../src/client/application/application-client.vala"
							_g_object_unref0 (_data_->main);
#line 643 "../src/client/application/application-client.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 643 "../src/client/application/application-client.vala"
							g_clear_error (&_data_->_inner_error0_);
#line 643 "../src/client/application/application-client.vala"
							g_object_unref (_data_->_async_result);
#line 643 "../src/client/application/application-client.vala"
							return FALSE;
#line 3687 "application-client.c"
						}
					}
				}
#line 656 "../src/client/application/application-client.vala"
				_data_->_tmp86_ = _data_->selected;
#line 656 "../src/client/application/application-client.vala"
				if (_data_->_tmp86_ != NULL) {
#line 657 "../src/client/application/application-client.vala"
					_data_->_tmp87_ = _data_->main;
#line 657 "../src/client/application/application-client.vala"
					_data_->_tmp88_ = _data_->selected;
#line 657 "../src/client/application/application-client.vala"
					_data_->_tmp89_ = _data_->email_id;
#line 657 "../src/client/application/application-client.vala"
					_data_->_tmp90_ = geary_collection_single (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp89_);
#line 657 "../src/client/application/application-client.vala"
					_data_->_tmp91_ = _data_->_tmp90_;
#line 657 "../src/client/application/application-client.vala"
					_data_->_state_ = 3;
#line 657 "../src/client/application/application-client.vala"
					application_main_window_show_email (_data_->_tmp87_, _data_->_tmp88_, _data_->_tmp91_, TRUE, application_client_show_email_ready, _data_);
#line 657 "../src/client/application/application-client.vala"
					return FALSE;
#line 3711 "application-client.c"
					_state_3:
#line 657 "../src/client/application/application-client.vala"
					application_main_window_show_email_finish (_data_->_tmp87_, _data_->_res_);
#line 657 "../src/client/application/application-client.vala"
					_g_object_unref0 (_data_->_tmp91_);
#line 3717 "application-client.c"
				}
#line 614 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->selected);
#line 614 "../src/client/application/application-client.vala"
				_g_object_unref0 (_data_->paths);
#line 3723 "application-client.c"
			}
#line 603 "../src/client/application/application-client.vala"
			_g_object_unref0 (_data_->folders);
#line 3727 "application-client.c"
		}
#line 598 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->email_id);
#line 598 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->context);
#line 598 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->email);
#line 3735 "application-client.c"
	}
#line 596 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->main);
#line 596 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 596 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 596 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 596 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3747 "application-client.c"
		}
	}
#line 596 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 596 "../src/client/application/application-client.vala"
	return FALSE;
#line 3754 "application-client.c"
}

static void
application_client_show_folder_data_free (gpointer _data)
{
	ApplicationClientShowFolderData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_variant_unref0 (_data_->id);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowFolderData, _data_);
#line 3768 "application-client.c"
}

void
application_client_show_folder (ApplicationClient* self,
                                GVariant* id,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	ApplicationClientShowFolderData* _data_;
	ApplicationClient* _tmp0_;
	GVariant* _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowFolderData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_folder_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	_tmp1_ = _g_variant_ref0 (id);
#line 27 "../src/client/application/application-client.vala"
	_g_variant_unref0 (_data_->id);
#line 27 "../src/client/application/application-client.vala"
	_data_->id = _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_folder_co (_data_);
#line 3800 "application-client.c"
}

void
application_client_show_folder_finish (ApplicationClient* self,
                                       GAsyncResult* _res_)
{
	ApplicationClientShowFolderData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3810 "application-client.c"
}

/**
     * Selects a specific folder in a main window.
     *
     * This method is invoked by the application `show-folder` action.
     *
     * The folder is identified by the given variant, which can be
     * obtained by calling {@link Plugin.Folder.to_variant}.
     */
static void
application_client_show_folder_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	ApplicationClientShowFolderData* _data_;
#line 677 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 677 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 677 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 677 "../src/client/application/application-client.vala"
	application_client_show_folder_co (_data_);
#line 3835 "application-client.c"
}

static gboolean
application_client_show_folder_co (ApplicationClientShowFolderData* _data_)
{
#line 676 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 676 "../src/client/application/application-client.vala"
		case 0:
#line 3845 "application-client.c"
		goto _state_0;
#line 676 "../src/client/application/application-client.vala"
		case 1:
#line 3849 "application-client.c"
		goto _state_1;
#line 676 "../src/client/application/application-client.vala"
		case 2:
#line 3853 "application-client.c"
		goto _state_2;
		default:
#line 676 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 3858 "application-client.c"
	}
	_state_0:
#line 677 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 677 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_show_folder_ready, _data_);
#line 677 "../src/client/application/application-client.vala"
	return FALSE;
#line 3867 "application-client.c"
	_state_1:
#line 677 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 677 "../src/client/application/application-client.vala"
	_data_->main = _data_->_tmp0_;
#line 678 "../src/client/application/application-client.vala"
	if (_data_->id != NULL) {
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp1_ = _data_->self->priv->_controller;
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp2_ = application_controller_get_plugins (_data_->_tmp1_);
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp4_ = application_plugin_manager_get_globals (_data_->_tmp3_);
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp6_ = application_plugin_manager_plugin_globals_get_folders (_data_->_tmp5_);
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 679 "../src/client/application/application-client.vala"
		_data_->_tmp8_ = application_folder_store_factory_get_folder_for_variant (_data_->_tmp7_, _data_->id);
#line 679 "../src/client/application/application-client.vala"
		_data_->folder = _data_->_tmp8_;
#line 681 "../src/client/application/application-client.vala"
		_data_->_tmp9_ = _data_->folder;
#line 681 "../src/client/application/application-client.vala"
		if (_data_->_tmp9_ != NULL) {
#line 682 "../src/client/application/application-client.vala"
			_data_->_tmp10_ = _data_->main;
#line 682 "../src/client/application/application-client.vala"
			_data_->_tmp11_ = _data_->folder;
#line 682 "../src/client/application/application-client.vala"
			_data_->_state_ = 2;
#line 682 "../src/client/application/application-client.vala"
			application_main_window_select_folder (_data_->_tmp10_, _data_->_tmp11_, TRUE, FALSE, application_client_show_folder_ready, _data_);
#line 682 "../src/client/application/application-client.vala"
			return FALSE;
#line 3907 "application-client.c"
			_state_2:
#line 682 "../src/client/application/application-client.vala"
			application_main_window_select_folder_finish (_data_->_tmp10_, _data_->_res_);
#line 3911 "application-client.c"
		}
#line 678 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->folder);
#line 3915 "application-client.c"
	}
#line 676 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->main);
#line 676 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 676 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 676 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 676 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3927 "application-client.c"
		}
	}
#line 676 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 676 "../src/client/application/application-client.vala"
	return FALSE;
#line 3934 "application-client.c"
}

static void
application_client_show_inspector_data_free (gpointer _data)
{
	ApplicationClientShowInspectorData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowInspectorData, _data_);
#line 3946 "application-client.c"
}

void
application_client_show_inspector (ApplicationClient* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	ApplicationClientShowInspectorData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowInspectorData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_inspector_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_inspector_co (_data_);
#line 3970 "application-client.c"
}

void
application_client_show_inspector_finish (ApplicationClient* self,
                                          GAsyncResult* _res_)
{
	ApplicationClientShowInspectorData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3980 "application-client.c"
}

static void
application_client_show_inspector_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	ApplicationClientShowInspectorData* _data_;
#line 688 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 688 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 688 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 688 "../src/client/application/application-client.vala"
	application_client_show_inspector_co (_data_);
#line 3997 "application-client.c"
}

static void
___lambda160_ (ApplicationClient* self)
{
#line 693 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->inspector);
#line 693 "../src/client/application/application-client.vala"
	self->priv->inspector = NULL;
#line 4007 "application-client.c"
}

static void
____lambda160__gtk_widget_destroy (GtkWidget* _sender,
                                   gpointer self)
{
#line 692 "../src/client/application/application-client.vala"
	___lambda160_ ((ApplicationClient*) self);
#line 4016 "application-client.c"
}

static gboolean
application_client_show_inspector_co (ApplicationClientShowInspectorData* _data_)
{
#line 687 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 687 "../src/client/application/application-client.vala"
		case 0:
#line 4026 "application-client.c"
		goto _state_0;
#line 687 "../src/client/application/application-client.vala"
		case 1:
#line 4030 "application-client.c"
		goto _state_1;
		default:
#line 687 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 4035 "application-client.c"
	}
	_state_0:
#line 688 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 688 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_show_inspector_ready, _data_);
#line 688 "../src/client/application/application-client.vala"
	return FALSE;
#line 4044 "application-client.c"
	_state_1:
#line 688 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 688 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 688 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 690 "../src/client/application/application-client.vala"
	_data_->_tmp2_ = _data_->self->priv->inspector;
#line 690 "../src/client/application/application-client.vala"
	if (_data_->_tmp2_ == NULL) {
#line 691 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = components_inspector_new (_data_->self);
#line 691 "../src/client/application/application-client.vala"
		g_object_ref_sink (_data_->_tmp3_);
#line 691 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->self->priv->inspector);
#line 691 "../src/client/application/application-client.vala"
		_data_->self->priv->inspector = _data_->_tmp3_;
#line 692 "../src/client/application/application-client.vala"
		_data_->_tmp4_ = _data_->self->priv->inspector;
#line 692 "../src/client/application/application-client.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, gtk_widget_get_type (), GtkWidget), "destroy", (GCallback) ____lambda160__gtk_widget_destroy, _data_->self, 0);
#line 698 "../src/client/application/application-client.vala"
		_data_->_tmp5_ = gtk_window_group_new ();
#line 698 "../src/client/application/application-client.vala"
		_data_->group = _data_->_tmp5_;
#line 699 "../src/client/application/application-client.vala"
		_data_->_tmp6_ = _data_->group;
#line 699 "../src/client/application/application-client.vala"
		_data_->_tmp7_ = _data_->self->priv->inspector;
#line 699 "../src/client/application/application-client.vala"
		gtk_window_group_add_window (_data_->_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, gtk_window_get_type (), GtkWindow));
#line 701 "../src/client/application/application-client.vala"
		_data_->_tmp8_ = _data_->self->priv->inspector;
#line 701 "../src/client/application/application-client.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 690 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->group);
#line 4084 "application-client.c"
	} else {
#line 703 "../src/client/application/application-client.vala"
		_data_->_tmp9_ = _data_->self->priv->inspector;
#line 703 "../src/client/application/application-client.vala"
		gtk_window_present (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, gtk_window_get_type (), GtkWindow));
#line 4090 "application-client.c"
	}
#line 687 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 687 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 687 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 687 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4100 "application-client.c"
		}
	}
#line 687 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 687 "../src/client/application/application-client.vala"
	return FALSE;
#line 4107 "application-client.c"
}

static void
application_client_show_preferences_data_free (gpointer _data)
{
	ApplicationClientShowPreferencesData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowPreferencesData, _data_);
#line 4119 "application-client.c"
}

void
application_client_show_preferences (ApplicationClient* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	ApplicationClientShowPreferencesData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowPreferencesData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_preferences_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_preferences_co (_data_);
#line 4143 "application-client.c"
}

void
application_client_show_preferences_finish (ApplicationClient* self,
                                            GAsyncResult* _res_)
{
	ApplicationClientShowPreferencesData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4153 "application-client.c"
}

static void
application_client_show_preferences_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	ApplicationClientShowPreferencesData* _data_;
#line 708 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 708 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 708 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 708 "../src/client/application/application-client.vala"
	application_client_show_preferences_co (_data_);
#line 4170 "application-client.c"
}

static gboolean
application_client_show_preferences_co (ApplicationClientShowPreferencesData* _data_)
{
#line 707 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 707 "../src/client/application/application-client.vala"
		case 0:
#line 4180 "application-client.c"
		goto _state_0;
#line 707 "../src/client/application/application-client.vala"
		case 1:
#line 4184 "application-client.c"
		goto _state_1;
		default:
#line 707 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 4189 "application-client.c"
	}
	_state_0:
#line 708 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 708 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_show_preferences_ready, _data_);
#line 708 "../src/client/application/application-client.vala"
	return FALSE;
#line 4198 "application-client.c"
	_state_1:
#line 708 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 708 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 708 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp2_ = application_client_get_active_main_window (_data_->self);
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp4_ = _data_->self->priv->_controller;
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp5_ = application_controller_get_plugins (_data_->_tmp4_);
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp7_ = components_preferences_window_new (_data_->_tmp3_, _data_->_tmp6_);
#line 710 "../src/client/application/application-client.vala"
	g_object_ref_sink (_data_->_tmp7_);
#line 710 "../src/client/application/application-client.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 710 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 710 "../src/client/application/application-client.vala"
	_data_->prefs = _data_->_tmp8_;
#line 714 "../src/client/application/application-client.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_data_->prefs, gtk_widget_get_type (), GtkWidget));
#line 707 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->prefs);
#line 707 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 707 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 707 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 707 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4238 "application-client.c"
		}
	}
#line 707 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 707 "../src/client/application/application-client.vala"
	return FALSE;
#line 4245 "application-client.c"
}

static void
application_client_new_composer_data_free (gpointer _data)
{
	ApplicationClientNewComposerData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->to);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientNewComposerData, _data_);
#line 4259 "application-client.c"
}

void
application_client_new_composer (ApplicationClient* self,
                                 GearyRFC822MailboxAddress* to,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	ApplicationClientNewComposerData* _data_;
	ApplicationClient* _tmp0_;
	GearyRFC822MailboxAddress* _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail ((to == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (to, GEARY_RF_C822_TYPE_MAILBOX_ADDRESS));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientNewComposerData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_new_composer_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	_tmp1_ = _g_object_ref0 (to);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->to);
#line 27 "../src/client/application/application-client.vala"
	_data_->to = _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	application_client_new_composer_co (_data_);
#line 4293 "application-client.c"
}

void
application_client_new_composer_finish (ApplicationClient* self,
                                        GAsyncResult* _res_)
{
	ApplicationClientNewComposerData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4303 "application-client.c"
}

static void
application_client_new_composer_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	ApplicationClientNewComposerData* _data_;
#line 718 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 718 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 718 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 718 "../src/client/application/application-client.vala"
	application_client_new_composer_co (_data_);
#line 4320 "application-client.c"
}

static gboolean
application_client_new_composer_co (ApplicationClientNewComposerData* _data_)
{
#line 717 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 717 "../src/client/application/application-client.vala"
		case 0:
#line 4330 "application-client.c"
		goto _state_0;
#line 717 "../src/client/application/application-client.vala"
		case 1:
#line 4334 "application-client.c"
		goto _state_1;
#line 717 "../src/client/application/application-client.vala"
		case 2:
#line 4338 "application-client.c"
		goto _state_2;
		default:
#line 717 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 4343 "application-client.c"
	}
	_state_0:
#line 718 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 718 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_new_composer_ready, _data_);
#line 718 "../src/client/application/application-client.vala"
	return FALSE;
#line 4352 "application-client.c"
	_state_1:
#line 718 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 718 "../src/client/application/application-client.vala"
	_data_->main = _data_->_tmp0_;
#line 719 "../src/client/application/application-client.vala"
	_data_->account = NULL;
#line 720 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->main;
#line 720 "../src/client/application/application-client.vala"
	_data_->_tmp2_ = application_main_window_get_selected_account (_data_->_tmp1_);
#line 720 "../src/client/application/application-client.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 720 "../src/client/application/application-client.vala"
	if (_data_->_tmp3_ != NULL) {
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp4_ = _data_->self->priv->_controller;
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp5_ = _data_->main;
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp6_ = application_main_window_get_selected_account (_data_->_tmp5_);
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp8_ = geary_account_get_information (_data_->_tmp7_);
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 721 "../src/client/application/application-client.vala"
		_data_->_tmp10_ = application_account_interface_get_context_for_account (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface), _data_->_tmp9_);
#line 721 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->account);
#line 721 "../src/client/application/application-client.vala"
		_data_->account = _data_->_tmp10_;
#line 4386 "application-client.c"
	}
#line 725 "../src/client/application/application-client.vala"
	_data_->_tmp11_ = _data_->account;
#line 725 "../src/client/application/application-client.vala"
	if (_data_->_tmp11_ == NULL) {
#line 726 "../src/client/application/application-client.vala"
		_data_->_tmp12_ = _data_->self->priv->_controller;
#line 726 "../src/client/application/application-client.vala"
		_data_->_tmp13_ = application_account_interface_get_account_contexts (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, APPLICATION_TYPE_ACCOUNT_INTERFACE, ApplicationAccountInterface));
#line 726 "../src/client/application/application-client.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 726 "../src/client/application/application-client.vala"
		_data_->_tmp15_ = geary_collection_first (APPLICATION_TYPE_ACCOUNT_CONTEXT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _data_->_tmp14_);
#line 726 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->account);
#line 726 "../src/client/application/application-client.vala"
		_data_->account = (ApplicationAccountContext*) _data_->_tmp15_;
#line 726 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->_tmp14_);
#line 4406 "application-client.c"
	}
#line 730 "../src/client/application/application-client.vala"
	_data_->_tmp16_ = _data_->account;
#line 730 "../src/client/application/application-client.vala"
	if (_data_->_tmp16_ != NULL) {
#line 731 "../src/client/application/application-client.vala"
		_data_->_tmp17_ = _data_->self->priv->_controller;
#line 731 "../src/client/application/application-client.vala"
		_data_->_tmp18_ = _data_->account;
#line 731 "../src/client/application/application-client.vala"
		_data_->_state_ = 2;
#line 731 "../src/client/application/application-client.vala"
		application_controller_compose_blank (_data_->_tmp17_, _data_->_tmp18_, _data_->to, application_client_new_composer_ready, _data_);
#line 731 "../src/client/application/application-client.vala"
		return FALSE;
#line 4422 "application-client.c"
		_state_2:
#line 731 "../src/client/application/application-client.vala"
		_data_->_tmp19_ = application_controller_compose_blank_finish (_data_->_tmp17_, _data_->_res_);
#line 731 "../src/client/application/application-client.vala"
		_data_->composer = _data_->_tmp19_;
#line 735 "../src/client/application/application-client.vala"
		_data_->_tmp20_ = _data_->self->priv->_controller;
#line 735 "../src/client/application/application-client.vala"
		_data_->_tmp21_ = _data_->composer;
#line 735 "../src/client/application/application-client.vala"
		application_controller_present_composer (_data_->_tmp20_, _data_->_tmp21_);
#line 730 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->composer);
#line 4436 "application-client.c"
	}
#line 717 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->account);
#line 717 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->main);
#line 717 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 717 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 717 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 717 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4450 "application-client.c"
		}
	}
#line 717 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 717 "../src/client/application/application-client.vala"
	return FALSE;
#line 4457 "application-client.c"
}

static void
application_client_new_composer_mailto_data_free (gpointer _data)
{
	ApplicationClientNewComposerMailtoData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_free0 (_data_->mailto);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientNewComposerMailtoData, _data_);
#line 4471 "application-client.c"
}

void
application_client_new_composer_mailto (ApplicationClient* self,
                                        const gchar* mailto,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
	ApplicationClientNewComposerMailtoData* _data_;
	ApplicationClient* _tmp0_;
	gchar* _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientNewComposerMailtoData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_new_composer_mailto_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	_tmp1_ = g_strdup (mailto);
#line 27 "../src/client/application/application-client.vala"
	_g_free0 (_data_->mailto);
#line 27 "../src/client/application/application-client.vala"
	_data_->mailto = _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	application_client_new_composer_mailto_co (_data_);
#line 4503 "application-client.c"
}

void
application_client_new_composer_mailto_finish (ApplicationClient* self,
                                               GAsyncResult* _res_)
{
	ApplicationClientNewComposerMailtoData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4513 "application-client.c"
}

static void
application_client_new_composer_mailto_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_)
{
	ApplicationClientNewComposerMailtoData* _data_;
#line 740 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 740 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 740 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 740 "../src/client/application/application-client.vala"
	application_client_new_composer_mailto_co (_data_);
#line 4530 "application-client.c"
}

static gboolean
application_client_new_composer_mailto_co (ApplicationClientNewComposerMailtoData* _data_)
{
#line 739 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 739 "../src/client/application/application-client.vala"
		case 0:
#line 4540 "application-client.c"
		goto _state_0;
#line 739 "../src/client/application/application-client.vala"
		case 1:
#line 4544 "application-client.c"
		goto _state_1;
#line 739 "../src/client/application/application-client.vala"
		case 2:
#line 4548 "application-client.c"
		goto _state_2;
		default:
#line 739 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 4553 "application-client.c"
	}
	_state_0:
#line 740 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 740 "../src/client/application/application-client.vala"
	application_client_present (_data_->self, application_client_new_composer_mailto_ready, _data_);
#line 740 "../src/client/application/application-client.vala"
	return FALSE;
#line 4562 "application-client.c"
	_state_1:
#line 740 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_present_finish (_data_->self, _data_->_res_);
#line 740 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 740 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 741 "../src/client/application/application-client.vala"
	_data_->_tmp2_ = _data_->self->priv->_controller;
#line 741 "../src/client/application/application-client.vala"
	_data_->_state_ = 2;
#line 741 "../src/client/application/application-client.vala"
	application_controller_compose_mailto (_data_->_tmp2_, _data_->mailto, application_client_new_composer_mailto_ready, _data_);
#line 741 "../src/client/application/application-client.vala"
	return FALSE;
#line 4578 "application-client.c"
	_state_2:
#line 741 "../src/client/application/application-client.vala"
	application_controller_compose_mailto_finish (_data_->_tmp2_, _data_->_res_);
#line 739 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 739 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 739 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 739 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4590 "application-client.c"
		}
	}
#line 739 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 739 "../src/client/application/application-client.vala"
	return FALSE;
#line 4597 "application-client.c"
}

static void
application_client_new_window_data_free (gpointer _data)
{
	ApplicationClientNewWindowData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->select_folder);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->select_conversations);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientNewWindowData, _data_);
#line 4613 "application-client.c"
}

void
application_client_new_window (ApplicationClient* self,
                               GearyFolder* select_folder,
                               GeeCollection* select_conversations,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	ApplicationClientNewWindowData* _data_;
	ApplicationClient* _tmp0_;
	GearyFolder* _tmp1_;
	GeeCollection* _tmp2_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail ((select_folder == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (select_folder, GEARY_TYPE_FOLDER));
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail ((select_conversations == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (select_conversations, GEE_TYPE_COLLECTION));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientNewWindowData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_new_window_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	_tmp1_ = _g_object_ref0 (select_folder);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->select_folder);
#line 27 "../src/client/application/application-client.vala"
	_data_->select_folder = _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	_tmp2_ = _g_object_ref0 (select_conversations);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->select_conversations);
#line 27 "../src/client/application/application-client.vala"
	_data_->select_conversations = _tmp2_;
#line 27 "../src/client/application/application-client.vala"
	application_client_new_window_co (_data_);
#line 4657 "application-client.c"
}

void
application_client_new_window_finish (ApplicationClient* self,
                                      GAsyncResult* _res_)
{
	ApplicationClientNewWindowData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4667 "application-client.c"
}

static void
application_client_new_window_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	ApplicationClientNewWindowData* _data_;
#line 746 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 746 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 746 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 746 "../src/client/application/application-client.vala"
	application_client_new_window_co (_data_);
#line 4684 "application-client.c"
}

static gboolean
application_client_new_window_co (ApplicationClientNewWindowData* _data_)
{
#line 744 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 744 "../src/client/application/application-client.vala"
		case 0:
#line 4694 "application-client.c"
		goto _state_0;
#line 744 "../src/client/application/application-client.vala"
		case 1:
#line 4698 "application-client.c"
		goto _state_1;
		default:
#line 744 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 4703 "application-client.c"
	}
	_state_0:
#line 746 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 746 "../src/client/application/application-client.vala"
	application_client_create_controller (_data_->self, application_client_new_window_ready, _data_);
#line 746 "../src/client/application/application-client.vala"
	return FALSE;
#line 4712 "application-client.c"
	_state_1:
#line 746 "../src/client/application/application-client.vala"
	application_client_create_controller_finish (_data_->self, _data_->_res_);
#line 749 "../src/client/application/application-client.vala"
	if (_data_->select_folder != NULL) {
#line 750 "../src/client/application/application-client.vala"
		_data_->_tmp1_ = _data_->select_conversations != NULL;
#line 4720 "application-client.c"
	} else {
#line 749 "../src/client/application/application-client.vala"
		_data_->_tmp1_ = FALSE;
#line 4724 "application-client.c"
	}
#line 748 "../src/client/application/application-client.vala"
	if (_data_->_tmp1_) {
#line 751 "../src/client/application/application-client.vala"
		_data_->_tmp2_ = gee_collection_get_is_empty (_data_->select_conversations);
#line 751 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 751 "../src/client/application/application-client.vala"
		_data_->_tmp0_ = !_data_->_tmp3_;
#line 4734 "application-client.c"
	} else {
#line 749 "../src/client/application/application-client.vala"
		_data_->_tmp0_ = FALSE;
#line 4738 "application-client.c"
	}
#line 748 "../src/client/application/application-client.vala"
	_data_->do_select = _data_->_tmp0_;
#line 754 "../src/client/application/application-client.vala"
	_data_->_tmp4_ = application_client_new_main_window (_data_->self, !_data_->do_select);
#line 754 "../src/client/application/application-client.vala"
	_data_->main = _data_->_tmp4_;
#line 755 "../src/client/application/application-client.vala"
	_data_->_tmp5_ = _data_->main;
#line 755 "../src/client/application/application-client.vala"
	gtk_window_present (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, gtk_window_get_type (), GtkWindow));
#line 757 "../src/client/application/application-client.vala"
	if (_data_->do_select) {
#line 758 "../src/client/application/application-client.vala"
		if (_data_->select_conversations == NULL) {
#line 758 "../src/client/application/application-client.vala"
			_data_->_tmp6_ = TRUE;
#line 4756 "application-client.c"
		} else {
#line 758 "../src/client/application/application-client.vala"
			_data_->_tmp7_ = gee_collection_get_is_empty (_data_->select_conversations);
#line 758 "../src/client/application/application-client.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 758 "../src/client/application/application-client.vala"
			_data_->_tmp6_ = _data_->_tmp8_;
#line 4764 "application-client.c"
		}
#line 758 "../src/client/application/application-client.vala"
		if (_data_->_tmp6_) {
#line 759 "../src/client/application/application-client.vala"
			_data_->_tmp9_ = _data_->main;
#line 759 "../src/client/application/application-client.vala"
			application_main_window_select_folder (_data_->_tmp9_, _data_->select_folder, TRUE, FALSE, NULL, NULL);
#line 4772 "application-client.c"
		} else {
#line 761 "../src/client/application/application-client.vala"
			_data_->_tmp10_ = _data_->main;
#line 761 "../src/client/application/application-client.vala"
			application_main_window_show_conversations (_data_->_tmp10_, _data_->select_folder, _data_->select_conversations, TRUE, NULL, NULL);
#line 4778 "application-client.c"
		}
	}
#line 744 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->main);
#line 744 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 744 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 744 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 744 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4791 "application-client.c"
		}
	}
#line 744 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 744 "../src/client/application/application-client.vala"
	return FALSE;
#line 4798 "application-client.c"
}

/** Returns the application's base home configuration directory. */
GFile*
application_client_get_home_config_directory (ApplicationClient* self)
{
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* result;
#line 771 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 772 "../src/client/application/application-client.vala"
	_tmp0_ = g_get_user_config_dir ();
#line 772 "../src/client/application/application-client.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 772 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 772 "../src/client/application/application-client.vala"
	_tmp3_ = application_client_get_geary_home_dir_name (self);
#line 772 "../src/client/application/application-client.vala"
	_tmp4_ = _tmp3_;
#line 772 "../src/client/application/application-client.vala"
	_tmp5_ = g_file_get_child (_tmp2_, _tmp4_);
#line 772 "../src/client/application/application-client.vala"
	_tmp6_ = _tmp5_;
#line 772 "../src/client/application/application-client.vala"
	_g_free0 (_tmp4_);
#line 772 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp2_);
#line 772 "../src/client/application/application-client.vala"
	result = _tmp6_;
#line 772 "../src/client/application/application-client.vala"
	return result;
#line 4837 "application-client.c"
}

/** Returns the application's base home cache directory. */
GFile*
application_client_get_home_cache_directory (ApplicationClient* self)
{
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* result;
#line 778 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 779 "../src/client/application/application-client.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 779 "../src/client/application/application-client.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 779 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 779 "../src/client/application/application-client.vala"
	_tmp3_ = application_client_get_geary_home_dir_name (self);
#line 779 "../src/client/application/application-client.vala"
	_tmp4_ = _tmp3_;
#line 779 "../src/client/application/application-client.vala"
	_tmp5_ = g_file_get_child (_tmp2_, _tmp4_);
#line 779 "../src/client/application/application-client.vala"
	_tmp6_ = _tmp5_;
#line 779 "../src/client/application/application-client.vala"
	_g_free0 (_tmp4_);
#line 779 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp2_);
#line 779 "../src/client/application/application-client.vala"
	result = _tmp6_;
#line 779 "../src/client/application/application-client.vala"
	return result;
#line 4876 "application-client.c"
}

/** Returns the application's base home data directory. */
GFile*
application_client_get_home_data_directory (ApplicationClient* self)
{
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* result;
#line 785 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 786 "../src/client/application/application-client.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 786 "../src/client/application/application-client.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 786 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 786 "../src/client/application/application-client.vala"
	_tmp3_ = application_client_get_geary_home_dir_name (self);
#line 786 "../src/client/application/application-client.vala"
	_tmp4_ = _tmp3_;
#line 786 "../src/client/application/application-client.vala"
	_tmp5_ = g_file_get_child (_tmp2_, _tmp4_);
#line 786 "../src/client/application/application-client.vala"
	_tmp6_ = _tmp5_;
#line 786 "../src/client/application/application-client.vala"
	_g_free0 (_tmp4_);
#line 786 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp2_);
#line 786 "../src/client/application/application-client.vala"
	result = _tmp6_;
#line 786 "../src/client/application/application-client.vala"
	return result;
#line 4915 "application-client.c"
}

/** Returns the application's base static resources directory. */
GFile*
application_client_get_resource_directory (ApplicationClient* self)
{
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* result;
#line 792 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 793 "../src/client/application/application-client.vala"
	_tmp1_ = application_client_get_is_installed (self);
#line 793 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 793 "../src/client/application/application-client.vala"
	if (_tmp2_) {
#line 4934 "application-client.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 794 "../src/client/application/application-client.vala"
		_tmp3_ = self->priv->_install_prefix;
#line 794 "../src/client/application/application-client.vala"
		_tmp4_ = g_file_get_child (_tmp3_, "share");
#line 794 "../src/client/application/application-client.vala"
		_tmp5_ = _tmp4_;
#line 794 "../src/client/application/application-client.vala"
		_tmp6_ = g_file_get_child (_tmp5_, "geary");
#line 794 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 794 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp6_;
#line 794 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp5_);
#line 4953 "application-client.c"
	} else {
		GFile* _tmp7_;
#line 795 "../src/client/application/application-client.vala"
		_tmp7_ = g_file_new_for_path (APPLICATION_CLIENT_SOURCE_ROOT_DIR);
#line 795 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 795 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp7_;
#line 4962 "application-client.c"
	}
#line 793 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 793 "../src/client/application/application-client.vala"
	return result;
#line 4968 "application-client.c"
}

/** Returns the location of the application's desktop files. */
GFile*
application_client_get_desktop_directory (ApplicationClient* self)
{
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* result;
#line 799 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 800 "../src/client/application/application-client.vala"
	_tmp1_ = application_client_get_is_installed (self);
#line 800 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 800 "../src/client/application/application-client.vala"
	if (_tmp2_) {
#line 4987 "application-client.c"
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 801 "../src/client/application/application-client.vala"
		_tmp3_ = self->priv->_install_prefix;
#line 801 "../src/client/application/application-client.vala"
		_tmp4_ = g_file_get_child (_tmp3_, "share");
#line 801 "../src/client/application/application-client.vala"
		_tmp5_ = _tmp4_;
#line 801 "../src/client/application/application-client.vala"
		_tmp6_ = g_file_get_child (_tmp5_, "applications");
#line 801 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 801 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp6_;
#line 801 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp5_);
#line 5006 "application-client.c"
	} else {
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
#line 802 "../src/client/application/application-client.vala"
		_tmp7_ = g_file_new_for_path (APPLICATION_CLIENT_BUILD_ROOT_DIR);
#line 802 "../src/client/application/application-client.vala"
		_tmp8_ = _tmp7_;
#line 802 "../src/client/application/application-client.vala"
		_tmp9_ = g_file_get_child (_tmp8_, "desktop");
#line 802 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 802 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp9_;
#line 802 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp8_);
#line 5023 "application-client.c"
	}
#line 800 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 800 "../src/client/application/application-client.vala"
	return result;
#line 5029 "application-client.c"
}

/**
     * Returns the directory containing the application's WebExtension libs.
     *
     * When running from the installation prefix, this will be based
     * on the Meson `libdir` option, and can be set by invoking `meson
     * configure` as appropriate.
     */
GFile*
application_client_get_web_extensions_dir (ApplicationClient* self)
{
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* result;
#line 812 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 813 "../src/client/application/application-client.vala"
	_tmp1_ = application_client_get_is_installed (self);
#line 813 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 813 "../src/client/application/application-client.vala"
	if (_tmp2_) {
#line 5054 "application-client.c"
		GFile* _tmp3_;
#line 814 "../src/client/application/application-client.vala"
		_tmp3_ = g_file_new_for_path (_WEB_EXTENSIONS_DIR);
#line 814 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 814 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp3_;
#line 5062 "application-client.c"
	} else {
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 815 "../src/client/application/application-client.vala"
		_tmp4_ = g_file_new_for_path (APPLICATION_CLIENT_BUILD_ROOT_DIR);
#line 815 "../src/client/application/application-client.vala"
		_tmp5_ = _tmp4_;
#line 815 "../src/client/application/application-client.vala"
		_tmp6_ = g_file_get_child (_tmp5_, "src");
#line 815 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 815 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp6_;
#line 815 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp5_);
#line 5079 "application-client.c"
	}
#line 813 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 813 "../src/client/application/application-client.vala"
	return result;
#line 5085 "application-client.c"
}

/**
     * Returns the directory containing the application's plugins.
     *
     * When running from the installation prefix, this will be based
     * on the Meson `libdir` option, and can be set by invoking `meson
     * configure` as appropriate.
     */
GFile*
application_client_get_app_plugins_dir (ApplicationClient* self)
{
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GFile* result;
#line 825 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 826 "../src/client/application/application-client.vala"
	_tmp1_ = application_client_get_is_installed (self);
#line 826 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 826 "../src/client/application/application-client.vala"
	if (_tmp2_) {
#line 5110 "application-client.c"
		GFile* _tmp3_;
#line 827 "../src/client/application/application-client.vala"
		_tmp3_ = g_file_new_for_path (_PLUGINS_DIR);
#line 827 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 827 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp3_;
#line 5118 "application-client.c"
	} else {
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 828 "../src/client/application/application-client.vala"
		_tmp4_ = g_file_new_for_path (APPLICATION_CLIENT_BUILD_ROOT_DIR);
#line 828 "../src/client/application/application-client.vala"
		_tmp5_ = _tmp4_;
#line 828 "../src/client/application/application-client.vala"
		_tmp6_ = g_file_get_child (_tmp5_, "src");
#line 828 "../src/client/application/application-client.vala"
		_tmp7_ = _tmp6_;
#line 828 "../src/client/application/application-client.vala"
		_tmp8_ = g_file_get_child (_tmp7_, "client");
#line 828 "../src/client/application/application-client.vala"
		_tmp9_ = _tmp8_;
#line 828 "../src/client/application/application-client.vala"
		_tmp10_ = g_file_get_child (_tmp9_, "plugin");
#line 828 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp0_);
#line 828 "../src/client/application/application-client.vala"
		_tmp0_ = _tmp10_;
#line 828 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp9_);
#line 828 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp7_);
#line 828 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp5_);
#line 5151 "application-client.c"
	}
#line 826 "../src/client/application/application-client.vala"
	result = _tmp0_;
#line 826 "../src/client/application/application-client.vala"
	return result;
#line 5157 "application-client.c"
}

static void
application_client_show_uri_data_free (gpointer _data)
{
	ApplicationClientShowUriData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_free0 (_data_->uri);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientShowUriData, _data_);
#line 5171 "application-client.c"
}

void
application_client_show_uri (ApplicationClient* self,
                             const gchar* uri,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	ApplicationClientShowUriData* _data_;
	ApplicationClient* _tmp0_;
	gchar* _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (uri != NULL);
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientShowUriData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_show_uri_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	_tmp1_ = g_strdup (uri);
#line 27 "../src/client/application/application-client.vala"
	_g_free0 (_data_->uri);
#line 27 "../src/client/application/application-client.vala"
	_data_->uri = _tmp1_;
#line 27 "../src/client/application/application-client.vala"
	application_client_show_uri_co (_data_);
#line 5205 "application-client.c"
}

void
application_client_show_uri_finish (ApplicationClient* self,
                                    GAsyncResult* _res_)
{
	ApplicationClientShowUriData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5215 "application-client.c"
}

/** Displays a URI on the current active window, if any. */
static void
application_client_show_uri_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	ApplicationClientShowUriData* _data_;
#line 834 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 834 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 834 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 834 "../src/client/application/application-client.vala"
	application_client_show_uri_co (_data_);
#line 5233 "application-client.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 5252 "application-client.c"
}

static gboolean
application_client_show_uri_co (ApplicationClientShowUriData* _data_)
{
#line 833 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 833 "../src/client/application/application-client.vala"
		case 0:
#line 5262 "application-client.c"
		goto _state_0;
#line 833 "../src/client/application/application-client.vala"
		case 1:
#line 5266 "application-client.c"
		goto _state_1;
#line 833 "../src/client/application/application-client.vala"
		case 2:
#line 5270 "application-client.c"
		goto _state_2;
		default:
#line 833 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 5275 "application-client.c"
	}
	_state_0:
#line 834 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 834 "../src/client/application/application-client.vala"
	application_client_create_controller (_data_->self, application_client_show_uri_ready, _data_);
#line 834 "../src/client/application/application-client.vala"
	return FALSE;
#line 5284 "application-client.c"
	_state_1:
#line 834 "../src/client/application/application-client.vala"
	application_client_create_controller_finish (_data_->self, _data_->_res_);
#line 836 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = g_utf8_strdown (_data_->uri, (gssize) -1);
#line 836 "../src/client/application/application-client.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 836 "../src/client/application/application-client.vala"
	_data_->_tmp2_ = g_str_has_prefix (_data_->_tmp1_, APPLICATION_CLIENT_MAILTO_URI_SCHEME_PREFIX);
#line 836 "../src/client/application/application-client.vala"
	_g_free0 (_data_->_tmp1_);
#line 836 "../src/client/application/application-client.vala"
	if (_data_->_tmp2_) {
#line 837 "../src/client/application/application-client.vala"
		_data_->_state_ = 2;
#line 837 "../src/client/application/application-client.vala"
		application_client_new_composer_mailto (_data_->self, _data_->uri, application_client_show_uri_ready, _data_);
#line 837 "../src/client/application/application-client.vala"
		return FALSE;
#line 5304 "application-client.c"
		_state_2:
#line 837 "../src/client/application/application-client.vala"
		application_client_new_composer_mailto_finish (_data_->self, _data_->_res_);
#line 5308 "application-client.c"
	} else {
#line 839 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = g_strdup (_data_->uri);
#line 839 "../src/client/application/application-client.vala"
		_data_->uri_ = _data_->_tmp3_;
#line 841 "../src/client/application/application-client.vala"
		if (!string_contains (_data_->uri, ":")) {
#line 842 "../src/client/application/application-client.vala"
			_data_->_tmp4_ = g_strconcat ("http://", _data_->uri, NULL);
#line 842 "../src/client/application/application-client.vala"
			_g_free0 (_data_->uri_);
#line 842 "../src/client/application/application-client.vala"
			_data_->uri_ = _data_->_tmp4_;
#line 5322 "application-client.c"
		}
		{
#line 846 "../src/client/application/application-client.vala"
			_data_->_tmp5_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, gtk_application_get_type (), GtkApplication));
#line 846 "../src/client/application/application-client.vala"
			_data_->_tmp6_ = _data_->uri_;
#line 846 "../src/client/application/application-client.vala"
			gtk_show_uri_on_window (_data_->_tmp5_, _data_->_tmp6_, (guint32) GDK_CURRENT_TIME, &_data_->_inner_error0_);
#line 846 "../src/client/application/application-client.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 5333 "application-client.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 845 "../src/client/application/application-client.vala"
			_data_->err = _data_->_inner_error0_;
#line 845 "../src/client/application/application-client.vala"
			_data_->_inner_error0_ = NULL;
#line 850 "../src/client/application/application-client.vala"
			_data_->_tmp7_ = _data_->self->priv->_controller;
#line 850 "../src/client/application/application-client.vala"
			_data_->_tmp8_ = _data_->err;
#line 850 "../src/client/application/application-client.vala"
			_data_->_tmp9_ = geary_problem_report_new (_data_->_tmp8_);
#line 850 "../src/client/application/application-client.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 850 "../src/client/application/application-client.vala"
			composer_application_interface_report_problem (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, COMPOSER_TYPE_APPLICATION_INTERFACE, ComposerApplicationInterface), _data_->_tmp10_);
#line 850 "../src/client/application/application-client.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 845 "../src/client/application/application-client.vala"
			_g_error_free0 (_data_->err);
#line 5358 "application-client.c"
		}
		__finally0:
#line 845 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 845 "../src/client/application/application-client.vala"
			_g_free0 (_data_->uri_);
#line 845 "../src/client/application/application-client.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 845 "../src/client/application/application-client.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 845 "../src/client/application/application-client.vala"
			g_object_unref (_data_->_async_result);
#line 845 "../src/client/application/application-client.vala"
			return FALSE;
#line 5373 "application-client.c"
		}
#line 836 "../src/client/application/application-client.vala"
		_g_free0 (_data_->uri_);
#line 5377 "application-client.c"
	}
#line 833 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 833 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 833 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 833 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5387 "application-client.c"
		}
	}
#line 833 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 833 "../src/client/application/application-client.vala"
	return FALSE;
#line 5394 "application-client.c"
}

/**
     * Closes the controller and all open windows, exiting if possible.
     *
     * Any open composers with unsaved or un-savable changes will be
     * prompted about and if cancelled, will cancel shut-down here.
     */
void
application_client_quit (ApplicationClient* self)
{
	gboolean _tmp0_ = FALSE;
	ApplicationController* _tmp1_;
#line 861 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 862 "../src/client/application/application-client.vala"
	_tmp1_ = self->priv->_controller;
#line 862 "../src/client/application/application-client.vala"
	if (_tmp1_ == NULL) {
#line 862 "../src/client/application/application-client.vala"
		_tmp0_ = TRUE;
#line 5416 "application-client.c"
	} else {
		ApplicationController* _tmp2_;
#line 863 "../src/client/application/application-client.vala"
		_tmp2_ = self->priv->_controller;
#line 863 "../src/client/application/application-client.vala"
		_tmp0_ = application_controller_check_open_composers (_tmp2_);
#line 5423 "application-client.c"
	}
#line 862 "../src/client/application/application-client.vala"
	if (_tmp0_) {
#line 864 "../src/client/application/application-client.vala"
		application_client_set_last_active_main_window (self, NULL);
#line 865 "../src/client/application/application-client.vala"
		g_application_quit (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), g_application_get_type (), GApplication));
#line 5431 "application-client.c"
	}
}

/**
     * Returns a set of paths of possible config locations.
     *
     * This is useful only for migrating configuration from
     * non-Flatpak to Flatpak or release-builds to non-release builds.
     */
static void
_vala_array_add3 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 878 "../src/client/application/application-client.vala"
	if ((*length) == (*size)) {
#line 878 "../src/client/application/application-client.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 878 "../src/client/application/application-client.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 5453 "application-client.c"
	}
#line 878 "../src/client/application/application-client.vala"
	(*array)[(*length)++] = value;
#line 878 "../src/client/application/application-client.vala"
	(*array)[*length] = NULL;
#line 5459 "application-client.c"
}

static void
_vala_array_add4 (GFile** * array,
                  gint* length,
                  gint* size,
                  GFile* value)
{
#line 883 "../src/client/application/application-client.vala"
	if ((*length) == (*size)) {
#line 883 "../src/client/application/application-client.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 883 "../src/client/application/application-client.vala"
		*array = g_renew (GFile*, *array, (*size) + 1);
#line 5474 "application-client.c"
	}
#line 883 "../src/client/application/application-client.vala"
	(*array)[(*length)++] = value;
#line 883 "../src/client/application/application-client.vala"
	(*array)[*length] = NULL;
#line 5480 "application-client.c"
}

GFile**
application_client_get_config_search_path (ApplicationClient* self,
                                           gint* result_length1)
{
	GFile** paths = NULL;
	GFile** _tmp0_;
	gint paths_length1;
	gint _paths_size_;
	GFile* home = NULL;
	const gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFile** _tmp15_;
	gint _tmp15__length1;
	GFile** result;
#line 875 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 876 "../src/client/application/application-client.vala"
	_tmp0_ = g_new0 (GFile*, 0 + 1);
#line 876 "../src/client/application/application-client.vala"
	paths = _tmp0_;
#line 876 "../src/client/application/application-client.vala"
	paths_length1 = 0;
#line 876 "../src/client/application/application-client.vala"
	_paths_size_ = paths_length1;
#line 877 "../src/client/application/application-client.vala"
	_tmp1_ = g_get_home_dir ();
#line 877 "../src/client/application/application-client.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 877 "../src/client/application/application-client.vala"
	home = _tmp2_;
#line 878 "../src/client/application/application-client.vala"
	_tmp3_ = g_file_get_child (home, ".config");
#line 878 "../src/client/application/application-client.vala"
	_tmp4_ = _tmp3_;
#line 878 "../src/client/application/application-client.vala"
	_tmp5_ = g_file_get_child (_tmp4_, "geary");
#line 878 "../src/client/application/application-client.vala"
	_vala_array_add3 (&paths, &paths_length1, &_paths_size_, _tmp5_);
#line 878 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp4_);
#line 883 "../src/client/application/application-client.vala"
	_tmp6_ = g_file_get_child (home, ".var");
#line 883 "../src/client/application/application-client.vala"
	_tmp7_ = _tmp6_;
#line 883 "../src/client/application/application-client.vala"
	_tmp8_ = g_file_get_child (_tmp7_, "app");
#line 883 "../src/client/application/application-client.vala"
	_tmp9_ = _tmp8_;
#line 883 "../src/client/application/application-client.vala"
	_tmp10_ = g_file_get_child (_tmp9_, "org.gnome.Geary");
#line 883 "../src/client/application/application-client.vala"
	_tmp11_ = _tmp10_;
#line 883 "../src/client/application/application-client.vala"
	_tmp12_ = g_file_get_child (_tmp11_, "config");
#line 883 "../src/client/application/application-client.vala"
	_tmp13_ = _tmp12_;
#line 883 "../src/client/application/application-client.vala"
	_tmp14_ = g_file_get_child (_tmp13_, "geary");
#line 883 "../src/client/application/application-client.vala"
	_vala_array_add4 (&paths, &paths_length1, &_paths_size_, _tmp14_);
#line 883 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp13_);
#line 883 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp11_);
#line 883 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp9_);
#line 883 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp7_);
#line 894 "../src/client/application/application-client.vala"
	_tmp15_ = paths;
#line 894 "../src/client/application/application-client.vala"
	_tmp15__length1 = paths_length1;
#line 894 "../src/client/application/application-client.vala"
	if (result_length1) {
#line 894 "../src/client/application/application-client.vala"
		*result_length1 = _tmp15__length1;
#line 5571 "application-client.c"
	}
#line 894 "../src/client/application/application-client.vala"
	result = _tmp15_;
#line 894 "../src/client/application/application-client.vala"
	_g_object_unref0 (home);
#line 894 "../src/client/application/application-client.vala"
	return result;
#line 5579 "application-client.c"
}

/**
     * Displays an error notification.
     *
     * Use _very_ sparingly.
     */
void
application_client_send_error_notification (ApplicationClient* self,
                                            const gchar* summary,
                                            const gchar* body)
{
	GNotification* _tmp0_;
	GNotification* _error_ = NULL;
	GNotification* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GThemedIcon* _tmp4_;
	GThemedIcon* _tmp5_;
	GNotification* _tmp6_;
#line 902 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 902 "../src/client/application/application-client.vala"
	g_return_if_fail (summary != NULL);
#line 902 "../src/client/application/application-client.vala"
	g_return_if_fail (body != NULL);
#line 903 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->error_notification;
#line 903 "../src/client/application/application-client.vala"
	if (_tmp0_ != NULL) {
#line 904 "../src/client/application/application-client.vala"
		application_client_clear_error_notification (self);
#line 5612 "application-client.c"
	}
#line 907 "../src/client/application/application-client.vala"
	_tmp1_ = g_notification_new (summary);
#line 907 "../src/client/application/application-client.vala"
	_error_ = _tmp1_;
#line 908 "../src/client/application/application-client.vala"
	g_notification_set_body (_error_, body);
#line 909 "../src/client/application/application-client.vala"
	_tmp2_ = g_strdup_printf ("%s-symbolic", APPLICATION_CLIENT_APP_ID);
#line 909 "../src/client/application/application-client.vala"
	_tmp3_ = _tmp2_;
#line 909 "../src/client/application/application-client.vala"
	_tmp4_ = (GThemedIcon*) g_themed_icon_new (_tmp3_);
#line 909 "../src/client/application/application-client.vala"
	_tmp5_ = _tmp4_;
#line 909 "../src/client/application/application-client.vala"
	g_notification_set_icon (_error_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, g_icon_get_type (), GIcon));
#line 909 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp5_);
#line 909 "../src/client/application/application-client.vala"
	_g_free0 (_tmp3_);
#line 912 "../src/client/application/application-client.vala"
	g_application_send_notification (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication), APPLICATION_CLIENT_ERROR_NOTIFICATION_ID, _error_);
#line 913 "../src/client/application/application-client.vala"
	_tmp6_ = _g_object_ref0 (_error_);
#line 913 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 913 "../src/client/application/application-client.vala"
	self->priv->error_notification = _tmp6_;
#line 902 "../src/client/application/application-client.vala"
	_g_object_unref0 (_error_);
#line 5644 "application-client.c"
}

void
application_client_clear_error_notification (ApplicationClient* self)
{
#line 916 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 917 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 917 "../src/client/application/application-client.vala"
	self->priv->error_notification = NULL;
#line 918 "../src/client/application/application-client.vala"
	g_application_withdraw_notification (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication), APPLICATION_CLIENT_ERROR_NOTIFICATION_ID);
#line 5658 "application-client.c"
}

static void
application_client_present_data_free (gpointer _data)
{
	ApplicationClientPresentData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->result);
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientPresentData, _data_);
#line 5672 "application-client.c"
}

static void
application_client_present (ApplicationClient* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	ApplicationClientPresentData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientPresentData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_present_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_present_co (_data_);
#line 5696 "application-client.c"
}

static ApplicationMainWindow*
application_client_present_finish (ApplicationClient* self,
                                   GAsyncResult* _res_)
{
	ApplicationMainWindow* result;
	ApplicationClientPresentData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 27 "../src/client/application/application-client.vala"
	result = _data_->result;
#line 27 "../src/client/application/application-client.vala"
	_data_->result = NULL;
#line 27 "../src/client/application/application-client.vala"
	return result;
#line 5713 "application-client.c"
}

static void
application_client_present_ready (GObject* source_object,
                                  GAsyncResult* _res_,
                                  gpointer _user_data_)
{
	ApplicationClientPresentData* _data_;
#line 924 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 924 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 924 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 924 "../src/client/application/application-client.vala"
	application_client_present_co (_data_);
#line 5730 "application-client.c"
}

static gboolean
application_client_present_co (ApplicationClientPresentData* _data_)
{
#line 923 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 923 "../src/client/application/application-client.vala"
		case 0:
#line 5740 "application-client.c"
		goto _state_0;
#line 923 "../src/client/application/application-client.vala"
		case 1:
#line 5744 "application-client.c"
		goto _state_1;
		default:
#line 923 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 5749 "application-client.c"
	}
	_state_0:
#line 924 "../src/client/application/application-client.vala"
	_data_->_state_ = 1;
#line 924 "../src/client/application/application-client.vala"
	application_client_create_controller (_data_->self, application_client_present_ready, _data_);
#line 924 "../src/client/application/application-client.vala"
	return FALSE;
#line 5758 "application-client.c"
	_state_1:
#line 924 "../src/client/application/application-client.vala"
	application_client_create_controller_finish (_data_->self, _data_->_res_);
#line 925 "../src/client/application/application-client.vala"
	_data_->_tmp0_ = application_client_get_active_main_window (_data_->self);
#line 925 "../src/client/application/application-client.vala"
	_data_->main = _data_->_tmp0_;
#line 926 "../src/client/application/application-client.vala"
	gtk_window_present (G_TYPE_CHECK_INSTANCE_CAST (_data_->main, gtk_window_get_type (), GtkWindow));
#line 927 "../src/client/application/application-client.vala"
	_data_->result = _data_->main;
#line 927 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 927 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 927 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 927 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5778 "application-client.c"
		}
	}
#line 927 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 927 "../src/client/application/application-client.vala"
	return FALSE;
#line 5785 "application-client.c"
}

static gboolean
_application_client_on_main_window_focus_in_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                                       GdkEventFocus* event,
                                                                       gpointer self)
{
	gboolean result;
	result = application_client_on_main_window_focus_in ((ApplicationClient*) self, _sender, event);
#line 933 "../src/client/application/application-client.vala"
	return result;
#line 5797 "application-client.c"
}

static void
_application_client_on_folders_first_available_geary_account_folders_available_unavailable (GearyAccount* _sender,
                                                                                            GeeBidirSortedSet* available,
                                                                                            GeeBidirSortedSet* unavailable,
                                                                                            gpointer self)
{
#line 944 "../src/client/application/application-client.vala"
	application_client_on_folders_first_available ((ApplicationClient*) self, _sender, available, unavailable);
#line 5808 "application-client.c"
}

static ApplicationMainWindow*
application_client_new_main_window (ApplicationClient* self,
                                    gboolean select_first_inbox)
{
	ApplicationMainWindow* window = NULL;
	ApplicationMainWindow* _tmp0_;
	ApplicationController* _tmp1_;
	ApplicationMainWindow* _tmp2_;
	ApplicationMainWindow* _tmp3_;
	GError* _inner_error0_ = NULL;
	ApplicationMainWindow* result;
#line 930 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 931 "../src/client/application/application-client.vala"
	_tmp0_ = application_main_window_new (self);
#line 931 "../src/client/application/application-client.vala"
	g_object_ref_sink (_tmp0_);
#line 931 "../src/client/application/application-client.vala"
	window = _tmp0_;
#line 932 "../src/client/application/application-client.vala"
	_tmp1_ = self->priv->_controller;
#line 932 "../src/client/application/application-client.vala"
	_tmp2_ = window;
#line 932 "../src/client/application/application-client.vala"
	application_controller_register_window (_tmp1_, _tmp2_);
#line 933 "../src/client/application/application-client.vala"
	_tmp3_ = window;
#line 933 "../src/client/application/application-client.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), "focus-in-event", (GCallback) _application_client_on_main_window_focus_in_gtk_widget_focus_in_event, self, 0);
#line 934 "../src/client/application/application-client.vala"
	if (select_first_inbox) {
#line 5842 "application-client.c"
		ApplicationMainWindow* _tmp4_;
#line 935 "../src/client/application/application-client.vala"
		_tmp4_ = window;
#line 935 "../src/client/application/application-client.vala"
		if (!application_main_window_select_first_inbox (_tmp4_, TRUE)) {
#line 5848 "application-client.c"
			{
				GeeCollection* _tmp5_ = NULL;
				GearyEngine* _tmp6_;
				GeeCollection* _tmp7_;
				GearyAccount* first = NULL;
				gpointer _tmp8_;
				GearyAccount* _tmp9_;
#line 941 "../src/client/application/application-client.vala"
				_tmp6_ = self->priv->_engine;
#line 941 "../src/client/application/application-client.vala"
				_tmp7_ = geary_engine_get_accounts (_tmp6_, &_inner_error0_);
#line 941 "../src/client/application/application-client.vala"
				_tmp5_ = _tmp7_;
#line 941 "../src/client/application/application-client.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5864 "application-client.c"
					goto __catch0_g_error;
				}
#line 940 "../src/client/application/application-client.vala"
				_tmp8_ = geary_collection_first (GEARY_TYPE_ACCOUNT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp5_);
#line 940 "../src/client/application/application-client.vala"
				first = (GearyAccount*) _tmp8_;
#line 943 "../src/client/application/application-client.vala"
				_tmp9_ = first;
#line 943 "../src/client/application/application-client.vala"
				if (_tmp9_ != NULL) {
#line 5875 "application-client.c"
					GearyAccount* _tmp10_;
#line 944 "../src/client/application/application-client.vala"
					_tmp10_ = first;
#line 944 "../src/client/application/application-client.vala"
					g_signal_connect_object (_tmp10_, "folders-available-unavailable", (GCallback) _application_client_on_folders_first_available_geary_account_folders_available_unavailable, self, G_CONNECT_AFTER);
#line 5881 "application-client.c"
				}
#line 939 "../src/client/application/application-client.vala"
				_g_object_unref0 (first);
#line 939 "../src/client/application/application-client.vala"
				_g_object_unref0 (_tmp5_);
#line 5887 "application-client.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 939 "../src/client/application/application-client.vala"
				g_clear_error (&_inner_error0_);
#line 949 "../src/client/application/application-client.vala"
				g_debug ("application-client.vala:949: Error getting Inbox for first account");
#line 5896 "application-client.c"
			}
			__finally0:
#line 939 "../src/client/application/application-client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 939 "../src/client/application/application-client.vala"
				_g_object_unref0 (window);
#line 939 "../src/client/application/application-client.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 939 "../src/client/application/application-client.vala"
				g_clear_error (&_inner_error0_);
#line 939 "../src/client/application/application-client.vala"
				return NULL;
#line 5909 "application-client.c"
			}
		}
	}
#line 953 "../src/client/application/application-client.vala"
	result = window;
#line 953 "../src/client/application/application-client.vala"
	return result;
#line 5917 "application-client.c"
}

static void
application_client_create_controller_data_free (gpointer _data)
{
	ApplicationClientCreateControllerData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientCreateControllerData, _data_);
#line 5929 "application-client.c"
}

static void
application_client_create_controller (ApplicationClient* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	ApplicationClientCreateControllerData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientCreateControllerData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_create_controller_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_create_controller_co (_data_);
#line 5953 "application-client.c"
}

static void
application_client_create_controller_finish (ApplicationClient* self,
                                             GAsyncResult* _res_)
{
	ApplicationClientCreateControllerData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5963 "application-client.c"
}

static void
application_client_create_controller_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	ApplicationClientCreateControllerData* _data_;
#line 962 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 962 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 962 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 962 "../src/client/application/application-client.vala"
	application_client_create_controller_co (_data_);
#line 5980 "application-client.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 5989 "application-client.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 5997 "application-client.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 6006 "application-client.c"
	}
}

static gboolean
application_client_create_controller_co (ApplicationClientCreateControllerData* _data_)
{
#line 957 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 957 "../src/client/application/application-client.vala"
		case 0:
#line 6017 "application-client.c"
		goto _state_0;
#line 957 "../src/client/application/application-client.vala"
		case 1:
#line 6021 "application-client.c"
		goto _state_1;
#line 957 "../src/client/application/application-client.vala"
		case 2:
#line 6025 "application-client.c"
		goto _state_2;
#line 957 "../src/client/application/application-client.vala"
		case 3:
#line 6029 "application-client.c"
		goto _state_3;
		default:
#line 957 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 6034 "application-client.c"
	}
	_state_0:
#line 958 "../src/client/application/application-client.vala"
	_data_->first_run = FALSE;
#line 959 "../src/client/application/application-client.vala"
	_data_->open_failed = FALSE;
#line 960 "../src/client/application/application-client.vala"
	_data_->mutex_token = GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN;
#line 6043 "application-client.c"
	{
#line 962 "../src/client/application/application-client.vala"
		_data_->_tmp1_ = _data_->self->priv->controller_mutex;
#line 962 "../src/client/application/application-client.vala"
		_data_->_state_ = 1;
#line 962 "../src/client/application/application-client.vala"
		geary_nonblocking_mutex_claim_async (_data_->_tmp1_, NULL, application_client_create_controller_ready, _data_);
#line 962 "../src/client/application/application-client.vala"
		return FALSE;
#line 6053 "application-client.c"
		_state_1:
#line 962 "../src/client/application/application-client.vala"
		_data_->_tmp0_ = geary_nonblocking_mutex_claim_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 962 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6059 "application-client.c"
			goto __catch0_g_error;
		}
#line 962 "../src/client/application/application-client.vala"
		_data_->mutex_token = _data_->_tmp0_;
#line 963 "../src/client/application/application-client.vala"
		_data_->_tmp2_ = _data_->self->priv->_controller;
#line 963 "../src/client/application/application-client.vala"
		if (_data_->_tmp2_ == NULL) {
#line 968 "../src/client/application/application-client.vala"
			if (g_strcmp0 (_REVNO, "") != 0) {
#line 968 "../src/client/application/application-client.vala"
				_data_->_tmp4_ = g_strdup_printf (" (%s)", _REVNO);
#line 968 "../src/client/application/application-client.vala"
				_g_free0 (_data_->_tmp3_);
#line 968 "../src/client/application/application-client.vala"
				_data_->_tmp3_ = _data_->_tmp4_;
#line 6076 "application-client.c"
			} else {
#line 968 "../src/client/application/application-client.vala"
				_data_->_tmp5_ = g_strdup ("");
#line 968 "../src/client/application/application-client.vala"
				_g_free0 (_data_->_tmp3_);
#line 968 "../src/client/application/application-client.vala"
				_data_->_tmp3_ = _data_->_tmp5_;
#line 6084 "application-client.c"
			}
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp6_ = _data_->self->priv->exec_dir;
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp7_ = g_file_get_path (_data_->_tmp6_);
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp9_ = application_client_get_is_installed (_data_->self);
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp10_ = _data_->_tmp9_;
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp11_ = bool_to_string (_data_->_tmp10_);
#line 964 "../src/client/application/application-client.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 964 "../src/client/application/application-client.vala"
			g_message ("application-client.vala:964: %s %s%s prefix=%s exec_dir=%s is_installe" \
"d=%s", APPLICATION_CLIENT_NAME, APPLICATION_CLIENT_VERSION, _data_->_tmp3_, APPLICATION_CLIENT_INSTALL_PREFIX, _data_->_tmp8_, _data_->_tmp12_);
#line 964 "../src/client/application/application-client.vala"
			_g_free0 (_data_->_tmp12_);
#line 964 "../src/client/application/application-client.vala"
			_g_free0 (_data_->_tmp8_);
#line 974 "../src/client/application/application-client.vala"
			_data_->_tmp14_ = _data_->self->priv->controller_cancellable;
#line 974 "../src/client/application/application-client.vala"
			_data_->_state_ = 2;
#line 974 "../src/client/application/application-client.vala"
			application_controller_new (_data_->self, _data_->_tmp14_, application_client_create_controller_ready, _data_);
#line 974 "../src/client/application/application-client.vala"
			return FALSE;
#line 6114 "application-client.c"
			_state_2:
#line 974 "../src/client/application/application-client.vala"
			_data_->_tmp15_ = application_controller_new_finish (_data_->_res_, &_data_->_inner_error0_);
#line 974 "../src/client/application/application-client.vala"
			_data_->_tmp13_ = _data_->_tmp15_;
#line 974 "../src/client/application/application-client.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 974 "../src/client/application/application-client.vala"
				_g_free0 (_data_->_tmp3_);
#line 6124 "application-client.c"
				goto __catch0_g_error;
			}
#line 974 "../src/client/application/application-client.vala"
			application_client_set_controller (_data_->self, _data_->_tmp13_);
#line 977 "../src/client/application/application-client.vala"
			_data_->_tmp16_ = _data_->self->priv->_engine;
#line 977 "../src/client/application/application-client.vala"
			_data_->_tmp17_ = geary_engine_get_has_accounts (_data_->_tmp16_);
#line 977 "../src/client/application/application-client.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 977 "../src/client/application/application-client.vala"
			_data_->first_run = !_data_->_tmp18_;
#line 963 "../src/client/application/application-client.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 963 "../src/client/application/application-client.vala"
			_g_free0 (_data_->_tmp3_);
#line 6141 "application-client.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 961 "../src/client/application/application-client.vala"
		_data_->err = _data_->_inner_error0_;
#line 961 "../src/client/application/application-client.vala"
		_data_->_inner_error0_ = NULL;
#line 980 "../src/client/application/application-client.vala"
		_data_->open_failed = TRUE;
#line 981 "../src/client/application/application-client.vala"
		_data_->_tmp19_ = _data_->err;
#line 981 "../src/client/application/application-client.vala"
		_data_->_tmp20_ = _data_->_tmp19_->message;
#line 981 "../src/client/application/application-client.vala"
		g_warning ("application-client.vala:981: Error creating controller: %s", _data_->_tmp20_);
#line 982 "../src/client/application/application-client.vala"
		_data_->_tmp21_ = _data_->err;
#line 982 "../src/client/application/application-client.vala"
		_data_->_tmp22_ = geary_problem_report_new (_data_->_tmp21_);
#line 982 "../src/client/application/application-client.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 982 "../src/client/application/application-client.vala"
		_data_->_tmp24_ = dialogs_problem_details_dialog_new (NULL, _data_->self, _data_->_tmp23_);
#line 982 "../src/client/application/application-client.vala"
		g_object_ref_sink (_data_->_tmp24_);
#line 982 "../src/client/application/application-client.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 982 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->_tmp23_);
#line 982 "../src/client/application/application-client.vala"
		_data_->dialog = _data_->_tmp25_;
#line 987 "../src/client/application/application-client.vala"
		_data_->_tmp26_ = _data_->dialog;
#line 987 "../src/client/application/application-client.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp26_, gtk_widget_get_type (), GtkWidget));
#line 961 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data_->dialog);
#line 961 "../src/client/application/application-client.vala"
		_g_error_free0 (_data_->err);
#line 6183 "application-client.c"
	}
	__finally0:
#line 961 "../src/client/application/application-client.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 961 "../src/client/application/application-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 961 "../src/client/application/application-client.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 961 "../src/client/application/application-client.vala"
		g_object_unref (_data_->_async_result);
#line 961 "../src/client/application/application-client.vala"
		return FALSE;
#line 6196 "application-client.c"
	}
#line 990 "../src/client/application/application-client.vala"
	if (_data_->mutex_token != GEARY_NONBLOCKING_MUTEX_INVALID_TOKEN) {
#line 6200 "application-client.c"
		{
#line 992 "../src/client/application/application-client.vala"
			_data_->_tmp27_ = _data_->self->priv->controller_mutex;
#line 992 "../src/client/application/application-client.vala"
			geary_nonblocking_mutex_release (_data_->_tmp27_, &_data_->mutex_token, &_data_->_inner_error0_);
#line 992 "../src/client/application/application-client.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6208 "application-client.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 991 "../src/client/application/application-client.vala"
			_data_->_error_ = _data_->_inner_error0_;
#line 991 "../src/client/application/application-client.vala"
			_data_->_inner_error0_ = NULL;
#line 994 "../src/client/application/application-client.vala"
			_data_->_tmp28_ = _data_->_error_;
#line 994 "../src/client/application/application-client.vala"
			_data_->_tmp29_ = _data_->_tmp28_->message;
#line 994 "../src/client/application/application-client.vala"
			g_warning ("application-client.vala:994: Failed to release controller mutex: %s", _data_->_tmp29_);
#line 991 "../src/client/application/application-client.vala"
			_g_error_free0 (_data_->_error_);
#line 6227 "application-client.c"
		}
		__finally1:
#line 991 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 991 "../src/client/application/application-client.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 991 "../src/client/application/application-client.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 991 "../src/client/application/application-client.vala"
			g_object_unref (_data_->_async_result);
#line 991 "../src/client/application/application-client.vala"
			return FALSE;
#line 6240 "application-client.c"
		}
	}
#line 999 "../src/client/application/application-client.vala"
	if (_data_->open_failed) {
#line 1000 "../src/client/application/application-client.vala"
		application_client_quit (_data_->self);
#line 6247 "application-client.c"
	}
#line 1003 "../src/client/application/application-client.vala"
	if (_data_->first_run) {
#line 1004 "../src/client/application/application-client.vala"
		_data_->_state_ = 3;
#line 1004 "../src/client/application/application-client.vala"
		application_client_show_accounts (_data_->self, application_client_create_controller_ready, _data_);
#line 1004 "../src/client/application/application-client.vala"
		return FALSE;
#line 6257 "application-client.c"
		_state_3:
#line 1004 "../src/client/application/application-client.vala"
		application_client_show_accounts_finish (_data_->self, _data_->_res_);
#line 1005 "../src/client/application/application-client.vala"
		_data_->_tmp30_ = _data_->self->priv->_engine;
#line 1005 "../src/client/application/application-client.vala"
		_data_->_tmp31_ = geary_engine_get_has_accounts (_data_->_tmp30_);
#line 1005 "../src/client/application/application-client.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 1005 "../src/client/application/application-client.vala"
		if (!_data_->_tmp32_) {
#line 1008 "../src/client/application/application-client.vala"
			application_client_quit (_data_->self);
#line 6271 "application-client.c"
		}
	}
#line 957 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 957 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 957 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 957 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6282 "application-client.c"
		}
	}
#line 957 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 957 "../src/client/application/application-client.vala"
	return FALSE;
#line 6289 "application-client.c"
}

static void
application_client_destroy_controller_data_free (gpointer _data)
{
	ApplicationClientDestroyControllerData* _data_;
	_data_ = _data;
#line 27 "../src/client/application/application-client.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/client/application/application-client.vala"
	g_slice_free (ApplicationClientDestroyControllerData, _data_);
#line 6301 "application-client.c"
}

static void
application_client_destroy_controller (ApplicationClient* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ApplicationClientDestroyControllerData* _data_;
	ApplicationClient* _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_slice_new0 (ApplicationClientDestroyControllerData);
#line 27 "../src/client/application/application-client.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 27 "../src/client/application/application-client.vala"
	g_task_set_task_data (_data_->_async_result, _data_, application_client_destroy_controller_data_free);
#line 27 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/client/application/application-client.vala"
	_data_->self = _tmp0_;
#line 27 "../src/client/application/application-client.vala"
	application_client_destroy_controller_co (_data_);
#line 6325 "application-client.c"
}

static void
application_client_destroy_controller_finish (ApplicationClient* self,
                                              GAsyncResult* _res_)
{
	ApplicationClientDestroyControllerData* _data_;
#line 27 "../src/client/application/application-client.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 6335 "application-client.c"
}

static void
application_client_destroy_controller_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ApplicationClientDestroyControllerData* _data_;
#line 1016 "../src/client/application/application-client.vala"
	_data_ = _user_data_;
#line 1016 "../src/client/application/application-client.vala"
	_data_->_source_object_ = source_object;
#line 1016 "../src/client/application/application-client.vala"
	_data_->_res_ = _res_;
#line 1016 "../src/client/application/application-client.vala"
	application_client_destroy_controller_co (_data_);
#line 6352 "application-client.c"
}

static gboolean
application_client_destroy_controller_co (ApplicationClientDestroyControllerData* _data_)
{
#line 1014 "../src/client/application/application-client.vala"
	switch (_data_->_state_) {
#line 1014 "../src/client/application/application-client.vala"
		case 0:
#line 6362 "application-client.c"
		goto _state_0;
#line 1014 "../src/client/application/application-client.vala"
		case 1:
#line 6366 "application-client.c"
		goto _state_1;
#line 1014 "../src/client/application/application-client.vala"
		case 2:
#line 6370 "application-client.c"
		goto _state_2;
		default:
#line 1014 "../src/client/application/application-client.vala"
		g_assert_not_reached ();
#line 6375 "application-client.c"
	}
	_state_0:
	{
#line 1016 "../src/client/application/application-client.vala"
		_data_->_tmp0_ = _data_->self->priv->controller_mutex;
#line 1016 "../src/client/application/application-client.vala"
		_data_->_state_ = 1;
#line 1016 "../src/client/application/application-client.vala"
		geary_nonblocking_mutex_claim_async (_data_->_tmp0_, NULL, application_client_destroy_controller_ready, _data_);
#line 1016 "../src/client/application/application-client.vala"
		return FALSE;
#line 6387 "application-client.c"
		_state_1:
#line 1016 "../src/client/application/application-client.vala"
		_data_->mutex_token = geary_nonblocking_mutex_claim_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 1016 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6393 "application-client.c"
			goto __catch0_g_error;
		}
#line 1017 "../src/client/application/application-client.vala"
		_data_->_tmp1_ = _data_->self->priv->_controller;
#line 1017 "../src/client/application/application-client.vala"
		if (_data_->_tmp1_ != NULL) {
#line 1018 "../src/client/application/application-client.vala"
			_data_->_tmp2_ = _data_->self->priv->_controller;
#line 1018 "../src/client/application/application-client.vala"
			_data_->_state_ = 2;
#line 1018 "../src/client/application/application-client.vala"
			application_controller_close (_data_->_tmp2_, application_client_destroy_controller_ready, _data_);
#line 1018 "../src/client/application/application-client.vala"
			return FALSE;
#line 6408 "application-client.c"
			_state_2:
#line 1018 "../src/client/application/application-client.vala"
			application_controller_close_finish (_data_->_tmp2_, _data_->_res_);
#line 1019 "../src/client/application/application-client.vala"
			application_client_set_controller (_data_->self, NULL);
#line 6414 "application-client.c"
		}
#line 1021 "../src/client/application/application-client.vala"
		_data_->_tmp3_ = _data_->self->priv->controller_mutex;
#line 1021 "../src/client/application/application-client.vala"
		geary_nonblocking_mutex_release (_data_->_tmp3_, &_data_->mutex_token, &_data_->_inner_error0_);
#line 1021 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6422 "application-client.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1015 "../src/client/application/application-client.vala"
		_data_->err = _data_->_inner_error0_;
#line 1015 "../src/client/application/application-client.vala"
		_data_->_inner_error0_ = NULL;
#line 1023 "../src/client/application/application-client.vala"
		_data_->_tmp4_ = _data_->err;
#line 1023 "../src/client/application/application-client.vala"
		_data_->_tmp5_ = _data_->_tmp4_->message;
#line 1023 "../src/client/application/application-client.vala"
		g_warning ("application-client.vala:1023: Error destroying controller: %s", _data_->_tmp5_);
#line 1015 "../src/client/application/application-client.vala"
		_g_error_free0 (_data_->err);
#line 6441 "application-client.c"
	}
	__finally0:
#line 1015 "../src/client/application/application-client.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1015 "../src/client/application/application-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1015 "../src/client/application/application-client.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1015 "../src/client/application/application-client.vala"
		g_object_unref (_data_->_async_result);
#line 1015 "../src/client/application/application-client.vala"
		return FALSE;
#line 6454 "application-client.c"
	}
	{
#line 1027 "../src/client/application/application-client.vala"
		_data_->_tmp6_ = _data_->self->priv->_engine;
#line 1027 "../src/client/application/application-client.vala"
		geary_engine_close (_data_->_tmp6_, &_data_->_inner_error0_);
#line 1027 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 6463 "application-client.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 1026 "../src/client/application/application-client.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 1026 "../src/client/application/application-client.vala"
		_data_->_inner_error0_ = NULL;
#line 1029 "../src/client/application/application-client.vala"
		_data_->_tmp7_ = _data_->_error_;
#line 1029 "../src/client/application/application-client.vala"
		_data_->_tmp8_ = _data_->_tmp7_->message;
#line 1029 "../src/client/application/application-client.vala"
		g_warning ("application-client.vala:1029: Error shutting down the engine: %s", _data_->_tmp8_);
#line 1026 "../src/client/application/application-client.vala"
		_g_error_free0 (_data_->_error_);
#line 6482 "application-client.c"
	}
	__finally1:
#line 1026 "../src/client/application/application-client.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1026 "../src/client/application/application-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1026 "../src/client/application/application-client.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1026 "../src/client/application/application-client.vala"
		g_object_unref (_data_->_async_result);
#line 1026 "../src/client/application/application-client.vala"
		return FALSE;
#line 6495 "application-client.c"
	}
#line 1014 "../src/client/application/application-client.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1014 "../src/client/application/application-client.vala"
	if (_data_->_state_ != 0) {
#line 1014 "../src/client/application/application-client.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1014 "../src/client/application/application-client.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6505 "application-client.c"
		}
	}
#line 1014 "../src/client/application/application-client.vala"
	g_object_unref (_data_->_async_result);
#line 1014 "../src/client/application/application-client.vala"
	return FALSE;
#line 6512 "application-client.c"
}

static gpointer
_g_variant_dict_ref0 (gpointer self)
{
#line 1034 "../src/client/application/application-client.vala"
	return self ? g_variant_dict_ref (self) : NULL;
#line 6520 "application-client.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 1083 "../src/client/application/application-client.vala"
	if (length >= 0) {
#line 6529 "application-client.c"
		gchar** result;
		gssize i;
#line 1083 "../src/client/application/application-client.vala"
		result = g_new0 (gchar*, length + 1);
#line 1083 "../src/client/application/application-client.vala"
		for (i = 0; i < length; i++) {
#line 6536 "application-client.c"
			gchar* _tmp0_;
#line 1083 "../src/client/application/application-client.vala"
			_tmp0_ = g_strdup (self[i]);
#line 1083 "../src/client/application/application-client.vala"
			result[i] = _tmp0_;
#line 6542 "application-client.c"
		}
#line 1083 "../src/client/application/application-client.vala"
		return result;
#line 6546 "application-client.c"
	}
#line 1083 "../src/client/application/application-client.vala"
	return NULL;
#line 6550 "application-client.c"
}

static gint
application_client_handle_general_options (ApplicationClient* self,
                                           GApplicationCommandLine* command_line)
{
	GVariantDict* options = NULL;
	GVariantDict* _tmp0_;
	GVariantDict* _tmp1_;
	GVariantDict* _tmp2_;
	gboolean activated = FALSE;
	GVariantDict* _tmp3_;
	GVariantDict* _tmp4_;
	GVariantDict* _tmp5_;
	GVariantDict* _tmp6_;
	GVariantDict* _tmp7_;
	GVariantDict* _tmp8_;
	GVariantDict* _tmp9_;
	GVariantDict* _tmp10_;
	ApplicationConfiguration* _tmp31_;
	GVariantDict* _tmp32_;
	ApplicationConfiguration* _tmp33_;
	GVariantDict* _tmp34_;
	ApplicationConfiguration* _tmp35_;
	GVariantDict* _tmp36_;
	gint result;
#line 1033 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), 0);
#line 1033 "../src/client/application/application-client.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (command_line, g_application_command_line_get_type ()), 0);
#line 1034 "../src/client/application/application-client.vala"
	_tmp0_ = g_application_command_line_get_options_dict (command_line);
#line 1034 "../src/client/application/application-client.vala"
	_tmp1_ = _g_variant_dict_ref0 (_tmp0_);
#line 1034 "../src/client/application/application-client.vala"
	options = _tmp1_;
#line 1035 "../src/client/application/application-client.vala"
	_tmp2_ = options;
#line 1035 "../src/client/application/application-client.vala"
	if (g_variant_dict_contains (_tmp2_, APPLICATION_CLIENT_OPTION_QUIT)) {
#line 1036 "../src/client/application/application-client.vala"
		application_client_quit (self);
#line 1037 "../src/client/application/application-client.vala"
		result = 0;
#line 1037 "../src/client/application/application-client.vala"
		_g_variant_dict_unref0 (options);
#line 1037 "../src/client/application/application-client.vala"
		return result;
#line 6599 "application-client.c"
	}
#line 1040 "../src/client/application/application-client.vala"
	activated = FALSE;
#line 1043 "../src/client/application/application-client.vala"
	geary_logging_suppress_domain ("GdkPixbuf");
#line 1044 "../src/client/application/application-client.vala"
	geary_logging_suppress_domain ("GLib-Net");
#line 1048 "../src/client/application/application-client.vala"
	_tmp3_ = options;
#line 1048 "../src/client/application/application-client.vala"
	if (!g_variant_dict_contains (_tmp3_, APPLICATION_CLIENT_OPTION_LOG_CONVERSATIONS)) {
#line 1049 "../src/client/application/application-client.vala"
		geary_logging_suppress_domain (GEARY_APP_CONVERSATION_MONITOR_LOGGING_DOMAIN);
#line 6613 "application-client.c"
	}
#line 1053 "../src/client/application/application-client.vala"
	_tmp4_ = options;
#line 1053 "../src/client/application/application-client.vala"
	if (!g_variant_dict_contains (_tmp4_, APPLICATION_CLIENT_OPTION_LOG_DESERIALIZER)) {
#line 1054 "../src/client/application/application-client.vala"
		geary_logging_suppress_domain (GEARY_IMAP_CLIENT_SERVICE_DESERIALISATION_LOGGING_DOMAIN);
#line 6621 "application-client.c"
	}
#line 1058 "../src/client/application/application-client.vala"
	_tmp5_ = options;
#line 1058 "../src/client/application/application-client.vala"
	if (!g_variant_dict_contains (_tmp5_, APPLICATION_CLIENT_OPTION_LOG_IMAP)) {
#line 1059 "../src/client/application/application-client.vala"
		geary_logging_suppress_domain (GEARY_IMAP_CLIENT_SERVICE_PROTOCOL_LOGGING_DOMAIN);
#line 6629 "application-client.c"
	}
#line 1063 "../src/client/application/application-client.vala"
	_tmp6_ = options;
#line 1063 "../src/client/application/application-client.vala"
	if (!g_variant_dict_contains (_tmp6_, APPLICATION_CLIENT_OPTION_LOG_REPLAY_QUEUE)) {
#line 1064 "../src/client/application/application-client.vala"
		geary_logging_suppress_domain (GEARY_IMAP_CLIENT_SERVICE_REPLAY_QUEUE_LOGGING_DOMAIN);
#line 6637 "application-client.c"
	}
#line 1068 "../src/client/application/application-client.vala"
	_tmp7_ = options;
#line 1068 "../src/client/application/application-client.vala"
	if (!g_variant_dict_contains (_tmp7_, APPLICATION_CLIENT_OPTION_LOG_SMTP)) {
#line 1069 "../src/client/application/application-client.vala"
		geary_logging_suppress_domain (GEARY_SMTP_CLIENT_SERVICE_PROTOCOL_LOGGING_DOMAIN);
#line 6645 "application-client.c"
	}
#line 1073 "../src/client/application/application-client.vala"
	_tmp8_ = options;
#line 1073 "../src/client/application/application-client.vala"
	if (g_variant_dict_contains (_tmp8_, APPLICATION_CLIENT_OPTION_LOG_SQL)) {
#line 1074 "../src/client/application/application-client.vala"
		geary_db_context_enable_sql_logging = TRUE;
#line 6653 "application-client.c"
	}
#line 1077 "../src/client/application/application-client.vala"
	_tmp9_ = options;
#line 1077 "../src/client/application/application-client.vala"
	if (g_variant_dict_contains (_tmp9_, APPLICATION_CLIENT_OPTION_NEW_WINDOW)) {
#line 1078 "../src/client/application/application-client.vala"
		g_action_group_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_group_get_type (), GActionGroup), ACTION_APPLICATION_NEW_WINDOW, NULL);
#line 1079 "../src/client/application/application-client.vala"
		activated = TRUE;
#line 6663 "application-client.c"
	}
#line 1082 "../src/client/application/application-client.vala"
	_tmp10_ = options;
#line 1082 "../src/client/application/application-client.vala"
	if (g_variant_dict_contains (_tmp10_, G_OPTION_REMAINING)) {
#line 6669 "application-client.c"
		gchar** args = NULL;
		GVariantDict* _tmp11_;
		const GVariantType* _tmp12_;
		GVariant* _tmp13_;
		GVariant* _tmp14_;
		gsize _tmp15_ = 0;
		const gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		gchar** _tmp18_;
		gint _tmp18__length1;
		gint args_length1;
		gint _args_size_;
		gchar** _tmp19_;
		gint _tmp19__length1;
#line 1083 "../src/client/application/application-client.vala"
		_tmp11_ = options;
#line 1083 "../src/client/application/application-client.vala"
		_tmp12_ = G_VARIANT_TYPE_STRING_ARRAY;
#line 1083 "../src/client/application/application-client.vala"
		_tmp13_ = g_variant_dict_lookup_value (_tmp11_, G_OPTION_REMAINING, _tmp12_);
#line 1083 "../src/client/application/application-client.vala"
		_tmp14_ = _tmp13_;
#line 1083 "../src/client/application/application-client.vala"
		_tmp16_ = g_variant_get_strv (_tmp14_, &_tmp15_);
#line 1083 "../src/client/application/application-client.vala"
		_tmp17_ = (_tmp16_ != NULL) ? _vala_array_dup1 (_tmp16_, _tmp15_) : _tmp16_;
#line 1083 "../src/client/application/application-client.vala"
		_tmp17__length1 = _tmp15_;
#line 1083 "../src/client/application/application-client.vala"
		_tmp16_ = (g_free (_tmp16_), NULL);
#line 1083 "../src/client/application/application-client.vala"
		_tmp18_ = _tmp17_;
#line 1083 "../src/client/application/application-client.vala"
		_tmp18__length1 = _tmp17__length1;
#line 1083 "../src/client/application/application-client.vala"
		_g_variant_unref0 (_tmp14_);
#line 1083 "../src/client/application/application-client.vala"
		args = _tmp18_;
#line 1083 "../src/client/application/application-client.vala"
		args_length1 = _tmp18__length1;
#line 1083 "../src/client/application/application-client.vala"
		_args_size_ = args_length1;
#line 1087 "../src/client/application/application-client.vala"
		_tmp19_ = args;
#line 1087 "../src/client/application/application-client.vala"
		_tmp19__length1 = args_length1;
#line 6717 "application-client.c"
		{
			gchar** arg_collection = NULL;
			gint arg_collection_length1 = 0;
			gint _arg_collection_size_ = 0;
			gint arg_it = 0;
#line 1087 "../src/client/application/application-client.vala"
			arg_collection = _tmp19_;
#line 1087 "../src/client/application/application-client.vala"
			arg_collection_length1 = _tmp19__length1;
#line 1087 "../src/client/application/application-client.vala"
			for (arg_it = 0; arg_it < arg_collection_length1; arg_it = arg_it + 1) {
#line 6729 "application-client.c"
				gchar* _tmp20_;
				gchar* arg = NULL;
#line 1087 "../src/client/application/application-client.vala"
				_tmp20_ = g_strdup (arg_collection[arg_it]);
#line 1087 "../src/client/application/application-client.vala"
				arg = _tmp20_;
#line 6736 "application-client.c"
				{
					const gchar* _tmp21_;
#line 1089 "../src/client/application/application-client.vala"
					_tmp21_ = arg;
#line 1089 "../src/client/application/application-client.vala"
					if (g_strcmp0 (_tmp21_, APPLICATION_CLIENT_MAILTO_URI_SCHEME_PREFIX) == 0) {
#line 1090 "../src/client/application/application-client.vala"
						g_action_group_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_group_get_type (), GActionGroup), ACTION_APPLICATION_COMPOSE, NULL);
#line 1091 "../src/client/application/application-client.vala"
						activated = TRUE;
#line 6747 "application-client.c"
					} else {
						const gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* _tmp24_;
						gboolean _tmp25_;
#line 1092 "../src/client/application/application-client.vala"
						_tmp22_ = arg;
#line 1092 "../src/client/application/application-client.vala"
						_tmp23_ = g_utf8_strdown (_tmp22_, (gssize) -1);
#line 1092 "../src/client/application/application-client.vala"
						_tmp24_ = _tmp23_;
#line 1092 "../src/client/application/application-client.vala"
						_tmp25_ = g_str_has_prefix (_tmp24_, APPLICATION_CLIENT_MAILTO_URI_SCHEME_PREFIX);
#line 1092 "../src/client/application/application-client.vala"
						_g_free0 (_tmp24_);
#line 1092 "../src/client/application/application-client.vala"
						if (_tmp25_) {
#line 6765 "application-client.c"
							const gchar* _tmp26_;
							GVariant* _tmp27_;
							GVariant* _tmp28_;
#line 1093 "../src/client/application/application-client.vala"
							_tmp26_ = arg;
#line 1093 "../src/client/application/application-client.vala"
							_tmp27_ = g_variant_new_string (_tmp26_);
#line 1093 "../src/client/application/application-client.vala"
							g_variant_ref_sink (_tmp27_);
#line 1093 "../src/client/application/application-client.vala"
							_tmp28_ = _tmp27_;
#line 1093 "../src/client/application/application-client.vala"
							g_action_group_activate_action (G_TYPE_CHECK_INSTANCE_CAST (self, g_action_group_get_type (), GActionGroup), ACTION_APPLICATION_MAILTO, _tmp28_);
#line 1093 "../src/client/application/application-client.vala"
							_g_variant_unref0 (_tmp28_);
#line 1094 "../src/client/application/application-client.vala"
							activated = TRUE;
#line 6783 "application-client.c"
						} else {
							const gchar* _tmp29_;
							const gchar* _tmp30_;
#line 1096 "../src/client/application/application-client.vala"
							_tmp29_ = self->priv->binary;
#line 1096 "../src/client/application/application-client.vala"
							g_application_command_line_printerr (command_line, "%s: ", _tmp29_);
#line 1097 "../src/client/application/application-client.vala"
							_tmp30_ = arg;
#line 1097 "../src/client/application/application-client.vala"
							g_application_command_line_printerr (command_line, _ ("Unrecognised program argument: “%s”"), _tmp30_);
#line 1102 "../src/client/application/application-client.vala"
							g_application_command_line_printerr (command_line, "\n");
#line 1103 "../src/client/application/application-client.vala"
							result = 1;
#line 1103 "../src/client/application/application-client.vala"
							_g_free0 (arg);
#line 1103 "../src/client/application/application-client.vala"
							args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 1103 "../src/client/application/application-client.vala"
							_g_variant_dict_unref0 (options);
#line 1103 "../src/client/application/application-client.vala"
							return result;
#line 6807 "application-client.c"
						}
					}
#line 1087 "../src/client/application/application-client.vala"
					_g_free0 (arg);
#line 6812 "application-client.c"
				}
			}
		}
#line 1082 "../src/client/application/application-client.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 6818 "application-client.c"
	}
#line 1108 "../src/client/application/application-client.vala"
	_tmp31_ = self->priv->_config;
#line 1108 "../src/client/application/application-client.vala"
	_tmp32_ = options;
#line 1108 "../src/client/application/application-client.vala"
	application_configuration_set_enable_debug (_tmp31_, g_variant_dict_contains (_tmp32_, APPLICATION_CLIENT_OPTION_DEBUG));
#line 1109 "../src/client/application/application-client.vala"
	_tmp33_ = self->priv->_config;
#line 1109 "../src/client/application/application-client.vala"
	_tmp34_ = options;
#line 1109 "../src/client/application/application-client.vala"
	application_configuration_set_enable_inspector (_tmp33_, g_variant_dict_contains (_tmp34_, APPLICATION_CLIENT_OPTION_INSPECTOR));
#line 1110 "../src/client/application/application-client.vala"
	_tmp35_ = self->priv->_config;
#line 1110 "../src/client/application/application-client.vala"
	_tmp36_ = options;
#line 1110 "../src/client/application/application-client.vala"
	application_configuration_set_revoke_certs (_tmp35_, g_variant_dict_contains (_tmp36_, APPLICATION_CLIENT_OPTION_REVOKE_CERTS));
#line 1112 "../src/client/application/application-client.vala"
	if (!activated) {
#line 1113 "../src/client/application/application-client.vala"
		g_application_activate (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication));
#line 6842 "application-client.c"
	}
#line 1116 "../src/client/application/application-client.vala"
	result = -1;
#line 1116 "../src/client/application/application-client.vala"
	_g_variant_dict_unref0 (options);
#line 1116 "../src/client/application/application-client.vala"
	return result;
#line 6850 "application-client.c"
}

static void
application_client_add_app_accelerators (ApplicationClient* self,
                                         const gchar* action,
                                         gchar** accelerators,
                                         gint accelerators_length1,
                                         GVariant* param)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1119 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1119 "../src/client/application/application-client.vala"
	g_return_if_fail (action != NULL);
#line 1122 "../src/client/application/application-client.vala"
	_tmp0_ = g_strconcat ("app.", action, NULL);
#line 1122 "../src/client/application/application-client.vala"
	_tmp1_ = _tmp0_;
#line 1122 "../src/client/application/application-client.vala"
	gtk_application_set_accels_for_action (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication), _tmp1_, accelerators);
#line 1122 "../src/client/application/application-client.vala"
	_g_free0 (_tmp1_);
#line 6874 "application-client.c"
}

static void
application_client_update_single_key_shortcuts (ApplicationClient* self)
{
	ApplicationConfiguration* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1125 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1126 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_config;
#line 1126 "../src/client/application/application-client.vala"
	_tmp1_ = application_configuration_get_single_key_shortcuts (_tmp0_);
#line 1126 "../src/client/application/application-client.vala"
	_tmp2_ = _tmp1_;
#line 1126 "../src/client/application/application-client.vala"
	if (_tmp2_) {
#line 6893 "application-client.c"
		GdkDisplay* _tmp3_;
		GdkScreen* _tmp4_;
		GtkCssProvider* _tmp5_;
#line 1127 "../src/client/application/application-client.vala"
		_tmp3_ = gdk_display_get_default ();
#line 1127 "../src/client/application/application-client.vala"
		_tmp4_ = gdk_display_get_default_screen (_tmp3_);
#line 1127 "../src/client/application/application-client.vala"
		_tmp5_ = self->priv->single_key_shortcuts;
#line 1127 "../src/client/application/application-client.vala"
		gtk_style_context_add_provider_for_screen (_tmp4_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_style_provider_get_type (), GtkStyleProvider), (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 6905 "application-client.c"
	} else {
		GdkDisplay* _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
#line 1133 "../src/client/application/application-client.vala"
		_tmp6_ = gdk_display_get_default ();
#line 1133 "../src/client/application/application-client.vala"
		_tmp7_ = gdk_display_get_default_screen (_tmp6_);
#line 1133 "../src/client/application/application-client.vala"
		_tmp8_ = self->priv->single_key_shortcuts;
#line 1133 "../src/client/application/application-client.vala"
		gtk_style_context_remove_provider_for_screen (_tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_style_provider_get_type (), GtkStyleProvider));
#line 6918 "application-client.c"
	}
}

static void
_application_client_on_css_parse_error_gtk_css_provider_parsing_error (GtkCssProvider* _sender,
                                                                       GtkCssSection* section,
                                                                       GError* _error_,
                                                                       gpointer self)
{
#line 1141 "../src/client/application/application-client.vala"
	application_client_on_css_parse_error ((ApplicationClient*) self, section, _error_);
#line 6930 "application-client.c"
}

static void
application_client_load_css (ApplicationClient* self,
                             GtkCssProvider* provider,
                             const gchar* resource_uri)
{
	GError* _inner_error0_ = NULL;
#line 1140 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1140 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (provider, gtk_css_provider_get_type ()));
#line 1140 "../src/client/application/application-client.vala"
	g_return_if_fail (resource_uri != NULL);
#line 1141 "../src/client/application/application-client.vala"
	g_signal_connect_object (provider, "parsing-error", (GCallback) _application_client_on_css_parse_error_gtk_css_provider_parsing_error, self, 0);
#line 6947 "application-client.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 1143 "../src/client/application/application-client.vala"
		_tmp0_ = g_file_new_for_uri (resource_uri);
#line 1143 "../src/client/application/application-client.vala"
		file = _tmp0_;
#line 1144 "../src/client/application/application-client.vala"
		gtk_css_provider_load_from_file (provider, file, &_inner_error0_);
#line 1144 "../src/client/application/application-client.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1144 "../src/client/application/application-client.vala"
			_g_object_unref0 (file);
#line 6961 "application-client.c"
			goto __catch0_g_error;
		}
#line 1142 "../src/client/application/application-client.vala"
		_g_object_unref0 (file);
#line 6966 "application-client.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 1142 "../src/client/application/application-client.vala"
		_error_ = _inner_error0_;
#line 1142 "../src/client/application/application-client.vala"
		_inner_error0_ = NULL;
#line 1146 "../src/client/application/application-client.vala"
		_tmp1_ = _error_;
#line 1146 "../src/client/application/application-client.vala"
		_tmp2_ = _tmp1_->message;
#line 1146 "../src/client/application/application-client.vala"
		g_warning ("application-client.vala:1146: Could not load CSS: %s", _tmp2_);
#line 1142 "../src/client/application/application-client.vala"
		_g_error_free0 (_error_);
#line 6986 "application-client.c"
	}
	__finally0:
#line 1142 "../src/client/application/application-client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1142 "../src/client/application/application-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1142 "../src/client/application/application-client.vala"
		g_clear_error (&_inner_error0_);
#line 1142 "../src/client/application/application-client.vala"
		return;
#line 6997 "application-client.c"
	}
}

static gchar*
application_client_get_geary_home_dir_name (ApplicationClient* self)
{
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1150 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), NULL);
#line 1160 "../src/client/application/application-client.vala"
	if (g_strcmp0 (_PROFILE, APPLICATION_CLIENT_PROFILE_RELEASE) == 0) {
#line 1160 "../src/client/application/application-client.vala"
		_tmp1_ = TRUE;
#line 7014 "application-client.c"
	} else {
		gboolean _tmp2_;
#line 1160 "../src/client/application/application-client.vala"
		_tmp2_ = self->priv->_is_flatpak_sandboxed;
#line 1160 "../src/client/application/application-client.vala"
		_tmp1_ = _tmp2_;
#line 7021 "application-client.c"
	}
#line 1159 "../src/client/application/application-client.vala"
	if (_tmp1_) {
#line 1161 "../src/client/application/application-client.vala"
		_tmp0_ = "geary";
#line 7027 "application-client.c"
	} else {
#line 1162 "../src/client/application/application-client.vala"
		_tmp0_ = "geary-" _PROFILE;
#line 7031 "application-client.c"
	}
#line 1159 "../src/client/application/application-client.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 1159 "../src/client/application/application-client.vala"
	result = _tmp3_;
#line 1159 "../src/client/application/application-client.vala"
	return result;
#line 7039 "application-client.c"
}

static void
application_client_on_activate_about (ApplicationClient* self)
{
#line 1166 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1167 "../src/client/application/application-client.vala"
	application_client_show_about (self, NULL, NULL);
#line 7049 "application-client.c"
}

static void
application_client_on_activate_accounts (ApplicationClient* self)
{
#line 1170 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1171 "../src/client/application/application-client.vala"
	application_client_show_accounts (self, NULL, NULL);
#line 7059 "application-client.c"
}

static void
application_client_on_activate_compose (ApplicationClient* self)
{
#line 1174 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1175 "../src/client/application/application-client.vala"
	application_client_new_composer (self, NULL, NULL, NULL);
#line 7069 "application-client.c"
}

static void
application_client_on_activate_inspect (ApplicationClient* self)
{
#line 1178 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1179 "../src/client/application/application-client.vala"
	application_client_show_inspector (self, NULL, NULL);
#line 7079 "application-client.c"
}

static void
application_client_on_activate_mailto (ApplicationClient* self,
                                       GSimpleAction* action,
                                       GVariant* param)
{
#line 1182 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1182 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 1183 "../src/client/application/application-client.vala"
	if (param != NULL) {
#line 7093 "application-client.c"
		const gchar* _tmp0_;
#line 1184 "../src/client/application/application-client.vala"
		_tmp0_ = g_variant_get_string (param, NULL);
#line 1184 "../src/client/application/application-client.vala"
		application_client_new_composer_mailto (self, _tmp0_, NULL, NULL);
#line 7099 "application-client.c"
	}
}

static void
application_client_on_activate_new_window (ApplicationClient* self)
{
	GearyFolder* folder = NULL;
	GeeCollection* conversations = NULL;
	ApplicationMainWindow* current = NULL;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationMainWindow* _tmp2_;
	GearyFolder* _tmp13_;
	GeeCollection* _tmp14_;
#line 1188 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1191 "../src/client/application/application-client.vala"
	folder = NULL;
#line 1192 "../src/client/application/application-client.vala"
	conversations = NULL;
#line 1193 "../src/client/application/application-client.vala"
	_tmp0_ = self->priv->_last_active_main_window;
#line 1193 "../src/client/application/application-client.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1193 "../src/client/application/application-client.vala"
	current = _tmp1_;
#line 1194 "../src/client/application/application-client.vala"
	_tmp2_ = current;
#line 1194 "../src/client/application/application-client.vala"
	if (_tmp2_ != NULL) {
#line 7130 "application-client.c"
		ApplicationMainWindow* _tmp3_;
		GearyFolder* _tmp4_;
		GearyFolder* _tmp5_;
		GearyFolder* _tmp6_;
		ApplicationMainWindow* _tmp7_;
		ConversationListView* _tmp8_;
		ConversationListView* _tmp9_;
		GeeSet* _tmp10_;
		GeeSet* _tmp11_;
		GeeCollection* _tmp12_;
#line 1195 "../src/client/application/application-client.vala"
		_tmp3_ = current;
#line 1195 "../src/client/application/application-client.vala"
		_tmp4_ = application_main_window_get_selected_folder (_tmp3_);
#line 1195 "../src/client/application/application-client.vala"
		_tmp5_ = _tmp4_;
#line 1195 "../src/client/application/application-client.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 1195 "../src/client/application/application-client.vala"
		_g_object_unref0 (folder);
#line 1195 "../src/client/application/application-client.vala"
		folder = _tmp6_;
#line 1196 "../src/client/application/application-client.vala"
		_tmp7_ = current;
#line 1196 "../src/client/application/application-client.vala"
		_tmp8_ = application_main_window_get_conversation_list_view (_tmp7_);
#line 1196 "../src/client/application/application-client.vala"
		_tmp9_ = _tmp8_;
#line 1196 "../src/client/application/application-client.vala"
		_tmp10_ = conversation_list_view_get_selected (_tmp9_);
#line 1196 "../src/client/application/application-client.vala"
		_tmp11_ = _tmp10_;
#line 1196 "../src/client/application/application-client.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1196 "../src/client/application/application-client.vala"
		_g_object_unref0 (conversations);
#line 1196 "../src/client/application/application-client.vala"
		conversations = _tmp12_;
#line 7169 "application-client.c"
	}
#line 1198 "../src/client/application/application-client.vala"
	_tmp13_ = folder;
#line 1198 "../src/client/application/application-client.vala"
	_tmp14_ = conversations;
#line 1198 "../src/client/application/application-client.vala"
	application_client_new_window (self, _tmp13_, _tmp14_, NULL, NULL);
#line 1188 "../src/client/application/application-client.vala"
	_g_object_unref0 (current);
#line 1188 "../src/client/application/application-client.vala"
	_g_object_unref0 (conversations);
#line 1188 "../src/client/application/application-client.vala"
	_g_object_unref0 (folder);
#line 7183 "application-client.c"
}

static void
application_client_on_activate_preferences (ApplicationClient* self)
{
#line 1201 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1202 "../src/client/application/application-client.vala"
	application_client_show_preferences (self, NULL, NULL);
#line 7193 "application-client.c"
}

static void
application_client_on_activate_quit (ApplicationClient* self)
{
#line 1205 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1206 "../src/client/application/application-client.vala"
	application_client_quit (self);
#line 7203 "application-client.c"
}

static void
application_client_on_activate_show_email (ApplicationClient* self,
                                           GSimpleAction* action,
                                           GVariant* target)
{
#line 1209 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1209 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 1211 "../src/client/application/application-client.vala"
	application_client_show_email (self, target, NULL, NULL);
#line 7217 "application-client.c"
}

static void
application_client_on_activate_show_folder (ApplicationClient* self,
                                            GSimpleAction* action,
                                            GVariant* target)
{
#line 1214 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1214 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (action, g_simple_action_get_type ()));
#line 1216 "../src/client/application/application-client.vala"
	application_client_show_folder (self, target, NULL, NULL);
#line 7231 "application-client.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 1220 "../src/client/application/application-client.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 1220 "../src/client/application/application-client.vala"
	return _data6_;
#line 7241 "application-client.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 1220 "../src/client/application/application-client.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 7251 "application-client.c"
		ApplicationClient* self;
#line 1220 "../src/client/application/application-client.vala"
		self = _data6_->self;
#line 1220 "../src/client/application/application-client.vala"
		_g_object_unref0 (_data6_->dialog);
#line 1220 "../src/client/application/application-client.vala"
		_g_object_unref0 (self);
#line 1220 "../src/client/application/application-client.vala"
		g_slice_free (Block6Data, _data6_);
#line 7261 "application-client.c"
	}
}

static void
___lambda159_ (Block6Data* _data6_)
{
	ApplicationClient* self;
	GtkDialog* _tmp0_;
#line 1247 "../src/client/application/application-client.vala"
	self = _data6_->self;
#line 1247 "../src/client/application/application-client.vala"
	_tmp0_ = _data6_->dialog;
#line 1247 "../src/client/application/application-client.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 7276 "application-client.c"
}

static void
____lambda159__gtk_dialog_response (GtkDialog* _sender,
                                    gint response_id,
                                    gpointer self)
{
#line 1247 "../src/client/application/application-client.vala"
	___lambda159_ (self);
#line 7286 "application-client.c"
}

static void
application_client_on_activate_help (ApplicationClient* self)
{
	GError* _inner_error0_ = NULL;
#line 1219 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 7295 "application-client.c"
	{
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 1221 "../src/client/application/application-client.vala"
		_tmp0_ = application_client_get_is_installed (self);
#line 1221 "../src/client/application/application-client.vala"
		_tmp1_ = _tmp0_;
#line 1221 "../src/client/application/application-client.vala"
		if (_tmp1_) {
#line 1222 "../src/client/application/application-client.vala"
			application_client_show_uri (self, "help:geary", NULL, NULL);
#line 7307 "application-client.c"
		} else {
			GPid pid = 0;
			GFile* exec_dir = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			gchar** argv = NULL;
			gchar** _tmp4_;
			gint argv_length1;
			gint _argv_size_;
			gchar** _tmp5_;
			gint _tmp5__length1;
			gchar* _tmp6_;
			gchar** _tmp7_;
			gint _tmp7__length1;
			gchar* _tmp8_;
			gchar** _tmp9_;
			gint _tmp9__length1;
			gboolean _tmp10_ = FALSE;
			GFile* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			GPid _tmp15_ = 0;
			gboolean _tmp16_;
			gboolean _tmp17_;
#line 1225 "../src/client/application/application-client.vala"
			_tmp2_ = self->priv->exec_dir;
#line 1225 "../src/client/application/application-client.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1225 "../src/client/application/application-client.vala"
			exec_dir = _tmp3_;
#line 1226 "../src/client/application/application-client.vala"
			_tmp4_ = g_new0 (gchar*, 3 + 1);
#line 1226 "../src/client/application/application-client.vala"
			argv = _tmp4_;
#line 1226 "../src/client/application/application-client.vala"
			argv_length1 = 3;
#line 1226 "../src/client/application/application-client.vala"
			_argv_size_ = argv_length1;
#line 1227 "../src/client/application/application-client.vala"
			_tmp5_ = argv;
#line 1227 "../src/client/application/application-client.vala"
			_tmp5__length1 = argv_length1;
#line 1227 "../src/client/application/application-client.vala"
			_tmp6_ = g_strdup ("yelp");
#line 1227 "../src/client/application/application-client.vala"
			_g_free0 (_tmp5_[0]);
#line 1227 "../src/client/application/application-client.vala"
			_tmp5_[0] = _tmp6_;
#line 1228 "../src/client/application/application-client.vala"
			_tmp7_ = argv;
#line 1228 "../src/client/application/application-client.vala"
			_tmp7__length1 = argv_length1;
#line 1228 "../src/client/application/application-client.vala"
			_tmp8_ = g_strdup (APPLICATION_CLIENT_SOURCE_ROOT_DIR "/help/C/");
#line 1228 "../src/client/application/application-client.vala"
			_g_free0 (_tmp7_[1]);
#line 1228 "../src/client/application/application-client.vala"
			_tmp7_[1] = _tmp8_;
#line 1229 "../src/client/application/application-client.vala"
			_tmp9_ = argv;
#line 1229 "../src/client/application/application-client.vala"
			_tmp9__length1 = argv_length1;
#line 1229 "../src/client/application/application-client.vala"
			_g_free0 (_tmp9_[2]);
#line 1229 "../src/client/application/application-client.vala"
			_tmp9_[2] = NULL;
#line 1230 "../src/client/application/application-client.vala"
			_tmp11_ = exec_dir;
#line 1230 "../src/client/application/application-client.vala"
			_tmp12_ = g_file_get_path (_tmp11_);
#line 1230 "../src/client/application/application-client.vala"
			_tmp13_ = _tmp12_;
#line 1230 "../src/client/application/application-client.vala"
			_tmp14_ = argv;
#line 1230 "../src/client/application/application-client.vala"
			_tmp14__length1 = argv_length1;
#line 1230 "../src/client/application/application-client.vala"
			_tmp16_ = g_spawn_async (_tmp13_, _tmp14_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_STDERR_TO_DEV_NULL, NULL, NULL, &_tmp15_, &_inner_error0_);
#line 1230 "../src/client/application/application-client.vala"
			pid = _tmp15_;
#line 1230 "../src/client/application/application-client.vala"
			_tmp17_ = _tmp16_;
#line 1230 "../src/client/application/application-client.vala"
			_g_free0 (_tmp13_);
#line 1230 "../src/client/application/application-client.vala"
			_tmp10_ = _tmp17_;
#line 1230 "../src/client/application/application-client.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1230 "../src/client/application/application-client.vala"
				argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 1230 "../src/client/application/application-client.vala"
				_g_object_unref0 (exec_dir);
#line 7402 "application-client.c"
				goto __catch0_g_error;
			}
#line 1230 "../src/client/application/application-client.vala"
			if (!_tmp10_) {
#line 1237 "../src/client/application/application-client.vala"
				g_debug ("application-client.vala:1237: Failed to launch help locally.");
#line 7409 "application-client.c"
			}
#line 1221 "../src/client/application/application-client.vala"
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 1221 "../src/client/application/application-client.vala"
			_g_object_unref0 (exec_dir);
#line 7415 "application-client.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		Block6Data* _data6_;
		GError* _tmp18_;
		const gchar* _tmp19_;
		GtkWindow* _tmp20_;
		GtkDialog* _tmp21_;
		GtkDialog* _tmp22_;
		GtkDialog* _tmp23_;
		GtkBox* _tmp24_;
		GError* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GtkLabel* _tmp29_;
		GtkLabel* _tmp30_;
		GtkDialog* _tmp31_;
		GtkDialog* _tmp32_;
#line 1220 "../src/client/application/application-client.vala"
		_error_ = _inner_error0_;
#line 1220 "../src/client/application/application-client.vala"
		_inner_error0_ = NULL;
#line 1220 "../src/client/application/application-client.vala"
		_data6_ = g_slice_new0 (Block6Data);
#line 1220 "../src/client/application/application-client.vala"
		_data6_->_ref_count_ = 1;
#line 1220 "../src/client/application/application-client.vala"
		_data6_->self = g_object_ref (self);
#line 1241 "../src/client/application/application-client.vala"
		_tmp18_ = _error_;
#line 1241 "../src/client/application/application-client.vala"
		_tmp19_ = _tmp18_->message;
#line 1241 "../src/client/application/application-client.vala"
		g_debug ("application-client.vala:1241: Error showing help: %s", _tmp19_);
#line 1242 "../src/client/application/application-client.vala"
		_tmp20_ = gtk_application_get_active_window (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 1242 "../src/client/application/application-client.vala"
		_tmp21_ = (GtkDialog*) gtk_dialog_new_with_buttons ("Error", _tmp20_, GTK_DIALOG_DESTROY_WITH_PARENT, STOCK__CLOSE, GTK_RESPONSE_CLOSE, NULL, NULL);
#line 1242 "../src/client/application/application-client.vala"
		g_object_ref_sink (_tmp21_);
#line 1242 "../src/client/application/application-client.vala"
		_data6_->dialog = _tmp21_;
#line 1247 "../src/client/application/application-client.vala"
		_tmp22_ = _data6_->dialog;
#line 1247 "../src/client/application/application-client.vala"
		g_signal_connect_data (_tmp22_, "response", (GCallback) ____lambda159__gtk_dialog_response, block6_data_ref (_data6_), (GClosureNotify) block6_data_unref, 0);
#line 1248 "../src/client/application/application-client.vala"
		_tmp23_ = _data6_->dialog;
#line 1248 "../src/client/application/application-client.vala"
		_tmp24_ = gtk_dialog_get_content_area (_tmp23_);
#line 1248 "../src/client/application/application-client.vala"
		_tmp25_ = _error_;
#line 1248 "../src/client/application/application-client.vala"
		_tmp26_ = _tmp25_->message;
#line 1248 "../src/client/application/application-client.vala"
		_tmp27_ = g_strdup_printf ("Error showing help: %s", _tmp26_);
#line 1248 "../src/client/application/application-client.vala"
		_tmp28_ = _tmp27_;
#line 1248 "../src/client/application/application-client.vala"
		_tmp29_ = (GtkLabel*) gtk_label_new (_tmp28_);
#line 1248 "../src/client/application/application-client.vala"
		g_object_ref_sink (_tmp29_);
#line 1248 "../src/client/application/application-client.vala"
		_tmp30_ = _tmp29_;
#line 1248 "../src/client/application/application-client.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget));
#line 1248 "../src/client/application/application-client.vala"
		_g_object_unref0 (_tmp30_);
#line 1248 "../src/client/application/application-client.vala"
		_g_free0 (_tmp28_);
#line 1251 "../src/client/application/application-client.vala"
		_tmp31_ = _data6_->dialog;
#line 1251 "../src/client/application/application-client.vala"
		gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget));
#line 1252 "../src/client/application/application-client.vala"
		_tmp32_ = _data6_->dialog;
#line 1252 "../src/client/application/application-client.vala"
		gtk_dialog_run (_tmp32_);
#line 1220 "../src/client/application/application-client.vala"
		_g_error_free0 (_error_);
#line 1220 "../src/client/application/application-client.vala"
		block6_data_unref (_data6_);
#line 1220 "../src/client/application/application-client.vala"
		_data6_ = NULL;
#line 7504 "application-client.c"
	}
	__finally0:
#line 1220 "../src/client/application/application-client.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1220 "../src/client/application/application-client.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1220 "../src/client/application/application-client.vala"
		g_clear_error (&_inner_error0_);
#line 1220 "../src/client/application/application-client.vala"
		return;
#line 7515 "application-client.c"
	}
}

static void
application_client_on_folders_first_available (ApplicationClient* self,
                                               GearyAccount* account,
                                               GeeBidirSortedSet* available,
                                               GeeBidirSortedSet* unavailable)
{
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	gboolean _tmp2_;
#line 1256 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1256 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT));
#line 1256 "../src/client/application/application-client.vala"
	g_return_if_fail ((available == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (available, GEE_TYPE_BIDIR_SORTED_SET));
#line 1256 "../src/client/application/application-client.vala"
	g_return_if_fail ((unavailable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (unavailable, GEE_TYPE_BIDIR_SORTED_SET));
#line 1260 "../src/client/application/application-client.vala"
	_tmp0_ = application_client_get_active_main_window (self);
#line 1260 "../src/client/application/application-client.vala"
	_tmp1_ = _tmp0_;
#line 1260 "../src/client/application/application-client.vala"
	_tmp2_ = application_main_window_select_first_inbox (_tmp1_, TRUE);
#line 1260 "../src/client/application/application-client.vala"
	_g_object_unref0 (_tmp1_);
#line 1260 "../src/client/application/application-client.vala"
	if (_tmp2_) {
#line 7546 "application-client.c"
		guint _tmp3_;
#line 1262 "../src/client/application/application-client.vala"
		g_signal_parse_name ("folders-available-unavailable", GEARY_TYPE_ACCOUNT, &_tmp3_, NULL, FALSE);
#line 1262 "../src/client/application/application-client.vala"
		g_signal_handlers_disconnect_matched (account, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _application_client_on_folders_first_available_geary_account_folders_available_unavailable, self);
#line 7552 "application-client.c"
	}
}

static gboolean
application_client_on_main_window_focus_in (ApplicationClient* self,
                                            GtkWidget* widget,
                                            GdkEventFocus* event)
{
	ApplicationMainWindow* main = NULL;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	gboolean result;
#line 1268 "../src/client/application/application-client.vala"
	g_return_val_if_fail (APPLICATION_IS_CLIENT (self), FALSE);
#line 1268 "../src/client/application/application-client.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), FALSE);
#line 1268 "../src/client/application/application-client.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1270 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (widget) ? ((ApplicationMainWindow*) widget) : NULL);
#line 1270 "../src/client/application/application-client.vala"
	main = _tmp0_;
#line 1271 "../src/client/application/application-client.vala"
	_tmp1_ = main;
#line 1271 "../src/client/application/application-client.vala"
	if (_tmp1_ != NULL) {
#line 7579 "application-client.c"
		ApplicationMainWindow* _tmp2_;
#line 1272 "../src/client/application/application-client.vala"
		_tmp2_ = main;
#line 1272 "../src/client/application/application-client.vala"
		application_client_set_last_active_main_window (self, _tmp2_);
#line 7585 "application-client.c"
	}
#line 1274 "../src/client/application/application-client.vala"
	result = GDK_EVENT_PROPAGATE;
#line 1274 "../src/client/application/application-client.vala"
	_g_object_unref0 (main);
#line 1274 "../src/client/application/application-client.vala"
	return result;
#line 7593 "application-client.c"
}

static void
application_client_on_window_removed (ApplicationClient* self,
                                      GtkWindow* window)
{
	ApplicationMainWindow* main = NULL;
	ApplicationMainWindow* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 1277 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1277 "../src/client/application/application-client.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (window, gtk_window_get_type ()));
#line 1278 "../src/client/application/application-client.vala"
	_tmp0_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (window) ? ((ApplicationMainWindow*) window) : NULL);
#line 1278 "../src/client/application/application-client.vala"
	main = _tmp0_;
#line 1279 "../src/client/application/application-client.vala"
	_tmp1_ = main;
#line 1279 "../src/client/application/application-client.vala"
	if (_tmp1_ != NULL) {
#line 7618 "application-client.c"
		ApplicationController* _tmp2_;
		ApplicationMainWindow* _tmp3_;
		ApplicationMainWindow* _tmp4_;
		ApplicationMainWindow* _tmp5_;
#line 1280 "../src/client/application/application-client.vala"
		_tmp2_ = self->priv->_controller;
#line 1280 "../src/client/application/application-client.vala"
		_tmp3_ = main;
#line 1280 "../src/client/application/application-client.vala"
		application_controller_unregister_window (_tmp2_, _tmp3_);
#line 1281 "../src/client/application/application-client.vala"
		_tmp4_ = self->priv->_last_active_main_window;
#line 1281 "../src/client/application/application-client.vala"
		_tmp5_ = main;
#line 1281 "../src/client/application/application-client.vala"
		if (_tmp4_ == _tmp5_) {
#line 7635 "application-client.c"
			GeeCollection* _tmp6_;
			GeeCollection* _tmp7_;
			gpointer _tmp8_;
			ApplicationMainWindow* _tmp9_;
#line 1282 "../src/client/application/application-client.vala"
			_tmp6_ = application_client_get_main_windows (self);
#line 1282 "../src/client/application/application-client.vala"
			_tmp7_ = _tmp6_;
#line 1282 "../src/client/application/application-client.vala"
			_tmp8_ = geary_collection_first (APPLICATION_TYPE_MAIN_WINDOW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp7_);
#line 1282 "../src/client/application/application-client.vala"
			_tmp9_ = (ApplicationMainWindow*) _tmp8_;
#line 1282 "../src/client/application/application-client.vala"
			application_client_set_last_active_main_window (self, _tmp9_);
#line 1282 "../src/client/application/application-client.vala"
			_g_object_unref0 (_tmp9_);
#line 1282 "../src/client/application/application-client.vala"
			_g_object_unref0 (_tmp7_);
#line 7654 "application-client.c"
		}
	}
#line 1291 "../src/client/application/application-client.vala"
	_tmp11_ = application_client_get_is_background_service (self);
#line 1291 "../src/client/application/application-client.vala"
	_tmp12_ = _tmp11_;
#line 1291 "../src/client/application/application-client.vala"
	if (!_tmp12_) {
#line 7663 "application-client.c"
		GList* _tmp13_;
#line 1291 "../src/client/application/application-client.vala"
		_tmp13_ = gtk_application_get_windows (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_get_type (), GtkApplication));
#line 1291 "../src/client/application/application-client.vala"
		_tmp10_ = g_list_length (_tmp13_) == ((guint) 0);
#line 7669 "application-client.c"
	} else {
#line 1291 "../src/client/application/application-client.vala"
		_tmp10_ = FALSE;
#line 7673 "application-client.c"
	}
#line 1291 "../src/client/application/application-client.vala"
	if (_tmp10_) {
#line 1292 "../src/client/application/application-client.vala"
		application_client_quit (self);
#line 7679 "application-client.c"
	}
#line 1277 "../src/client/application/application-client.vala"
	_g_object_unref0 (main);
#line 7683 "application-client.c"
}

static void
application_client_on_single_key_shortcuts_toggled (ApplicationClient* self)
{
#line 1296 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1297 "../src/client/application/application-client.vala"
	application_client_update_single_key_shortcuts (self);
#line 7693 "application-client.c"
}

static void
application_client_on_css_parse_error (ApplicationClient* self,
                                       GtkCssSection* section,
                                       GError* _error_)
{
	guint start = 0U;
	guint end = 0U;
#line 1300 "../src/client/application/application-client.vala"
	g_return_if_fail (APPLICATION_IS_CLIENT (self));
#line 1300 "../src/client/application/application-client.vala"
	g_return_if_fail (section != NULL);
#line 1300 "../src/client/application/application-client.vala"
	g_return_if_fail (_error_ != NULL);
#line 1301 "../src/client/application/application-client.vala"
	start = gtk_css_section_get_start_line (section);
#line 1302 "../src/client/application/application-client.vala"
	end = gtk_css_section_get_end_line (section);
#line 1303 "../src/client/application/application-client.vala"
	if (start == end) {
#line 7715 "application-client.c"
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 1304 "../src/client/application/application-client.vala"
		_tmp0_ = gtk_css_section_get_file (section);
#line 1304 "../src/client/application/application-client.vala"
		_tmp1_ = g_file_get_uri (_tmp0_);
#line 1304 "../src/client/application/application-client.vala"
		_tmp2_ = _tmp1_;
#line 1304 "../src/client/application/application-client.vala"
		_tmp3_ = _error_->message;
#line 1304 "../src/client/application/application-client.vala"
		g_warning ("application-client.vala:1304: Error parsing %s:%u: %s", _tmp2_, start, _tmp3_);
#line 1304 "../src/client/application/application-client.vala"
		_g_free0 (_tmp2_);
#line 7732 "application-client.c"
	} else {
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1309 "../src/client/application/application-client.vala"
		_tmp4_ = gtk_css_section_get_file (section);
#line 1309 "../src/client/application/application-client.vala"
		_tmp5_ = g_file_get_uri (_tmp4_);
#line 1309 "../src/client/application/application-client.vala"
		_tmp6_ = _tmp5_;
#line 1309 "../src/client/application/application-client.vala"
		_tmp7_ = _error_->message;
#line 1309 "../src/client/application/application-client.vala"
		g_warning ("application-client.vala:1309: Error parsing %s:%u-%u: %s", _tmp6_, start, end, _tmp7_);
#line 1309 "../src/client/application/application-client.vala"
		_g_free0 (_tmp6_);
#line 7750 "application-client.c"
	}
}

void
application_client_runtime_detail_copy (const ApplicationClientRuntimeDetail* self,
                                        ApplicationClientRuntimeDetail* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 155 "../src/client/application/application-client.vala"
	_tmp0_ = (*self).name;
#line 155 "../src/client/application/application-client.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 155 "../src/client/application/application-client.vala"
	_g_free0 ((*dest).name);
#line 155 "../src/client/application/application-client.vala"
	(*dest).name = _tmp1_;
#line 155 "../src/client/application/application-client.vala"
	_tmp2_ = (*self).value;
#line 155 "../src/client/application/application-client.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 155 "../src/client/application/application-client.vala"
	_g_free0 ((*dest).value);
#line 155 "../src/client/application/application-client.vala"
	(*dest).value = _tmp3_;
#line 7778 "application-client.c"
}

void
application_client_runtime_detail_destroy (ApplicationClientRuntimeDetail* self)
{
#line 157 "../src/client/application/application-client.vala"
	_g_free0 ((*self).name);
#line 158 "../src/client/application/application-client.vala"
	_g_free0 ((*self).value);
#line 7788 "application-client.c"
}

ApplicationClientRuntimeDetail*
application_client_runtime_detail_dup (const ApplicationClientRuntimeDetail* self)
{
	ApplicationClientRuntimeDetail* dup;
#line 155 "../src/client/application/application-client.vala"
	dup = g_new0 (ApplicationClientRuntimeDetail, 1);
#line 155 "../src/client/application/application-client.vala"
	application_client_runtime_detail_copy (self, dup);
#line 155 "../src/client/application/application-client.vala"
	return dup;
#line 7801 "application-client.c"
}

void
application_client_runtime_detail_free (ApplicationClientRuntimeDetail* self)
{
#line 155 "../src/client/application/application-client.vala"
	application_client_runtime_detail_destroy (self);
#line 155 "../src/client/application/application-client.vala"
	g_free (self);
#line 7811 "application-client.c"
}

static GType
application_client_runtime_detail_get_type_once (void)
{
	GType application_client_runtime_detail_type_id;
	application_client_runtime_detail_type_id = g_boxed_type_register_static ("ApplicationClientRuntimeDetail", (GBoxedCopyFunc) application_client_runtime_detail_dup, (GBoxedFreeFunc) application_client_runtime_detail_free);
	return application_client_runtime_detail_type_id;
}

GType
application_client_runtime_detail_get_type (void)
{
	static volatile gsize application_client_runtime_detail_type_id__once = 0;
	if (g_once_init_enter (&application_client_runtime_detail_type_id__once)) {
		GType application_client_runtime_detail_type_id;
		application_client_runtime_detail_type_id = application_client_runtime_detail_get_type_once ();
		g_once_init_leave (&application_client_runtime_detail_type_id__once, application_client_runtime_detail_type_id);
	}
	return application_client_runtime_detail_type_id__once;
}

static void
application_client_class_init (ApplicationClientClass * klass,
                               gpointer klass_data)
{
#line 27 "../src/client/application/application-client.vala"
	application_client_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/client/application/application-client.vala"
	g_type_class_adjust_private_offset (klass, &ApplicationClient_private_offset);
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->local_command_line = (gboolean (*) (GApplication*, gchar***, gint*)) application_client_real_local_command_line;
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) application_client_real_handle_local_options;
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) application_client_real_startup;
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->command_line = (gint (*) (GApplication*, GApplicationCommandLine*)) application_client_real_command_line;
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->shutdown = (void (*) (GApplication*)) application_client_real_shutdown;
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) application_client_real_activate;
#line 27 "../src/client/application/application-client.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) application_client_real_open;
#line 27 "../src/client/application/application-client.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_client_get_property;
#line 27 "../src/client/application/application-client.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_application_client_set_property;
#line 27 "../src/client/application/application-client.vala"
	G_OBJECT_CLASS (klass)->finalize = application_client_finalize;
#line 7862 "application-client.c"
	/**
	     * The global email subsystem controller for this app instance.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_ENGINE_PROPERTY, application_client_properties[APPLICATION_CLIENT_ENGINE_PROPERTY] = g_param_spec_object ("engine", "engine", "engine", GEARY_TYPE_ENGINE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7868 "application-client.c"
	/**
	     * The user's desktop settings for the application.
	     *
	     * This will be null until {@link startup} has been called, and
	     * hence will only ever become non-null for the primary instance.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_CONFIG_PROPERTY, application_client_properties[APPLICATION_CLIENT_CONFIG_PROPERTY] = g_param_spec_object ("config", "config", "config", APPLICATION_TYPE_CONFIGURATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7877 "application-client.c"
	/**
	     * The last active main window.
	     *
	     * This will be null if no main windows exist, see {@link
	     * get_active_main_window} if you want to be guaranteed an
	     * instance.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_LAST_ACTIVE_MAIN_WINDOW_PROPERTY, application_client_properties[APPLICATION_CLIENT_LAST_ACTIVE_MAIN_WINDOW_PROPERTY] = g_param_spec_object ("last-active-main-window", "last-active-main-window", "last-active-main-window", APPLICATION_TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7887 "application-client.c"
	/**
	     * Manages the autostart desktop file.
	     *
	     * This will be null until {@link startup} has been called, and
	     * hence will only ever become non-null for the primary instance.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_AUTOSTART_PROPERTY, application_client_properties[APPLICATION_CLIENT_AUTOSTART_PROPERTY] = g_param_spec_object ("autostart", "autostart", "autostart", APPLICATION_TYPE_STARTUP_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7896 "application-client.c"
	/**
	     * Determines if Geary configured to run as as a background service.
	     *
	     * If this returns `true`, then the primary application instance
	     * will continue to run in the background after the last window is
	     * closed, instead of exiting as usual.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_IS_BACKGROUND_SERVICE_PROPERTY, application_client_properties[APPLICATION_CLIENT_IS_BACKGROUND_SERVICE_PROPERTY] = g_param_spec_boolean ("is-background-service", "is-background-service", "is-background-service", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7906 "application-client.c"
	/**
	     * Determines if Geary appears to be running under Flatpak.
	     *
	     * If this returns `true`, then the application instance
	     * appears to be running inside a Flatpak sandbox.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_IS_FLATPAK_SANDBOXED_PROPERTY, application_client_properties[APPLICATION_CLIENT_IS_FLATPAK_SANDBOXED_PROPERTY] = g_param_spec_boolean ("is-flatpak-sandboxed", "is-flatpak-sandboxed", "is-flatpak-sandboxed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7915 "application-client.c"
	/**
	     * The global controller for this application instance.
	     *
	     * This will be non-null in the primary application instance, only
	     * after initial activation, or after startup if {@link
	     * is_background_service} is true.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_CONTROLLER_PROPERTY, application_client_properties[APPLICATION_CLIENT_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", APPLICATION_TYPE_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7925 "application-client.c"
	/**
	     * Determines if this instance is running from the install directory.
	     */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_IS_INSTALLED_PROPERTY, application_client_properties[APPLICATION_CLIENT_IS_INSTALLED_PROPERTY] = g_param_spec_boolean ("is-installed", "is-installed", "is-installed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7931 "application-client.c"
	/** Returns the compile-time configured installation directory. */
#line 27 "../src/client/application/application-client.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_CLIENT_INSTALL_PREFIX_PROPERTY, application_client_properties[APPLICATION_CLIENT_INSTALL_PREFIX_PROPERTY] = g_param_spec_object ("install-prefix", "install-prefix", "install-prefix", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7935 "application-client.c"
}

static void
application_client_instance_init (ApplicationClient * self,
                                  gpointer klass)
{
	GFile* _tmp0_;
	GtkCssProvider* _tmp1_;
	GCancellable* _tmp2_;
	GearyNonblockingMutex* _tmp3_;
#line 27 "../src/client/application/application-client.vala"
	self->priv = application_client_get_instance_private (self);
#line 165 "../src/client/application/application-client.vala"
	self->priv->_engine = NULL;
#line 175 "../src/client/application/application-client.vala"
	self->priv->_config = NULL;
#line 186 "../src/client/application/application-client.vala"
	self->priv->_last_active_main_window = NULL;
#line 196 "../src/client/application/application-client.vala"
	self->priv->_autostart = NULL;
#line 228 "../src/client/application/application-client.vala"
	self->priv->_controller = NULL;
#line 242 "../src/client/application/application-client.vala"
	_tmp0_ = g_file_new_for_path (APPLICATION_CLIENT_INSTALL_PREFIX);
#line 242 "../src/client/application/application-client.vala"
	self->priv->_install_prefix = _tmp0_;
#line 249 "../src/client/application/application-client.vala"
	_tmp1_ = gtk_css_provider_new ();
#line 249 "../src/client/application/application-client.vala"
	self->priv->single_key_shortcuts = _tmp1_;
#line 250 "../src/client/application/application-client.vala"
	_tmp2_ = g_cancellable_new ();
#line 250 "../src/client/application/application-client.vala"
	self->priv->controller_cancellable = _tmp2_;
#line 251 "../src/client/application/application-client.vala"
	self->priv->inspector = NULL;
#line 252 "../src/client/application/application-client.vala"
	_tmp3_ = geary_nonblocking_mutex_new ();
#line 252 "../src/client/application/application-client.vala"
	self->priv->controller_mutex = _tmp3_;
#line 253 "../src/client/application/application-client.vala"
	self->priv->error_notification = NULL;
#line 7978 "application-client.c"
}

static void
application_client_finalize (GObject * obj)
{
	ApplicationClient * self;
#line 27 "../src/client/application/application-client.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 165 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->_engine);
#line 175 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->_config);
#line 186 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->_last_active_main_window);
#line 196 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->_autostart);
#line 228 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->_controller);
#line 242 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->_install_prefix);
#line 247 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->exec_dir);
#line 248 "../src/client/application/application-client.vala"
	_g_free0 (self->priv->binary);
#line 249 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->single_key_shortcuts);
#line 250 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->controller_cancellable);
#line 251 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->inspector);
#line 252 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->controller_mutex);
#line 253 "../src/client/application/application-client.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 27 "../src/client/application/application-client.vala"
	G_OBJECT_CLASS (application_client_parent_class)->finalize (obj);
#line 8015 "application-client.c"
}

/**
 * The client application's main point of entry and desktop integration.
 */
static GType
application_client_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationClientClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_client_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ApplicationClient), 0, (GInstanceInitFunc) application_client_instance_init, NULL };
	GType application_client_type_id;
	application_client_type_id = g_type_register_static (gtk_application_get_type (), "ApplicationClient", &g_define_type_info, 0);
	ApplicationClient_private_offset = g_type_add_instance_private (application_client_type_id, sizeof (ApplicationClientPrivate));
	return application_client_type_id;
}

GType
application_client_get_type (void)
{
	static volatile gsize application_client_type_id__once = 0;
	if (g_once_init_enter (&application_client_type_id__once)) {
		GType application_client_type_id;
		application_client_type_id = application_client_get_type_once ();
		g_once_init_leave (&application_client_type_id__once, application_client_type_id);
	}
	return application_client_type_id__once;
}

static void
_vala_application_client_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	ApplicationClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 27 "../src/client/application/application-client.vala"
	switch (property_id) {
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_ENGINE_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_object (value, application_client_get_engine (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_CONFIG_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_object (value, application_client_get_config (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_LAST_ACTIVE_MAIN_WINDOW_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_object (value, application_client_get_last_active_main_window (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_AUTOSTART_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_object (value, application_client_get_autostart (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_IS_BACKGROUND_SERVICE_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_boolean (value, application_client_get_is_background_service (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_IS_FLATPAK_SANDBOXED_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_boolean (value, application_client_get_is_flatpak_sandboxed (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_CONTROLLER_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_object (value, application_client_get_controller (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_IS_INSTALLED_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_boolean (value, application_client_get_is_installed (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_INSTALL_PREFIX_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		g_value_set_object (value, application_client_get_install_prefix (self));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 8107 "application-client.c"
		default:
#line 27 "../src/client/application/application-client.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/client/application/application-client.vala"
		break;
#line 8113 "application-client.c"
	}
}

static void
_vala_application_client_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	ApplicationClient * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, APPLICATION_TYPE_CLIENT, ApplicationClient);
#line 27 "../src/client/application/application-client.vala"
	switch (property_id) {
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_ENGINE_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_engine (self, g_value_get_object (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_CONFIG_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_config (self, g_value_get_object (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_LAST_ACTIVE_MAIN_WINDOW_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_last_active_main_window (self, g_value_get_object (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_AUTOSTART_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_autostart (self, g_value_get_object (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_IS_FLATPAK_SANDBOXED_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_is_flatpak_sandboxed (self, g_value_get_boolean (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_CONTROLLER_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_controller (self, g_value_get_object (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 27 "../src/client/application/application-client.vala"
		case APPLICATION_CLIENT_INSTALL_PREFIX_PROPERTY:
#line 27 "../src/client/application/application-client.vala"
		application_client_set_install_prefix (self, g_value_get_object (value));
#line 27 "../src/client/application/application-client.vala"
		break;
#line 8169 "application-client.c"
		default:
#line 27 "../src/client/application/application-client.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/client/application/application-client.vala"
		break;
#line 8175 "application-client.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

